/* Content.c generated by valac 0.56.14, the Vala compiler
 * generated from Content.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	HE_CONTENT_SCHEME_0_PROPERTY,
	HE_CONTENT_SCHEME_NUM_PROPERTIES
};
static GParamSpec* he_content_scheme_properties[HE_CONTENT_SCHEME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer he_content_scheme_parent_class = NULL;
static HeSchemeFactoryIface * he_content_scheme_he_scheme_factory_parent_iface = NULL;

static void he_content_scheme_real_generate (HeSchemeFactory* base,
                                      HeColorCAM16Color* accent,
                                      gboolean is_dark,
                                      gboolean is_contrast,
                                      HeScheme* result);
static GType he_content_scheme_get_type_once (void);

static void
he_content_scheme_real_generate (HeSchemeFactory* base,
                                 HeColorCAM16Color* accent,
                                 gboolean is_dark,
                                 gboolean is_contrast,
                                 HeScheme* result)
{
	HeContentScheme * self;
	gdouble hue = 0.0;
	HeColorCAM16Color _tmp0_;
	gdouble chroma = 0.0;
	HeColorCAM16Color _tmp1_;
	gdouble primary = 0.0;
	gdouble secondary = 0.0;
	gdouble tertiary = 0.0;
	gdouble primary_hue = 0.0;
	gdouble secondary_hue = 0.0;
	gdouble tertiary_hue = 0.0;
	gdouble neutral = 0.0;
	gdouble neutral2 = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	gdouble _tmp41_ = 0.0;
	gdouble _tmp42_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp46_ = 0.0;
	gdouble _tmp49_ = 0.0;
	gdouble _tmp50_ = 0.0;
	gdouble _tmp53_ = 0.0;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	gdouble _tmp58_ = 0.0;
	gdouble _tmp59_ = 0.0;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	HeScheme _tmp90_ = {0};
#line 20 "../lib/Models/Schemes/Content.vala"
	self = (HeContentScheme*) base;
#line 20 "../lib/Models/Schemes/Content.vala"
	g_return_if_fail (accent != NULL);
#line 21 "../lib/Models/Schemes/Content.vala"
	_tmp0_ = *accent;
#line 21 "../lib/Models/Schemes/Content.vala"
	hue = _tmp0_.h;
#line 22 "../lib/Models/Schemes/Content.vala"
	_tmp1_ = *accent;
#line 22 "../lib/Models/Schemes/Content.vala"
	chroma = _tmp1_.c;
#line 24 "../lib/Models/Schemes/Content.vala"
	primary = chroma;
#line 25 "../lib/Models/Schemes/Content.vala"
	secondary = fmax (chroma - 32.0, chroma * 0.5);
#line 26 "../lib/Models/Schemes/Content.vala"
	tertiary = fmax (chroma + 16.0, chroma / 0.3);
#line 27 "../lib/Models/Schemes/Content.vala"
	primary_hue = he_math_utils_sanitize_degrees (hue);
#line 28 "../lib/Models/Schemes/Content.vala"
	secondary_hue = he_math_utils_sanitize_degrees (hue);
#line 29 "../lib/Models/Schemes/Content.vala"
	tertiary_hue = he_math_utils_sanitize_degrees (hue + 60.0);
#line 30 "../lib/Models/Schemes/Content.vala"
	neutral = chroma / 16.0;
#line 31 "../lib/Models/Schemes/Content.vala"
	neutral2 = (chroma / 8.0) + 4.0;
#line 37 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 37 "../lib/Models/Schemes/Content.vala"
		_tmp2_ = 6.0;
#line 162 "Content.c"
	} else {
#line 37 "../lib/Models/Schemes/Content.vala"
		_tmp2_ = 98.0;
#line 166 "Content.c"
	}
#line 38 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 38 "../lib/Models/Schemes/Content.vala"
		_tmp3_ = 24.0;
#line 172 "Content.c"
	} else {
#line 38 "../lib/Models/Schemes/Content.vala"
		_tmp3_ = 90.0;
#line 176 "Content.c"
	}
#line 39 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 39 "../lib/Models/Schemes/Content.vala"
		_tmp4_ = 98.0;
#line 182 "Content.c"
	} else {
#line 39 "../lib/Models/Schemes/Content.vala"
		_tmp4_ = 10.0;
#line 186 "Content.c"
	}
#line 40 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 40 "../lib/Models/Schemes/Content.vala"
		_tmp5_ = 80.0;
#line 192 "Content.c"
	} else {
#line 40 "../lib/Models/Schemes/Content.vala"
		_tmp5_ = 30.0;
#line 196 "Content.c"
	}
#line 41 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 41 "../lib/Models/Schemes/Content.vala"
		_tmp6_ = 90.0;
#line 202 "Content.c"
	} else {
#line 41 "../lib/Models/Schemes/Content.vala"
		_tmp6_ = 20.0;
#line 206 "Content.c"
	}
#line 42 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 42 "../lib/Models/Schemes/Content.vala"
		_tmp7_ = 20.0;
#line 212 "Content.c"
	} else {
#line 42 "../lib/Models/Schemes/Content.vala"
		_tmp7_ = 95.0;
#line 216 "Content.c"
	}
#line 44 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 220 "Content.c"
		gdouble _tmp9_ = 0.0;
#line 44 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 44 "../lib/Models/Schemes/Content.vala"
			_tmp9_ = 34.0;
#line 226 "Content.c"
		} else {
#line 44 "../lib/Models/Schemes/Content.vala"
			_tmp9_ = 24.0;
#line 230 "Content.c"
		}
#line 44 "../lib/Models/Schemes/Content.vala"
		_tmp8_ = _tmp9_;
#line 234 "Content.c"
	} else {
		gdouble _tmp10_ = 0.0;
#line 44 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 44 "../lib/Models/Schemes/Content.vala"
			_tmp10_ = 98.0;
#line 241 "Content.c"
		} else {
#line 44 "../lib/Models/Schemes/Content.vala"
			_tmp10_ = 98.0;
#line 245 "Content.c"
		}
#line 44 "../lib/Models/Schemes/Content.vala"
		_tmp8_ = _tmp10_;
#line 249 "Content.c"
	}
#line 45 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 253 "Content.c"
		gdouble _tmp12_ = 0.0;
#line 45 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 45 "../lib/Models/Schemes/Content.vala"
			_tmp12_ = 6.0;
#line 259 "Content.c"
		} else {
#line 45 "../lib/Models/Schemes/Content.vala"
			_tmp12_ = 6.0;
#line 263 "Content.c"
		}
#line 45 "../lib/Models/Schemes/Content.vala"
		_tmp11_ = _tmp12_;
#line 267 "Content.c"
	} else {
		gdouble _tmp13_ = 0.0;
#line 45 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 45 "../lib/Models/Schemes/Content.vala"
			_tmp13_ = 75.0;
#line 274 "Content.c"
		} else {
#line 45 "../lib/Models/Schemes/Content.vala"
			_tmp13_ = 87.0;
#line 278 "Content.c"
		}
#line 45 "../lib/Models/Schemes/Content.vala"
		_tmp11_ = _tmp13_;
#line 282 "Content.c"
	}
#line 47 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 286 "Content.c"
		gdouble _tmp15_ = 0.0;
#line 47 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Content.vala"
			_tmp15_ = 0.0;
#line 292 "Content.c"
		} else {
#line 47 "../lib/Models/Schemes/Content.vala"
			_tmp15_ = 4.0;
#line 296 "Content.c"
		}
#line 47 "../lib/Models/Schemes/Content.vala"
		_tmp14_ = _tmp15_;
#line 300 "Content.c"
	} else {
		gdouble _tmp16_ = 0.0;
#line 47 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Content.vala"
			_tmp16_ = 100.0;
#line 307 "Content.c"
		} else {
#line 47 "../lib/Models/Schemes/Content.vala"
			_tmp16_ = 100.0;
#line 311 "Content.c"
		}
#line 47 "../lib/Models/Schemes/Content.vala"
		_tmp14_ = _tmp16_;
#line 315 "Content.c"
	}
#line 48 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 319 "Content.c"
		gdouble _tmp18_ = 0.0;
#line 48 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Content.vala"
			_tmp18_ = 12.0;
#line 325 "Content.c"
		} else {
#line 48 "../lib/Models/Schemes/Content.vala"
			_tmp18_ = 10.0;
#line 329 "Content.c"
		}
#line 48 "../lib/Models/Schemes/Content.vala"
		_tmp17_ = _tmp18_;
#line 333 "Content.c"
	} else {
		gdouble _tmp19_ = 0.0;
#line 48 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Content.vala"
			_tmp19_ = 95.0;
#line 340 "Content.c"
		} else {
#line 48 "../lib/Models/Schemes/Content.vala"
			_tmp19_ = 96.0;
#line 344 "Content.c"
		}
#line 48 "../lib/Models/Schemes/Content.vala"
		_tmp17_ = _tmp19_;
#line 348 "Content.c"
	}
#line 49 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 352 "Content.c"
		gdouble _tmp21_ = 0.0;
#line 49 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 49 "../lib/Models/Schemes/Content.vala"
			_tmp21_ = 20.0;
#line 358 "Content.c"
		} else {
#line 49 "../lib/Models/Schemes/Content.vala"
			_tmp21_ = 12.0;
#line 362 "Content.c"
		}
#line 49 "../lib/Models/Schemes/Content.vala"
		_tmp20_ = _tmp21_;
#line 366 "Content.c"
	} else {
		gdouble _tmp22_ = 0.0;
#line 49 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 49 "../lib/Models/Schemes/Content.vala"
			_tmp22_ = 90.0;
#line 373 "Content.c"
		} else {
#line 49 "../lib/Models/Schemes/Content.vala"
			_tmp22_ = 94.0;
#line 377 "Content.c"
		}
#line 49 "../lib/Models/Schemes/Content.vala"
		_tmp20_ = _tmp22_;
#line 381 "Content.c"
	}
#line 50 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 385 "Content.c"
		gdouble _tmp24_ = 0.0;
#line 50 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Content.vala"
			_tmp24_ = 25.0;
#line 391 "Content.c"
		} else {
#line 50 "../lib/Models/Schemes/Content.vala"
			_tmp24_ = 17.0;
#line 395 "Content.c"
		}
#line 50 "../lib/Models/Schemes/Content.vala"
		_tmp23_ = _tmp24_;
#line 399 "Content.c"
	} else {
		gdouble _tmp25_ = 0.0;
#line 50 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Content.vala"
			_tmp25_ = 85.0;
#line 406 "Content.c"
		} else {
#line 50 "../lib/Models/Schemes/Content.vala"
			_tmp25_ = 92.0;
#line 410 "Content.c"
		}
#line 50 "../lib/Models/Schemes/Content.vala"
		_tmp23_ = _tmp25_;
#line 414 "Content.c"
	}
#line 51 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 418 "Content.c"
		gdouble _tmp27_ = 0.0;
#line 51 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Content.vala"
			_tmp27_ = 30.0;
#line 424 "Content.c"
		} else {
#line 51 "../lib/Models/Schemes/Content.vala"
			_tmp27_ = 22.0;
#line 428 "Content.c"
		}
#line 51 "../lib/Models/Schemes/Content.vala"
		_tmp26_ = _tmp27_;
#line 432 "Content.c"
	} else {
		gdouble _tmp28_ = 0.0;
#line 51 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Content.vala"
			_tmp28_ = 80.0;
#line 439 "Content.c"
		} else {
#line 51 "../lib/Models/Schemes/Content.vala"
			_tmp28_ = 90.0;
#line 443 "Content.c"
		}
#line 51 "../lib/Models/Schemes/Content.vala"
		_tmp26_ = _tmp28_;
#line 447 "Content.c"
	}
#line 56 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 451 "Content.c"
		gdouble _tmp30_ = 0.0;
#line 56 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 56 "../lib/Models/Schemes/Content.vala"
			_tmp30_ = 90.0;
#line 457 "Content.c"
		} else {
#line 56 "../lib/Models/Schemes/Content.vala"
			_tmp30_ = 80.0;
#line 461 "Content.c"
		}
#line 56 "../lib/Models/Schemes/Content.vala"
		_tmp29_ = _tmp30_;
#line 465 "Content.c"
	} else {
		gdouble _tmp31_ = 0.0;
#line 56 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 56 "../lib/Models/Schemes/Content.vala"
			_tmp31_ = 20.0;
#line 472 "Content.c"
		} else {
#line 56 "../lib/Models/Schemes/Content.vala"
			_tmp31_ = 40.0;
#line 476 "Content.c"
		}
#line 56 "../lib/Models/Schemes/Content.vala"
		_tmp29_ = _tmp31_;
#line 480 "Content.c"
	}
#line 57 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 57 "../lib/Models/Schemes/Content.vala"
		_tmp32_ = 20.0;
#line 486 "Content.c"
	} else {
#line 57 "../lib/Models/Schemes/Content.vala"
		_tmp32_ = 100.0;
#line 490 "Content.c"
	}
#line 58 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 494 "Content.c"
		gdouble _tmp34_ = 0.0;
#line 58 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 58 "../lib/Models/Schemes/Content.vala"
			_tmp34_ = 40.0;
#line 500 "Content.c"
		} else {
#line 58 "../lib/Models/Schemes/Content.vala"
			_tmp34_ = 30.0;
#line 504 "Content.c"
		}
#line 58 "../lib/Models/Schemes/Content.vala"
		_tmp33_ = _tmp34_;
#line 508 "Content.c"
	} else {
		gdouble _tmp35_ = 0.0;
#line 58 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 58 "../lib/Models/Schemes/Content.vala"
			_tmp35_ = 70.0;
#line 515 "Content.c"
		} else {
#line 58 "../lib/Models/Schemes/Content.vala"
			_tmp35_ = 90.0;
#line 519 "Content.c"
		}
#line 58 "../lib/Models/Schemes/Content.vala"
		_tmp33_ = _tmp35_;
#line 523 "Content.c"
	}
#line 59 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 59 "../lib/Models/Schemes/Content.vala"
		_tmp36_ = 90.0;
#line 529 "Content.c"
	} else {
#line 59 "../lib/Models/Schemes/Content.vala"
		_tmp36_ = 10.0;
#line 533 "Content.c"
	}
#line 60 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 60 "../lib/Models/Schemes/Content.vala"
		_tmp37_ = 40.0;
#line 539 "Content.c"
	} else {
#line 60 "../lib/Models/Schemes/Content.vala"
		_tmp37_ = 80.0;
#line 543 "Content.c"
	}
#line 65 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 547 "Content.c"
		gdouble _tmp39_ = 0.0;
#line 65 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 65 "../lib/Models/Schemes/Content.vala"
			_tmp39_ = 90.0;
#line 553 "Content.c"
		} else {
#line 65 "../lib/Models/Schemes/Content.vala"
			_tmp39_ = 80.0;
#line 557 "Content.c"
		}
#line 65 "../lib/Models/Schemes/Content.vala"
		_tmp38_ = _tmp39_;
#line 561 "Content.c"
	} else {
		gdouble _tmp40_ = 0.0;
#line 65 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 65 "../lib/Models/Schemes/Content.vala"
			_tmp40_ = 20.0;
#line 568 "Content.c"
		} else {
#line 65 "../lib/Models/Schemes/Content.vala"
			_tmp40_ = 40.0;
#line 572 "Content.c"
		}
#line 65 "../lib/Models/Schemes/Content.vala"
		_tmp38_ = _tmp40_;
#line 576 "Content.c"
	}
#line 66 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 66 "../lib/Models/Schemes/Content.vala"
		_tmp41_ = 20.0;
#line 582 "Content.c"
	} else {
#line 66 "../lib/Models/Schemes/Content.vala"
		_tmp41_ = 100.0;
#line 586 "Content.c"
	}
#line 67 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 590 "Content.c"
		gdouble _tmp43_ = 0.0;
#line 67 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 67 "../lib/Models/Schemes/Content.vala"
			_tmp43_ = 40.0;
#line 596 "Content.c"
		} else {
#line 67 "../lib/Models/Schemes/Content.vala"
			_tmp43_ = 30.0;
#line 600 "Content.c"
		}
#line 67 "../lib/Models/Schemes/Content.vala"
		_tmp42_ = _tmp43_;
#line 604 "Content.c"
	} else {
		gdouble _tmp44_ = 0.0;
#line 67 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 67 "../lib/Models/Schemes/Content.vala"
			_tmp44_ = 70.0;
#line 611 "Content.c"
		} else {
#line 67 "../lib/Models/Schemes/Content.vala"
			_tmp44_ = 90.0;
#line 615 "Content.c"
		}
#line 67 "../lib/Models/Schemes/Content.vala"
		_tmp42_ = _tmp44_;
#line 619 "Content.c"
	}
#line 68 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 68 "../lib/Models/Schemes/Content.vala"
		_tmp45_ = 90.0;
#line 625 "Content.c"
	} else {
#line 68 "../lib/Models/Schemes/Content.vala"
		_tmp45_ = 10.0;
#line 629 "Content.c"
	}
#line 73 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 633 "Content.c"
		gdouble _tmp47_ = 0.0;
#line 73 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 73 "../lib/Models/Schemes/Content.vala"
			_tmp47_ = 90.0;
#line 639 "Content.c"
		} else {
#line 73 "../lib/Models/Schemes/Content.vala"
			_tmp47_ = 80.0;
#line 643 "Content.c"
		}
#line 73 "../lib/Models/Schemes/Content.vala"
		_tmp46_ = _tmp47_;
#line 647 "Content.c"
	} else {
		gdouble _tmp48_ = 0.0;
#line 73 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 73 "../lib/Models/Schemes/Content.vala"
			_tmp48_ = 20.0;
#line 654 "Content.c"
		} else {
#line 73 "../lib/Models/Schemes/Content.vala"
			_tmp48_ = 40.0;
#line 658 "Content.c"
		}
#line 73 "../lib/Models/Schemes/Content.vala"
		_tmp46_ = _tmp48_;
#line 662 "Content.c"
	}
#line 74 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 74 "../lib/Models/Schemes/Content.vala"
		_tmp49_ = 20.0;
#line 668 "Content.c"
	} else {
#line 74 "../lib/Models/Schemes/Content.vala"
		_tmp49_ = 100.0;
#line 672 "Content.c"
	}
#line 75 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 676 "Content.c"
		gdouble _tmp51_ = 0.0;
#line 75 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 75 "../lib/Models/Schemes/Content.vala"
			_tmp51_ = 40.0;
#line 682 "Content.c"
		} else {
#line 75 "../lib/Models/Schemes/Content.vala"
			_tmp51_ = 30.0;
#line 686 "Content.c"
		}
#line 75 "../lib/Models/Schemes/Content.vala"
		_tmp50_ = _tmp51_;
#line 690 "Content.c"
	} else {
		gdouble _tmp52_ = 0.0;
#line 75 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 75 "../lib/Models/Schemes/Content.vala"
			_tmp52_ = 70.0;
#line 697 "Content.c"
		} else {
#line 75 "../lib/Models/Schemes/Content.vala"
			_tmp52_ = 90.0;
#line 701 "Content.c"
		}
#line 75 "../lib/Models/Schemes/Content.vala"
		_tmp50_ = _tmp52_;
#line 705 "Content.c"
	}
#line 76 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 76 "../lib/Models/Schemes/Content.vala"
		_tmp53_ = 90.0;
#line 711 "Content.c"
	} else {
#line 76 "../lib/Models/Schemes/Content.vala"
		_tmp53_ = 10.0;
#line 715 "Content.c"
	}
#line 81 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 81 "../lib/Models/Schemes/Content.vala"
		_tmp54_ = 60.0;
#line 721 "Content.c"
	} else {
#line 81 "../lib/Models/Schemes/Content.vala"
		_tmp54_ = 50.0;
#line 725 "Content.c"
	}
#line 82 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 729 "Content.c"
		gdouble _tmp56_ = 0.0;
#line 82 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 82 "../lib/Models/Schemes/Content.vala"
			_tmp56_ = 45.0;
#line 735 "Content.c"
		} else {
#line 82 "../lib/Models/Schemes/Content.vala"
			_tmp56_ = 30.0;
#line 739 "Content.c"
		}
#line 82 "../lib/Models/Schemes/Content.vala"
		_tmp55_ = _tmp56_;
#line 743 "Content.c"
	} else {
		gdouble _tmp57_ = 0.0;
#line 82 "../lib/Models/Schemes/Content.vala"
		if (is_contrast) {
#line 82 "../lib/Models/Schemes/Content.vala"
			_tmp57_ = 60.0;
#line 750 "Content.c"
		} else {
#line 82 "../lib/Models/Schemes/Content.vala"
			_tmp57_ = 80.0;
#line 754 "Content.c"
		}
#line 82 "../lib/Models/Schemes/Content.vala"
		_tmp55_ = _tmp57_;
#line 758 "Content.c"
	}
#line 87 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 87 "../lib/Models/Schemes/Content.vala"
		_tmp58_ = 0.0;
#line 764 "Content.c"
	} else {
#line 87 "../lib/Models/Schemes/Content.vala"
		_tmp58_ = 0.0;
#line 768 "Content.c"
	}
#line 88 "../lib/Models/Schemes/Content.vala"
	if (is_dark) {
#line 88 "../lib/Models/Schemes/Content.vala"
		_tmp59_ = 0.0;
#line 774 "Content.c"
	} else {
#line 88 "../lib/Models/Schemes/Content.vala"
		_tmp59_ = 0.0;
#line 778 "Content.c"
	}
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp60_ = he_color_hct_to_hex (hue, neutral, _tmp2_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp61_ = he_color_hct_to_hex (hue, neutral, _tmp3_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp62_ = he_color_hct_to_hex (hue, neutral, _tmp4_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp63_ = he_color_hct_to_hex (hue, neutral, _tmp5_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp64_ = he_color_hct_to_hex (hue, neutral, _tmp6_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp65_ = he_color_hct_to_hex (hue, neutral, _tmp7_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp66_ = he_color_hct_to_hex (hue, neutral, _tmp8_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp67_ = he_color_hct_to_hex (hue, neutral, _tmp11_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp68_ = he_color_hct_to_hex (hue, neutral, _tmp14_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp69_ = he_color_hct_to_hex (hue, neutral, _tmp17_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp70_ = he_color_hct_to_hex (hue, neutral, _tmp20_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp71_ = he_color_hct_to_hex (hue, neutral, _tmp23_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp72_ = he_color_hct_to_hex (hue, neutral, _tmp26_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp73_ = he_color_hct_to_hex (primary_hue, primary, _tmp29_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp74_ = he_color_hct_to_hex (primary_hue, primary, _tmp32_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp75_ = he_color_hct_to_hex (primary_hue, primary, _tmp33_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp76_ = he_color_hct_to_hex (primary_hue, primary, _tmp36_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp77_ = he_color_hct_to_hex (primary_hue, primary, _tmp37_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp78_ = he_color_hct_to_hex (secondary_hue, secondary, _tmp38_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp79_ = he_color_hct_to_hex (secondary_hue, secondary, _tmp41_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp80_ = he_color_hct_to_hex (secondary_hue, secondary, _tmp42_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp81_ = he_color_hct_to_hex (secondary_hue, secondary, _tmp45_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp82_ = he_color_hct_to_hex (tertiary_hue, tertiary, _tmp46_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp83_ = he_color_hct_to_hex (tertiary_hue, tertiary, _tmp49_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp84_ = he_color_hct_to_hex (tertiary_hue, tertiary, _tmp50_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp85_ = he_color_hct_to_hex (tertiary_hue, tertiary, _tmp53_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp86_ = he_color_hct_to_hex (hue, neutral2, _tmp54_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp87_ = he_color_hct_to_hex (hue, neutral2, _tmp55_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp88_ = he_color_hct_to_hex (hue, neutral, _tmp58_);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp89_ = he_color_hct_to_hex (hue, neutral, _tmp59_);
#line 33 "../lib/Models/Schemes/Content.vala"
	memset (&_tmp90_, 0, sizeof (HeScheme));
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_bg_hex = _tmp60_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_bg_variant_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_bg_variant_hex = _tmp61_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_fg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_fg_hex = _tmp62_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_fg_variant_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_fg_variant_hex = _tmp63_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.inverse_surface_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.inverse_surface_bg_hex = _tmp64_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.inverse_surface_fg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.inverse_surface_fg_hex = _tmp65_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_bright_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_bright_bg_hex = _tmp66_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_dim_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_dim_bg_hex = _tmp67_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_container_lowest_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_container_lowest_bg_hex = _tmp68_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_container_low_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_container_low_bg_hex = _tmp69_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_container_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_container_bg_hex = _tmp70_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_container_high_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_container_high_bg_hex = _tmp71_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.surface_container_highest_bg_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.surface_container_highest_bg_hex = _tmp72_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.primary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.primary_hex = _tmp73_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_primary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_primary_hex = _tmp74_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.primary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.primary_container_hex = _tmp75_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_primary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_primary_container_hex = _tmp76_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.inverse_primary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.inverse_primary_hex = _tmp77_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.secondary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.secondary_hex = _tmp78_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_secondary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_secondary_hex = _tmp79_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.secondary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.secondary_container_hex = _tmp80_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_secondary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_secondary_container_hex = _tmp81_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.tertiary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.tertiary_hex = _tmp82_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_tertiary_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_tertiary_hex = _tmp83_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.tertiary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.tertiary_container_hex = _tmp84_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.on_tertiary_container_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.on_tertiary_container_hex = _tmp85_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.outline_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.outline_hex = _tmp86_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.outline_variant_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.outline_variant_hex = _tmp87_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.shadow_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.shadow_hex = _tmp88_;
#line 33 "../lib/Models/Schemes/Content.vala"
	_g_free0 (_tmp90_.scrim_hex);
#line 33 "../lib/Models/Schemes/Content.vala"
	_tmp90_.scrim_hex = _tmp89_;
#line 33 "../lib/Models/Schemes/Content.vala"
	*result = _tmp90_;
#line 33 "../lib/Models/Schemes/Content.vala"
	return;
#line 966 "Content.c"
}

HeContentScheme*
he_content_scheme_construct (GType object_type)
{
	HeContentScheme * self = NULL;
#line 19 "../lib/Models/Schemes/Content.vala"
	self = (HeContentScheme*) g_object_new (object_type, NULL);
#line 19 "../lib/Models/Schemes/Content.vala"
	return self;
#line 977 "Content.c"
}

HeContentScheme*
he_content_scheme_new (void)
{
#line 19 "../lib/Models/Schemes/Content.vala"
	return he_content_scheme_construct (HE_TYPE_CONTENT_SCHEME);
#line 985 "Content.c"
}

static void
he_content_scheme_class_init (HeContentSchemeClass * klass,
                              gpointer klass_data)
{
#line 19 "../lib/Models/Schemes/Content.vala"
	he_content_scheme_parent_class = g_type_class_peek_parent (klass);
#line 994 "Content.c"
}

static void
he_content_scheme_he_scheme_factory_interface_init (HeSchemeFactoryIface * iface,
                                                    gpointer iface_data)
{
#line 19 "../lib/Models/Schemes/Content.vala"
	he_content_scheme_he_scheme_factory_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../lib/Models/Schemes/Content.vala"
	iface->generate = (void (*) (HeSchemeFactory*, HeColorCAM16Color*, gboolean, gboolean, HeScheme*)) he_content_scheme_real_generate;
#line 1005 "Content.c"
}

static void
he_content_scheme_instance_init (HeContentScheme * self,
                                 gpointer klass)
{
}

static GType
he_content_scheme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeContentSchemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_content_scheme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeContentScheme), 0, (GInstanceInitFunc) he_content_scheme_instance_init, NULL };
	static const GInterfaceInfo he_scheme_factory_info = { (GInterfaceInitFunc) he_content_scheme_he_scheme_factory_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_content_scheme_type_id;
	he_content_scheme_type_id = g_type_register_static (G_TYPE_OBJECT, "HeContentScheme", &g_define_type_info, 0);
	g_type_add_interface_static (he_content_scheme_type_id, HE_TYPE_SCHEME_FACTORY, &he_scheme_factory_info);
	return he_content_scheme_type_id;
}

GType
he_content_scheme_get_type (void)
{
	static volatile gsize he_content_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_content_scheme_type_id__once)) {
		GType he_content_scheme_type_id;
		he_content_scheme_type_id = he_content_scheme_get_type_once ();
		g_once_init_leave (&he_content_scheme_type_id__once, he_content_scheme_type_id);
	}
	return he_content_scheme_type_id__once;
}

