/* Muted.c generated by valac 0.56.14, the Vala compiler
 * generated from Muted.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	HE_MUTED_SCHEME_0_PROPERTY,
	HE_MUTED_SCHEME_NUM_PROPERTIES
};
static GParamSpec* he_muted_scheme_properties[HE_MUTED_SCHEME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer he_muted_scheme_parent_class = NULL;
static HeSchemeFactoryIface * he_muted_scheme_he_scheme_factory_parent_iface = NULL;

static void he_muted_scheme_real_generate (HeSchemeFactory* base,
                                    HeColorCAM16Color* accent,
                                    gboolean is_dark,
                                    gboolean is_contrast,
                                    HeScheme* result);
static GType he_muted_scheme_get_type_once (void);

static void
he_muted_scheme_real_generate (HeSchemeFactory* base,
                               HeColorCAM16Color* accent,
                               gboolean is_dark,
                               gboolean is_contrast,
                               HeScheme* result)
{
	HeMutedScheme * self;
	gdouble hue = 0.0;
	HeColorCAM16Color _tmp0_;
	gdouble primary_hue = 0.0;
	gdouble secondary_hue = 0.0;
	gdouble tertiary_hue = 0.0;
#line 27 "../lib/Models/Schemes/Muted.vala"
	static const gdouble PRIMARY = 20.0;
#line 28 "../lib/Models/Schemes/Muted.vala"
	static const gdouble SECONDARY = 8.0;
#line 29 "../lib/Models/Schemes/Muted.vala"
	static const gdouble TERTIARY = 12.0;
#line 30 "../lib/Models/Schemes/Muted.vala"
	static const gdouble NEUTRAL = 2.0;
#line 31 "../lib/Models/Schemes/Muted.vala"
	static const gdouble NEUTRAL2 = 4.0;
#line 72 "Muted.c"
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	gdouble _tmp52_ = 0.0;
	gdouble _tmp53_ = 0.0;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp57_ = 0.0;
	gdouble _tmp58_ = 0.0;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	HeScheme _tmp89_ = {0};
#line 20 "../lib/Models/Schemes/Muted.vala"
	self = (HeMutedScheme*) base;
#line 20 "../lib/Models/Schemes/Muted.vala"
	g_return_if_fail (accent != NULL);
#line 21 "../lib/Models/Schemes/Muted.vala"
	_tmp0_ = *accent;
#line 21 "../lib/Models/Schemes/Muted.vala"
	hue = _tmp0_.h;
#line 23 "../lib/Models/Schemes/Muted.vala"
	primary_hue = he_math_utils_sanitize_degrees (hue);
#line 24 "../lib/Models/Schemes/Muted.vala"
	secondary_hue = he_math_utils_sanitize_degrees (hue);
#line 25 "../lib/Models/Schemes/Muted.vala"
	tertiary_hue = he_math_utils_sanitize_degrees (hue + 60.0);
#line 37 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 37 "../lib/Models/Schemes/Muted.vala"
		_tmp1_ = 6.0;
#line 152 "Muted.c"
	} else {
#line 37 "../lib/Models/Schemes/Muted.vala"
		_tmp1_ = 98.0;
#line 156 "Muted.c"
	}
#line 38 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 38 "../lib/Models/Schemes/Muted.vala"
		_tmp2_ = 24.0;
#line 162 "Muted.c"
	} else {
#line 38 "../lib/Models/Schemes/Muted.vala"
		_tmp2_ = 90.0;
#line 166 "Muted.c"
	}
#line 39 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 39 "../lib/Models/Schemes/Muted.vala"
		_tmp3_ = 98.0;
#line 172 "Muted.c"
	} else {
#line 39 "../lib/Models/Schemes/Muted.vala"
		_tmp3_ = 10.0;
#line 176 "Muted.c"
	}
#line 40 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 40 "../lib/Models/Schemes/Muted.vala"
		_tmp4_ = 80.0;
#line 182 "Muted.c"
	} else {
#line 40 "../lib/Models/Schemes/Muted.vala"
		_tmp4_ = 30.0;
#line 186 "Muted.c"
	}
#line 41 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 41 "../lib/Models/Schemes/Muted.vala"
		_tmp5_ = 90.0;
#line 192 "Muted.c"
	} else {
#line 41 "../lib/Models/Schemes/Muted.vala"
		_tmp5_ = 20.0;
#line 196 "Muted.c"
	}
#line 42 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 42 "../lib/Models/Schemes/Muted.vala"
		_tmp6_ = 20.0;
#line 202 "Muted.c"
	} else {
#line 42 "../lib/Models/Schemes/Muted.vala"
		_tmp6_ = 95.0;
#line 206 "Muted.c"
	}
#line 44 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 210 "Muted.c"
		gdouble _tmp8_ = 0.0;
#line 44 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 44 "../lib/Models/Schemes/Muted.vala"
			_tmp8_ = 34.0;
#line 216 "Muted.c"
		} else {
#line 44 "../lib/Models/Schemes/Muted.vala"
			_tmp8_ = 24.0;
#line 220 "Muted.c"
		}
#line 44 "../lib/Models/Schemes/Muted.vala"
		_tmp7_ = _tmp8_;
#line 224 "Muted.c"
	} else {
		gdouble _tmp9_ = 0.0;
#line 44 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 44 "../lib/Models/Schemes/Muted.vala"
			_tmp9_ = 98.0;
#line 231 "Muted.c"
		} else {
#line 44 "../lib/Models/Schemes/Muted.vala"
			_tmp9_ = 98.0;
#line 235 "Muted.c"
		}
#line 44 "../lib/Models/Schemes/Muted.vala"
		_tmp7_ = _tmp9_;
#line 239 "Muted.c"
	}
#line 45 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 243 "Muted.c"
		gdouble _tmp11_ = 0.0;
#line 45 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 45 "../lib/Models/Schemes/Muted.vala"
			_tmp11_ = 6.0;
#line 249 "Muted.c"
		} else {
#line 45 "../lib/Models/Schemes/Muted.vala"
			_tmp11_ = 6.0;
#line 253 "Muted.c"
		}
#line 45 "../lib/Models/Schemes/Muted.vala"
		_tmp10_ = _tmp11_;
#line 257 "Muted.c"
	} else {
		gdouble _tmp12_ = 0.0;
#line 45 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 45 "../lib/Models/Schemes/Muted.vala"
			_tmp12_ = 75.0;
#line 264 "Muted.c"
		} else {
#line 45 "../lib/Models/Schemes/Muted.vala"
			_tmp12_ = 87.0;
#line 268 "Muted.c"
		}
#line 45 "../lib/Models/Schemes/Muted.vala"
		_tmp10_ = _tmp12_;
#line 272 "Muted.c"
	}
#line 47 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 276 "Muted.c"
		gdouble _tmp14_ = 0.0;
#line 47 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Muted.vala"
			_tmp14_ = 0.0;
#line 282 "Muted.c"
		} else {
#line 47 "../lib/Models/Schemes/Muted.vala"
			_tmp14_ = 4.0;
#line 286 "Muted.c"
		}
#line 47 "../lib/Models/Schemes/Muted.vala"
		_tmp13_ = _tmp14_;
#line 290 "Muted.c"
	} else {
		gdouble _tmp15_ = 0.0;
#line 47 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Muted.vala"
			_tmp15_ = 100.0;
#line 297 "Muted.c"
		} else {
#line 47 "../lib/Models/Schemes/Muted.vala"
			_tmp15_ = 100.0;
#line 301 "Muted.c"
		}
#line 47 "../lib/Models/Schemes/Muted.vala"
		_tmp13_ = _tmp15_;
#line 305 "Muted.c"
	}
#line 48 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 309 "Muted.c"
		gdouble _tmp17_ = 0.0;
#line 48 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Muted.vala"
			_tmp17_ = 12.0;
#line 315 "Muted.c"
		} else {
#line 48 "../lib/Models/Schemes/Muted.vala"
			_tmp17_ = 10.0;
#line 319 "Muted.c"
		}
#line 48 "../lib/Models/Schemes/Muted.vala"
		_tmp16_ = _tmp17_;
#line 323 "Muted.c"
	} else {
		gdouble _tmp18_ = 0.0;
#line 48 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Muted.vala"
			_tmp18_ = 95.0;
#line 330 "Muted.c"
		} else {
#line 48 "../lib/Models/Schemes/Muted.vala"
			_tmp18_ = 96.0;
#line 334 "Muted.c"
		}
#line 48 "../lib/Models/Schemes/Muted.vala"
		_tmp16_ = _tmp18_;
#line 338 "Muted.c"
	}
#line 49 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 342 "Muted.c"
		gdouble _tmp20_ = 0.0;
#line 49 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 49 "../lib/Models/Schemes/Muted.vala"
			_tmp20_ = 20.0;
#line 348 "Muted.c"
		} else {
#line 49 "../lib/Models/Schemes/Muted.vala"
			_tmp20_ = 12.0;
#line 352 "Muted.c"
		}
#line 49 "../lib/Models/Schemes/Muted.vala"
		_tmp19_ = _tmp20_;
#line 356 "Muted.c"
	} else {
		gdouble _tmp21_ = 0.0;
#line 49 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 49 "../lib/Models/Schemes/Muted.vala"
			_tmp21_ = 90.0;
#line 363 "Muted.c"
		} else {
#line 49 "../lib/Models/Schemes/Muted.vala"
			_tmp21_ = 94.0;
#line 367 "Muted.c"
		}
#line 49 "../lib/Models/Schemes/Muted.vala"
		_tmp19_ = _tmp21_;
#line 371 "Muted.c"
	}
#line 50 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 375 "Muted.c"
		gdouble _tmp23_ = 0.0;
#line 50 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Muted.vala"
			_tmp23_ = 25.0;
#line 381 "Muted.c"
		} else {
#line 50 "../lib/Models/Schemes/Muted.vala"
			_tmp23_ = 17.0;
#line 385 "Muted.c"
		}
#line 50 "../lib/Models/Schemes/Muted.vala"
		_tmp22_ = _tmp23_;
#line 389 "Muted.c"
	} else {
		gdouble _tmp24_ = 0.0;
#line 50 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Muted.vala"
			_tmp24_ = 85.0;
#line 396 "Muted.c"
		} else {
#line 50 "../lib/Models/Schemes/Muted.vala"
			_tmp24_ = 92.0;
#line 400 "Muted.c"
		}
#line 50 "../lib/Models/Schemes/Muted.vala"
		_tmp22_ = _tmp24_;
#line 404 "Muted.c"
	}
#line 51 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 408 "Muted.c"
		gdouble _tmp26_ = 0.0;
#line 51 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Muted.vala"
			_tmp26_ = 30.0;
#line 414 "Muted.c"
		} else {
#line 51 "../lib/Models/Schemes/Muted.vala"
			_tmp26_ = 22.0;
#line 418 "Muted.c"
		}
#line 51 "../lib/Models/Schemes/Muted.vala"
		_tmp25_ = _tmp26_;
#line 422 "Muted.c"
	} else {
		gdouble _tmp27_ = 0.0;
#line 51 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Muted.vala"
			_tmp27_ = 80.0;
#line 429 "Muted.c"
		} else {
#line 51 "../lib/Models/Schemes/Muted.vala"
			_tmp27_ = 90.0;
#line 433 "Muted.c"
		}
#line 51 "../lib/Models/Schemes/Muted.vala"
		_tmp25_ = _tmp27_;
#line 437 "Muted.c"
	}
#line 56 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 441 "Muted.c"
		gdouble _tmp29_ = 0.0;
#line 56 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 56 "../lib/Models/Schemes/Muted.vala"
			_tmp29_ = 90.0;
#line 447 "Muted.c"
		} else {
#line 56 "../lib/Models/Schemes/Muted.vala"
			_tmp29_ = 80.0;
#line 451 "Muted.c"
		}
#line 56 "../lib/Models/Schemes/Muted.vala"
		_tmp28_ = _tmp29_;
#line 455 "Muted.c"
	} else {
		gdouble _tmp30_ = 0.0;
#line 56 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 56 "../lib/Models/Schemes/Muted.vala"
			_tmp30_ = 20.0;
#line 462 "Muted.c"
		} else {
#line 56 "../lib/Models/Schemes/Muted.vala"
			_tmp30_ = 40.0;
#line 466 "Muted.c"
		}
#line 56 "../lib/Models/Schemes/Muted.vala"
		_tmp28_ = _tmp30_;
#line 470 "Muted.c"
	}
#line 57 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 57 "../lib/Models/Schemes/Muted.vala"
		_tmp31_ = 20.0;
#line 476 "Muted.c"
	} else {
#line 57 "../lib/Models/Schemes/Muted.vala"
		_tmp31_ = 100.0;
#line 480 "Muted.c"
	}
#line 58 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 484 "Muted.c"
		gdouble _tmp33_ = 0.0;
#line 58 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 58 "../lib/Models/Schemes/Muted.vala"
			_tmp33_ = 40.0;
#line 490 "Muted.c"
		} else {
#line 58 "../lib/Models/Schemes/Muted.vala"
			_tmp33_ = 30.0;
#line 494 "Muted.c"
		}
#line 58 "../lib/Models/Schemes/Muted.vala"
		_tmp32_ = _tmp33_;
#line 498 "Muted.c"
	} else {
		gdouble _tmp34_ = 0.0;
#line 58 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 58 "../lib/Models/Schemes/Muted.vala"
			_tmp34_ = 70.0;
#line 505 "Muted.c"
		} else {
#line 58 "../lib/Models/Schemes/Muted.vala"
			_tmp34_ = 90.0;
#line 509 "Muted.c"
		}
#line 58 "../lib/Models/Schemes/Muted.vala"
		_tmp32_ = _tmp34_;
#line 513 "Muted.c"
	}
#line 59 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 59 "../lib/Models/Schemes/Muted.vala"
		_tmp35_ = 90.0;
#line 519 "Muted.c"
	} else {
#line 59 "../lib/Models/Schemes/Muted.vala"
		_tmp35_ = 10.0;
#line 523 "Muted.c"
	}
#line 60 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 60 "../lib/Models/Schemes/Muted.vala"
		_tmp36_ = 40.0;
#line 529 "Muted.c"
	} else {
#line 60 "../lib/Models/Schemes/Muted.vala"
		_tmp36_ = 80.0;
#line 533 "Muted.c"
	}
#line 65 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 537 "Muted.c"
		gdouble _tmp38_ = 0.0;
#line 65 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 65 "../lib/Models/Schemes/Muted.vala"
			_tmp38_ = 90.0;
#line 543 "Muted.c"
		} else {
#line 65 "../lib/Models/Schemes/Muted.vala"
			_tmp38_ = 80.0;
#line 547 "Muted.c"
		}
#line 65 "../lib/Models/Schemes/Muted.vala"
		_tmp37_ = _tmp38_;
#line 551 "Muted.c"
	} else {
		gdouble _tmp39_ = 0.0;
#line 65 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 65 "../lib/Models/Schemes/Muted.vala"
			_tmp39_ = 20.0;
#line 558 "Muted.c"
		} else {
#line 65 "../lib/Models/Schemes/Muted.vala"
			_tmp39_ = 40.0;
#line 562 "Muted.c"
		}
#line 65 "../lib/Models/Schemes/Muted.vala"
		_tmp37_ = _tmp39_;
#line 566 "Muted.c"
	}
#line 66 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 66 "../lib/Models/Schemes/Muted.vala"
		_tmp40_ = 20.0;
#line 572 "Muted.c"
	} else {
#line 66 "../lib/Models/Schemes/Muted.vala"
		_tmp40_ = 100.0;
#line 576 "Muted.c"
	}
#line 67 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 580 "Muted.c"
		gdouble _tmp42_ = 0.0;
#line 67 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 67 "../lib/Models/Schemes/Muted.vala"
			_tmp42_ = 40.0;
#line 586 "Muted.c"
		} else {
#line 67 "../lib/Models/Schemes/Muted.vala"
			_tmp42_ = 30.0;
#line 590 "Muted.c"
		}
#line 67 "../lib/Models/Schemes/Muted.vala"
		_tmp41_ = _tmp42_;
#line 594 "Muted.c"
	} else {
		gdouble _tmp43_ = 0.0;
#line 67 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 67 "../lib/Models/Schemes/Muted.vala"
			_tmp43_ = 70.0;
#line 601 "Muted.c"
		} else {
#line 67 "../lib/Models/Schemes/Muted.vala"
			_tmp43_ = 90.0;
#line 605 "Muted.c"
		}
#line 67 "../lib/Models/Schemes/Muted.vala"
		_tmp41_ = _tmp43_;
#line 609 "Muted.c"
	}
#line 68 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 68 "../lib/Models/Schemes/Muted.vala"
		_tmp44_ = 90.0;
#line 615 "Muted.c"
	} else {
#line 68 "../lib/Models/Schemes/Muted.vala"
		_tmp44_ = 10.0;
#line 619 "Muted.c"
	}
#line 73 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 623 "Muted.c"
		gdouble _tmp46_ = 0.0;
#line 73 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 73 "../lib/Models/Schemes/Muted.vala"
			_tmp46_ = 90.0;
#line 629 "Muted.c"
		} else {
#line 73 "../lib/Models/Schemes/Muted.vala"
			_tmp46_ = 80.0;
#line 633 "Muted.c"
		}
#line 73 "../lib/Models/Schemes/Muted.vala"
		_tmp45_ = _tmp46_;
#line 637 "Muted.c"
	} else {
		gdouble _tmp47_ = 0.0;
#line 73 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 73 "../lib/Models/Schemes/Muted.vala"
			_tmp47_ = 20.0;
#line 644 "Muted.c"
		} else {
#line 73 "../lib/Models/Schemes/Muted.vala"
			_tmp47_ = 40.0;
#line 648 "Muted.c"
		}
#line 73 "../lib/Models/Schemes/Muted.vala"
		_tmp45_ = _tmp47_;
#line 652 "Muted.c"
	}
#line 74 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 74 "../lib/Models/Schemes/Muted.vala"
		_tmp48_ = 20.0;
#line 658 "Muted.c"
	} else {
#line 74 "../lib/Models/Schemes/Muted.vala"
		_tmp48_ = 100.0;
#line 662 "Muted.c"
	}
#line 75 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 666 "Muted.c"
		gdouble _tmp50_ = 0.0;
#line 75 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 75 "../lib/Models/Schemes/Muted.vala"
			_tmp50_ = 40.0;
#line 672 "Muted.c"
		} else {
#line 75 "../lib/Models/Schemes/Muted.vala"
			_tmp50_ = 30.0;
#line 676 "Muted.c"
		}
#line 75 "../lib/Models/Schemes/Muted.vala"
		_tmp49_ = _tmp50_;
#line 680 "Muted.c"
	} else {
		gdouble _tmp51_ = 0.0;
#line 75 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 75 "../lib/Models/Schemes/Muted.vala"
			_tmp51_ = 70.0;
#line 687 "Muted.c"
		} else {
#line 75 "../lib/Models/Schemes/Muted.vala"
			_tmp51_ = 90.0;
#line 691 "Muted.c"
		}
#line 75 "../lib/Models/Schemes/Muted.vala"
		_tmp49_ = _tmp51_;
#line 695 "Muted.c"
	}
#line 76 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 76 "../lib/Models/Schemes/Muted.vala"
		_tmp52_ = 90.0;
#line 701 "Muted.c"
	} else {
#line 76 "../lib/Models/Schemes/Muted.vala"
		_tmp52_ = 10.0;
#line 705 "Muted.c"
	}
#line 81 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 81 "../lib/Models/Schemes/Muted.vala"
		_tmp53_ = 60.0;
#line 711 "Muted.c"
	} else {
#line 81 "../lib/Models/Schemes/Muted.vala"
		_tmp53_ = 50.0;
#line 715 "Muted.c"
	}
#line 82 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 719 "Muted.c"
		gdouble _tmp55_ = 0.0;
#line 82 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 82 "../lib/Models/Schemes/Muted.vala"
			_tmp55_ = 45.0;
#line 725 "Muted.c"
		} else {
#line 82 "../lib/Models/Schemes/Muted.vala"
			_tmp55_ = 30.0;
#line 729 "Muted.c"
		}
#line 82 "../lib/Models/Schemes/Muted.vala"
		_tmp54_ = _tmp55_;
#line 733 "Muted.c"
	} else {
		gdouble _tmp56_ = 0.0;
#line 82 "../lib/Models/Schemes/Muted.vala"
		if (is_contrast) {
#line 82 "../lib/Models/Schemes/Muted.vala"
			_tmp56_ = 60.0;
#line 740 "Muted.c"
		} else {
#line 82 "../lib/Models/Schemes/Muted.vala"
			_tmp56_ = 80.0;
#line 744 "Muted.c"
		}
#line 82 "../lib/Models/Schemes/Muted.vala"
		_tmp54_ = _tmp56_;
#line 748 "Muted.c"
	}
#line 87 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 87 "../lib/Models/Schemes/Muted.vala"
		_tmp57_ = 0.0;
#line 754 "Muted.c"
	} else {
#line 87 "../lib/Models/Schemes/Muted.vala"
		_tmp57_ = 0.0;
#line 758 "Muted.c"
	}
#line 88 "../lib/Models/Schemes/Muted.vala"
	if (is_dark) {
#line 88 "../lib/Models/Schemes/Muted.vala"
		_tmp58_ = 0.0;
#line 764 "Muted.c"
	} else {
#line 88 "../lib/Models/Schemes/Muted.vala"
		_tmp58_ = 0.0;
#line 768 "Muted.c"
	}
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp59_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp1_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp60_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp2_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp61_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp3_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp62_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp4_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp63_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp5_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp64_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp6_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp65_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp7_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp66_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp10_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp67_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp13_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp68_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp16_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp69_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp19_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp70_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp22_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp71_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp25_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp72_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp28_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp73_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp31_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp74_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp32_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp75_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp35_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp76_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp36_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp77_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp37_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp78_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp40_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp79_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp41_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp80_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp44_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp81_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp45_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp82_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp48_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp83_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp49_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp84_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp52_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp85_ = he_color_hct_to_hex (hue, NEUTRAL2, _tmp53_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp86_ = he_color_hct_to_hex (hue, NEUTRAL2, _tmp54_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp87_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp57_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp88_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp58_);
#line 33 "../lib/Models/Schemes/Muted.vala"
	memset (&_tmp89_, 0, sizeof (HeScheme));
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_bg_hex = _tmp59_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_bg_variant_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_bg_variant_hex = _tmp60_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_fg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_fg_hex = _tmp61_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_fg_variant_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_fg_variant_hex = _tmp62_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.inverse_surface_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.inverse_surface_bg_hex = _tmp63_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.inverse_surface_fg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.inverse_surface_fg_hex = _tmp64_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_bright_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_bright_bg_hex = _tmp65_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_dim_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_dim_bg_hex = _tmp66_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_container_lowest_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_container_lowest_bg_hex = _tmp67_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_container_low_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_container_low_bg_hex = _tmp68_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_container_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_container_bg_hex = _tmp69_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_container_high_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_container_high_bg_hex = _tmp70_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.surface_container_highest_bg_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.surface_container_highest_bg_hex = _tmp71_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.primary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.primary_hex = _tmp72_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_primary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_primary_hex = _tmp73_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.primary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.primary_container_hex = _tmp74_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_primary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_primary_container_hex = _tmp75_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.inverse_primary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.inverse_primary_hex = _tmp76_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.secondary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.secondary_hex = _tmp77_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_secondary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_secondary_hex = _tmp78_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.secondary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.secondary_container_hex = _tmp79_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_secondary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_secondary_container_hex = _tmp80_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.tertiary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.tertiary_hex = _tmp81_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_tertiary_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_tertiary_hex = _tmp82_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.tertiary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.tertiary_container_hex = _tmp83_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.on_tertiary_container_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.on_tertiary_container_hex = _tmp84_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.outline_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.outline_hex = _tmp85_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.outline_variant_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.outline_variant_hex = _tmp86_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.shadow_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.shadow_hex = _tmp87_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	_g_free0 (_tmp89_.scrim_hex);
#line 33 "../lib/Models/Schemes/Muted.vala"
	_tmp89_.scrim_hex = _tmp88_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	*result = _tmp89_;
#line 33 "../lib/Models/Schemes/Muted.vala"
	return;
#line 956 "Muted.c"
}

HeMutedScheme*
he_muted_scheme_construct (GType object_type)
{
	HeMutedScheme * self = NULL;
#line 19 "../lib/Models/Schemes/Muted.vala"
	self = (HeMutedScheme*) g_object_new (object_type, NULL);
#line 19 "../lib/Models/Schemes/Muted.vala"
	return self;
#line 967 "Muted.c"
}

HeMutedScheme*
he_muted_scheme_new (void)
{
#line 19 "../lib/Models/Schemes/Muted.vala"
	return he_muted_scheme_construct (HE_TYPE_MUTED_SCHEME);
#line 975 "Muted.c"
}

static void
he_muted_scheme_class_init (HeMutedSchemeClass * klass,
                            gpointer klass_data)
{
#line 19 "../lib/Models/Schemes/Muted.vala"
	he_muted_scheme_parent_class = g_type_class_peek_parent (klass);
#line 984 "Muted.c"
}

static void
he_muted_scheme_he_scheme_factory_interface_init (HeSchemeFactoryIface * iface,
                                                  gpointer iface_data)
{
#line 19 "../lib/Models/Schemes/Muted.vala"
	he_muted_scheme_he_scheme_factory_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../lib/Models/Schemes/Muted.vala"
	iface->generate = (void (*) (HeSchemeFactory*, HeColorCAM16Color*, gboolean, gboolean, HeScheme*)) he_muted_scheme_real_generate;
#line 995 "Muted.c"
}

static void
he_muted_scheme_instance_init (HeMutedScheme * self,
                               gpointer klass)
{
}

static GType
he_muted_scheme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeMutedSchemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_muted_scheme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeMutedScheme), 0, (GInstanceInitFunc) he_muted_scheme_instance_init, NULL };
	static const GInterfaceInfo he_scheme_factory_info = { (GInterfaceInitFunc) he_muted_scheme_he_scheme_factory_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_muted_scheme_type_id;
	he_muted_scheme_type_id = g_type_register_static (G_TYPE_OBJECT, "HeMutedScheme", &g_define_type_info, 0);
	g_type_add_interface_static (he_muted_scheme_type_id, HE_TYPE_SCHEME_FACTORY, &he_scheme_factory_info);
	return he_muted_scheme_type_id;
}

GType
he_muted_scheme_get_type (void)
{
	static volatile gsize he_muted_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_muted_scheme_type_id__once)) {
		GType he_muted_scheme_type_id;
		he_muted_scheme_type_id = he_muted_scheme_get_type_once ();
		g_once_init_leave (&he_muted_scheme_type_id__once, he_muted_scheme_type_id);
	}
	return he_muted_scheme_type_id__once;
}

