/* Vibrant.c generated by valac 0.56.14, the Vala compiler
 * generated from Vibrant.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	HE_VIBRANT_SCHEME_0_PROPERTY,
	HE_VIBRANT_SCHEME_NUM_PROPERTIES
};
static GParamSpec* he_vibrant_scheme_properties[HE_VIBRANT_SCHEME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer he_vibrant_scheme_parent_class = NULL;
static HeSchemeFactoryIface * he_vibrant_scheme_he_scheme_factory_parent_iface = NULL;

static void he_vibrant_scheme_real_generate (HeSchemeFactory* base,
                                      HeColorCAM16Color* accent,
                                      gboolean is_dark,
                                      gboolean is_contrast,
                                      HeScheme* result);
static GType he_vibrant_scheme_get_type_once (void);

static void
he_vibrant_scheme_real_generate (HeSchemeFactory* base,
                                 HeColorCAM16Color* accent,
                                 gboolean is_dark,
                                 gboolean is_contrast,
                                 HeScheme* result)
{
	HeVibrantScheme * self;
	gdouble hue = 0.0;
	HeColorCAM16Color _tmp0_;
#line 23 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble PRIMARY = 80.0;
#line 24 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble SECONDARY = 32.0;
#line 25 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble TERTIARY = 48.0;
#line 26 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble NEUTRAL = 12.0;
#line 27 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble NEUTRAL2 = 16.0;
#line 28 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble HUES[9] = {(gdouble) 0, (gdouble) 41, (gdouble) 61, (gdouble) 101, (gdouble) 131, (gdouble) 181, (gdouble) 251, (gdouble) 301, (gdouble) 360};
#line 29 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble SECONDARY_ROTATIONS[9] = {(gdouble) 45, (gdouble) 95, (gdouble) 45, (gdouble) 20, (gdouble) 45, (gdouble) 90, (gdouble) 45, (gdouble) 45, (gdouble) 45};
#line 30 "../lib/Models/Schemes/Vibrant.vala"
	static const gdouble TERTIARY_ROTATIONS[9] = {(gdouble) 120, (gdouble) 120, (gdouble) 20, (gdouble) 45, (gdouble) 20, (gdouble) 15, (gdouble) 20, (gdouble) 120, (gdouble) 120};
#line 75 "Vibrant.c"
	gdouble primary_hue = 0.0;
	gdouble secondary_hue = 0.0;
	gdouble tertiary_hue = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp16_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp28_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_ = 0.0;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	gdouble _tmp52_ = 0.0;
	gdouble _tmp53_ = 0.0;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp57_ = 0.0;
	gdouble _tmp58_ = 0.0;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	HeScheme _tmp89_ = {0};
#line 20 "../lib/Models/Schemes/Vibrant.vala"
	self = (HeVibrantScheme*) base;
#line 20 "../lib/Models/Schemes/Vibrant.vala"
	g_return_if_fail (accent != NULL);
#line 21 "../lib/Models/Schemes/Vibrant.vala"
	_tmp0_ = *accent;
#line 21 "../lib/Models/Schemes/Vibrant.vala"
	hue = _tmp0_.h;
#line 32 "../lib/Models/Schemes/Vibrant.vala"
	primary_hue = he_math_utils_sanitize_degrees (hue);
#line 33 "../lib/Models/Schemes/Vibrant.vala"
	secondary_hue = he_color_get_rotated_hue (hue, HUES, (gint) G_N_ELEMENTS (HUES), SECONDARY_ROTATIONS, (gint) G_N_ELEMENTS (SECONDARY_ROTATIONS));
#line 34 "../lib/Models/Schemes/Vibrant.vala"
	tertiary_hue = he_color_get_rotated_hue (hue, HUES, (gint) G_N_ELEMENTS (HUES), TERTIARY_ROTATIONS, (gint) G_N_ELEMENTS (TERTIARY_ROTATIONS));
#line 40 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 40 "../lib/Models/Schemes/Vibrant.vala"
		_tmp1_ = 6.0;
#line 158 "Vibrant.c"
	} else {
#line 40 "../lib/Models/Schemes/Vibrant.vala"
		_tmp1_ = 98.0;
#line 162 "Vibrant.c"
	}
#line 41 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 41 "../lib/Models/Schemes/Vibrant.vala"
		_tmp2_ = 24.0;
#line 168 "Vibrant.c"
	} else {
#line 41 "../lib/Models/Schemes/Vibrant.vala"
		_tmp2_ = 90.0;
#line 172 "Vibrant.c"
	}
#line 42 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 42 "../lib/Models/Schemes/Vibrant.vala"
		_tmp3_ = 98.0;
#line 178 "Vibrant.c"
	} else {
#line 42 "../lib/Models/Schemes/Vibrant.vala"
		_tmp3_ = 10.0;
#line 182 "Vibrant.c"
	}
#line 43 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 43 "../lib/Models/Schemes/Vibrant.vala"
		_tmp4_ = 80.0;
#line 188 "Vibrant.c"
	} else {
#line 43 "../lib/Models/Schemes/Vibrant.vala"
		_tmp4_ = 30.0;
#line 192 "Vibrant.c"
	}
#line 44 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 44 "../lib/Models/Schemes/Vibrant.vala"
		_tmp5_ = 90.0;
#line 198 "Vibrant.c"
	} else {
#line 44 "../lib/Models/Schemes/Vibrant.vala"
		_tmp5_ = 20.0;
#line 202 "Vibrant.c"
	}
#line 45 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 45 "../lib/Models/Schemes/Vibrant.vala"
		_tmp6_ = 20.0;
#line 208 "Vibrant.c"
	} else {
#line 45 "../lib/Models/Schemes/Vibrant.vala"
		_tmp6_ = 95.0;
#line 212 "Vibrant.c"
	}
#line 47 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 216 "Vibrant.c"
		gdouble _tmp8_ = 0.0;
#line 47 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Vibrant.vala"
			_tmp8_ = 34.0;
#line 222 "Vibrant.c"
		} else {
#line 47 "../lib/Models/Schemes/Vibrant.vala"
			_tmp8_ = 24.0;
#line 226 "Vibrant.c"
		}
#line 47 "../lib/Models/Schemes/Vibrant.vala"
		_tmp7_ = _tmp8_;
#line 230 "Vibrant.c"
	} else {
		gdouble _tmp9_ = 0.0;
#line 47 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 47 "../lib/Models/Schemes/Vibrant.vala"
			_tmp9_ = 98.0;
#line 237 "Vibrant.c"
		} else {
#line 47 "../lib/Models/Schemes/Vibrant.vala"
			_tmp9_ = 98.0;
#line 241 "Vibrant.c"
		}
#line 47 "../lib/Models/Schemes/Vibrant.vala"
		_tmp7_ = _tmp9_;
#line 245 "Vibrant.c"
	}
#line 48 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 249 "Vibrant.c"
		gdouble _tmp11_ = 0.0;
#line 48 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Vibrant.vala"
			_tmp11_ = 6.0;
#line 255 "Vibrant.c"
		} else {
#line 48 "../lib/Models/Schemes/Vibrant.vala"
			_tmp11_ = 6.0;
#line 259 "Vibrant.c"
		}
#line 48 "../lib/Models/Schemes/Vibrant.vala"
		_tmp10_ = _tmp11_;
#line 263 "Vibrant.c"
	} else {
		gdouble _tmp12_ = 0.0;
#line 48 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 48 "../lib/Models/Schemes/Vibrant.vala"
			_tmp12_ = 75.0;
#line 270 "Vibrant.c"
		} else {
#line 48 "../lib/Models/Schemes/Vibrant.vala"
			_tmp12_ = 87.0;
#line 274 "Vibrant.c"
		}
#line 48 "../lib/Models/Schemes/Vibrant.vala"
		_tmp10_ = _tmp12_;
#line 278 "Vibrant.c"
	}
#line 50 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 282 "Vibrant.c"
		gdouble _tmp14_ = 0.0;
#line 50 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Vibrant.vala"
			_tmp14_ = 0.0;
#line 288 "Vibrant.c"
		} else {
#line 50 "../lib/Models/Schemes/Vibrant.vala"
			_tmp14_ = 4.0;
#line 292 "Vibrant.c"
		}
#line 50 "../lib/Models/Schemes/Vibrant.vala"
		_tmp13_ = _tmp14_;
#line 296 "Vibrant.c"
	} else {
		gdouble _tmp15_ = 0.0;
#line 50 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 50 "../lib/Models/Schemes/Vibrant.vala"
			_tmp15_ = 100.0;
#line 303 "Vibrant.c"
		} else {
#line 50 "../lib/Models/Schemes/Vibrant.vala"
			_tmp15_ = 100.0;
#line 307 "Vibrant.c"
		}
#line 50 "../lib/Models/Schemes/Vibrant.vala"
		_tmp13_ = _tmp15_;
#line 311 "Vibrant.c"
	}
#line 51 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 315 "Vibrant.c"
		gdouble _tmp17_ = 0.0;
#line 51 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Vibrant.vala"
			_tmp17_ = 12.0;
#line 321 "Vibrant.c"
		} else {
#line 51 "../lib/Models/Schemes/Vibrant.vala"
			_tmp17_ = 10.0;
#line 325 "Vibrant.c"
		}
#line 51 "../lib/Models/Schemes/Vibrant.vala"
		_tmp16_ = _tmp17_;
#line 329 "Vibrant.c"
	} else {
		gdouble _tmp18_ = 0.0;
#line 51 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 51 "../lib/Models/Schemes/Vibrant.vala"
			_tmp18_ = 95.0;
#line 336 "Vibrant.c"
		} else {
#line 51 "../lib/Models/Schemes/Vibrant.vala"
			_tmp18_ = 96.0;
#line 340 "Vibrant.c"
		}
#line 51 "../lib/Models/Schemes/Vibrant.vala"
		_tmp16_ = _tmp18_;
#line 344 "Vibrant.c"
	}
#line 52 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 348 "Vibrant.c"
		gdouble _tmp20_ = 0.0;
#line 52 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 52 "../lib/Models/Schemes/Vibrant.vala"
			_tmp20_ = 20.0;
#line 354 "Vibrant.c"
		} else {
#line 52 "../lib/Models/Schemes/Vibrant.vala"
			_tmp20_ = 12.0;
#line 358 "Vibrant.c"
		}
#line 52 "../lib/Models/Schemes/Vibrant.vala"
		_tmp19_ = _tmp20_;
#line 362 "Vibrant.c"
	} else {
		gdouble _tmp21_ = 0.0;
#line 52 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 52 "../lib/Models/Schemes/Vibrant.vala"
			_tmp21_ = 90.0;
#line 369 "Vibrant.c"
		} else {
#line 52 "../lib/Models/Schemes/Vibrant.vala"
			_tmp21_ = 94.0;
#line 373 "Vibrant.c"
		}
#line 52 "../lib/Models/Schemes/Vibrant.vala"
		_tmp19_ = _tmp21_;
#line 377 "Vibrant.c"
	}
#line 53 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 381 "Vibrant.c"
		gdouble _tmp23_ = 0.0;
#line 53 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 53 "../lib/Models/Schemes/Vibrant.vala"
			_tmp23_ = 25.0;
#line 387 "Vibrant.c"
		} else {
#line 53 "../lib/Models/Schemes/Vibrant.vala"
			_tmp23_ = 17.0;
#line 391 "Vibrant.c"
		}
#line 53 "../lib/Models/Schemes/Vibrant.vala"
		_tmp22_ = _tmp23_;
#line 395 "Vibrant.c"
	} else {
		gdouble _tmp24_ = 0.0;
#line 53 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 53 "../lib/Models/Schemes/Vibrant.vala"
			_tmp24_ = 85.0;
#line 402 "Vibrant.c"
		} else {
#line 53 "../lib/Models/Schemes/Vibrant.vala"
			_tmp24_ = 92.0;
#line 406 "Vibrant.c"
		}
#line 53 "../lib/Models/Schemes/Vibrant.vala"
		_tmp22_ = _tmp24_;
#line 410 "Vibrant.c"
	}
#line 54 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 414 "Vibrant.c"
		gdouble _tmp26_ = 0.0;
#line 54 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 54 "../lib/Models/Schemes/Vibrant.vala"
			_tmp26_ = 30.0;
#line 420 "Vibrant.c"
		} else {
#line 54 "../lib/Models/Schemes/Vibrant.vala"
			_tmp26_ = 22.0;
#line 424 "Vibrant.c"
		}
#line 54 "../lib/Models/Schemes/Vibrant.vala"
		_tmp25_ = _tmp26_;
#line 428 "Vibrant.c"
	} else {
		gdouble _tmp27_ = 0.0;
#line 54 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 54 "../lib/Models/Schemes/Vibrant.vala"
			_tmp27_ = 80.0;
#line 435 "Vibrant.c"
		} else {
#line 54 "../lib/Models/Schemes/Vibrant.vala"
			_tmp27_ = 90.0;
#line 439 "Vibrant.c"
		}
#line 54 "../lib/Models/Schemes/Vibrant.vala"
		_tmp25_ = _tmp27_;
#line 443 "Vibrant.c"
	}
#line 59 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 447 "Vibrant.c"
		gdouble _tmp29_ = 0.0;
#line 59 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 59 "../lib/Models/Schemes/Vibrant.vala"
			_tmp29_ = 90.0;
#line 453 "Vibrant.c"
		} else {
#line 59 "../lib/Models/Schemes/Vibrant.vala"
			_tmp29_ = 80.0;
#line 457 "Vibrant.c"
		}
#line 59 "../lib/Models/Schemes/Vibrant.vala"
		_tmp28_ = _tmp29_;
#line 461 "Vibrant.c"
	} else {
		gdouble _tmp30_ = 0.0;
#line 59 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 59 "../lib/Models/Schemes/Vibrant.vala"
			_tmp30_ = 20.0;
#line 468 "Vibrant.c"
		} else {
#line 59 "../lib/Models/Schemes/Vibrant.vala"
			_tmp30_ = 40.0;
#line 472 "Vibrant.c"
		}
#line 59 "../lib/Models/Schemes/Vibrant.vala"
		_tmp28_ = _tmp30_;
#line 476 "Vibrant.c"
	}
#line 60 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 60 "../lib/Models/Schemes/Vibrant.vala"
		_tmp31_ = 20.0;
#line 482 "Vibrant.c"
	} else {
#line 60 "../lib/Models/Schemes/Vibrant.vala"
		_tmp31_ = 100.0;
#line 486 "Vibrant.c"
	}
#line 61 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 490 "Vibrant.c"
		gdouble _tmp33_ = 0.0;
#line 61 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 61 "../lib/Models/Schemes/Vibrant.vala"
			_tmp33_ = 40.0;
#line 496 "Vibrant.c"
		} else {
#line 61 "../lib/Models/Schemes/Vibrant.vala"
			_tmp33_ = 30.0;
#line 500 "Vibrant.c"
		}
#line 61 "../lib/Models/Schemes/Vibrant.vala"
		_tmp32_ = _tmp33_;
#line 504 "Vibrant.c"
	} else {
		gdouble _tmp34_ = 0.0;
#line 61 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 61 "../lib/Models/Schemes/Vibrant.vala"
			_tmp34_ = 70.0;
#line 511 "Vibrant.c"
		} else {
#line 61 "../lib/Models/Schemes/Vibrant.vala"
			_tmp34_ = 90.0;
#line 515 "Vibrant.c"
		}
#line 61 "../lib/Models/Schemes/Vibrant.vala"
		_tmp32_ = _tmp34_;
#line 519 "Vibrant.c"
	}
#line 62 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 62 "../lib/Models/Schemes/Vibrant.vala"
		_tmp35_ = 90.0;
#line 525 "Vibrant.c"
	} else {
#line 62 "../lib/Models/Schemes/Vibrant.vala"
		_tmp35_ = 10.0;
#line 529 "Vibrant.c"
	}
#line 63 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 63 "../lib/Models/Schemes/Vibrant.vala"
		_tmp36_ = 40.0;
#line 535 "Vibrant.c"
	} else {
#line 63 "../lib/Models/Schemes/Vibrant.vala"
		_tmp36_ = 80.0;
#line 539 "Vibrant.c"
	}
#line 68 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 543 "Vibrant.c"
		gdouble _tmp38_ = 0.0;
#line 68 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 68 "../lib/Models/Schemes/Vibrant.vala"
			_tmp38_ = 90.0;
#line 549 "Vibrant.c"
		} else {
#line 68 "../lib/Models/Schemes/Vibrant.vala"
			_tmp38_ = 80.0;
#line 553 "Vibrant.c"
		}
#line 68 "../lib/Models/Schemes/Vibrant.vala"
		_tmp37_ = _tmp38_;
#line 557 "Vibrant.c"
	} else {
		gdouble _tmp39_ = 0.0;
#line 68 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 68 "../lib/Models/Schemes/Vibrant.vala"
			_tmp39_ = 20.0;
#line 564 "Vibrant.c"
		} else {
#line 68 "../lib/Models/Schemes/Vibrant.vala"
			_tmp39_ = 40.0;
#line 568 "Vibrant.c"
		}
#line 68 "../lib/Models/Schemes/Vibrant.vala"
		_tmp37_ = _tmp39_;
#line 572 "Vibrant.c"
	}
#line 69 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 69 "../lib/Models/Schemes/Vibrant.vala"
		_tmp40_ = 20.0;
#line 578 "Vibrant.c"
	} else {
#line 69 "../lib/Models/Schemes/Vibrant.vala"
		_tmp40_ = 100.0;
#line 582 "Vibrant.c"
	}
#line 70 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 586 "Vibrant.c"
		gdouble _tmp42_ = 0.0;
#line 70 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 70 "../lib/Models/Schemes/Vibrant.vala"
			_tmp42_ = 40.0;
#line 592 "Vibrant.c"
		} else {
#line 70 "../lib/Models/Schemes/Vibrant.vala"
			_tmp42_ = 30.0;
#line 596 "Vibrant.c"
		}
#line 70 "../lib/Models/Schemes/Vibrant.vala"
		_tmp41_ = _tmp42_;
#line 600 "Vibrant.c"
	} else {
		gdouble _tmp43_ = 0.0;
#line 70 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 70 "../lib/Models/Schemes/Vibrant.vala"
			_tmp43_ = 70.0;
#line 607 "Vibrant.c"
		} else {
#line 70 "../lib/Models/Schemes/Vibrant.vala"
			_tmp43_ = 90.0;
#line 611 "Vibrant.c"
		}
#line 70 "../lib/Models/Schemes/Vibrant.vala"
		_tmp41_ = _tmp43_;
#line 615 "Vibrant.c"
	}
#line 71 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 71 "../lib/Models/Schemes/Vibrant.vala"
		_tmp44_ = 90.0;
#line 621 "Vibrant.c"
	} else {
#line 71 "../lib/Models/Schemes/Vibrant.vala"
		_tmp44_ = 10.0;
#line 625 "Vibrant.c"
	}
#line 76 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 629 "Vibrant.c"
		gdouble _tmp46_ = 0.0;
#line 76 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 76 "../lib/Models/Schemes/Vibrant.vala"
			_tmp46_ = 90.0;
#line 635 "Vibrant.c"
		} else {
#line 76 "../lib/Models/Schemes/Vibrant.vala"
			_tmp46_ = 80.0;
#line 639 "Vibrant.c"
		}
#line 76 "../lib/Models/Schemes/Vibrant.vala"
		_tmp45_ = _tmp46_;
#line 643 "Vibrant.c"
	} else {
		gdouble _tmp47_ = 0.0;
#line 76 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 76 "../lib/Models/Schemes/Vibrant.vala"
			_tmp47_ = 20.0;
#line 650 "Vibrant.c"
		} else {
#line 76 "../lib/Models/Schemes/Vibrant.vala"
			_tmp47_ = 40.0;
#line 654 "Vibrant.c"
		}
#line 76 "../lib/Models/Schemes/Vibrant.vala"
		_tmp45_ = _tmp47_;
#line 658 "Vibrant.c"
	}
#line 77 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 77 "../lib/Models/Schemes/Vibrant.vala"
		_tmp48_ = 20.0;
#line 664 "Vibrant.c"
	} else {
#line 77 "../lib/Models/Schemes/Vibrant.vala"
		_tmp48_ = 100.0;
#line 668 "Vibrant.c"
	}
#line 78 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 672 "Vibrant.c"
		gdouble _tmp50_ = 0.0;
#line 78 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 78 "../lib/Models/Schemes/Vibrant.vala"
			_tmp50_ = 40.0;
#line 678 "Vibrant.c"
		} else {
#line 78 "../lib/Models/Schemes/Vibrant.vala"
			_tmp50_ = 30.0;
#line 682 "Vibrant.c"
		}
#line 78 "../lib/Models/Schemes/Vibrant.vala"
		_tmp49_ = _tmp50_;
#line 686 "Vibrant.c"
	} else {
		gdouble _tmp51_ = 0.0;
#line 78 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 78 "../lib/Models/Schemes/Vibrant.vala"
			_tmp51_ = 70.0;
#line 693 "Vibrant.c"
		} else {
#line 78 "../lib/Models/Schemes/Vibrant.vala"
			_tmp51_ = 90.0;
#line 697 "Vibrant.c"
		}
#line 78 "../lib/Models/Schemes/Vibrant.vala"
		_tmp49_ = _tmp51_;
#line 701 "Vibrant.c"
	}
#line 79 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 79 "../lib/Models/Schemes/Vibrant.vala"
		_tmp52_ = 90.0;
#line 707 "Vibrant.c"
	} else {
#line 79 "../lib/Models/Schemes/Vibrant.vala"
		_tmp52_ = 10.0;
#line 711 "Vibrant.c"
	}
#line 84 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 84 "../lib/Models/Schemes/Vibrant.vala"
		_tmp53_ = 60.0;
#line 717 "Vibrant.c"
	} else {
#line 84 "../lib/Models/Schemes/Vibrant.vala"
		_tmp53_ = 50.0;
#line 721 "Vibrant.c"
	}
#line 85 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 725 "Vibrant.c"
		gdouble _tmp55_ = 0.0;
#line 85 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 85 "../lib/Models/Schemes/Vibrant.vala"
			_tmp55_ = 45.0;
#line 731 "Vibrant.c"
		} else {
#line 85 "../lib/Models/Schemes/Vibrant.vala"
			_tmp55_ = 30.0;
#line 735 "Vibrant.c"
		}
#line 85 "../lib/Models/Schemes/Vibrant.vala"
		_tmp54_ = _tmp55_;
#line 739 "Vibrant.c"
	} else {
		gdouble _tmp56_ = 0.0;
#line 85 "../lib/Models/Schemes/Vibrant.vala"
		if (is_contrast) {
#line 85 "../lib/Models/Schemes/Vibrant.vala"
			_tmp56_ = 60.0;
#line 746 "Vibrant.c"
		} else {
#line 85 "../lib/Models/Schemes/Vibrant.vala"
			_tmp56_ = 80.0;
#line 750 "Vibrant.c"
		}
#line 85 "../lib/Models/Schemes/Vibrant.vala"
		_tmp54_ = _tmp56_;
#line 754 "Vibrant.c"
	}
#line 90 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 90 "../lib/Models/Schemes/Vibrant.vala"
		_tmp57_ = 0.0;
#line 760 "Vibrant.c"
	} else {
#line 90 "../lib/Models/Schemes/Vibrant.vala"
		_tmp57_ = 0.0;
#line 764 "Vibrant.c"
	}
#line 91 "../lib/Models/Schemes/Vibrant.vala"
	if (is_dark) {
#line 91 "../lib/Models/Schemes/Vibrant.vala"
		_tmp58_ = 0.0;
#line 770 "Vibrant.c"
	} else {
#line 91 "../lib/Models/Schemes/Vibrant.vala"
		_tmp58_ = 0.0;
#line 774 "Vibrant.c"
	}
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp59_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp1_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp60_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp2_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp61_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp3_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp62_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp4_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp63_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp5_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp64_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp6_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp65_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp7_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp66_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp10_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp67_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp13_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp68_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp16_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp69_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp19_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp70_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp22_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp71_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp25_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp72_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp28_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp73_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp31_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp74_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp32_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp75_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp35_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp76_ = he_color_hct_to_hex (primary_hue, PRIMARY, _tmp36_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp77_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp37_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp78_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp40_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp79_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp41_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp80_ = he_color_hct_to_hex (secondary_hue, SECONDARY, _tmp44_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp81_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp45_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp82_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp48_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp83_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp49_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp84_ = he_color_hct_to_hex (tertiary_hue, TERTIARY, _tmp52_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp85_ = he_color_hct_to_hex (hue, NEUTRAL2, _tmp53_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp86_ = he_color_hct_to_hex (hue, NEUTRAL2, _tmp54_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp87_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp57_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp88_ = he_color_hct_to_hex (hue, NEUTRAL, _tmp58_);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	memset (&_tmp89_, 0, sizeof (HeScheme));
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_bg_hex = _tmp59_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_bg_variant_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_bg_variant_hex = _tmp60_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_fg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_fg_hex = _tmp61_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_fg_variant_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_fg_variant_hex = _tmp62_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.inverse_surface_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.inverse_surface_bg_hex = _tmp63_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.inverse_surface_fg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.inverse_surface_fg_hex = _tmp64_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_bright_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_bright_bg_hex = _tmp65_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_dim_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_dim_bg_hex = _tmp66_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_container_lowest_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_container_lowest_bg_hex = _tmp67_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_container_low_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_container_low_bg_hex = _tmp68_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_container_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_container_bg_hex = _tmp69_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_container_high_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_container_high_bg_hex = _tmp70_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.surface_container_highest_bg_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.surface_container_highest_bg_hex = _tmp71_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.primary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.primary_hex = _tmp72_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_primary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_primary_hex = _tmp73_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.primary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.primary_container_hex = _tmp74_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_primary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_primary_container_hex = _tmp75_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.inverse_primary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.inverse_primary_hex = _tmp76_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.secondary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.secondary_hex = _tmp77_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_secondary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_secondary_hex = _tmp78_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.secondary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.secondary_container_hex = _tmp79_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_secondary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_secondary_container_hex = _tmp80_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.tertiary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.tertiary_hex = _tmp81_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_tertiary_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_tertiary_hex = _tmp82_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.tertiary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.tertiary_container_hex = _tmp83_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.on_tertiary_container_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.on_tertiary_container_hex = _tmp84_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.outline_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.outline_hex = _tmp85_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.outline_variant_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.outline_variant_hex = _tmp86_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.shadow_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.shadow_hex = _tmp87_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_g_free0 (_tmp89_.scrim_hex);
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	_tmp89_.scrim_hex = _tmp88_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	*result = _tmp89_;
#line 36 "../lib/Models/Schemes/Vibrant.vala"
	return;
#line 962 "Vibrant.c"
}

HeVibrantScheme*
he_vibrant_scheme_construct (GType object_type)
{
	HeVibrantScheme * self = NULL;
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	self = (HeVibrantScheme*) g_object_new (object_type, NULL);
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	return self;
#line 973 "Vibrant.c"
}

HeVibrantScheme*
he_vibrant_scheme_new (void)
{
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	return he_vibrant_scheme_construct (HE_TYPE_VIBRANT_SCHEME);
#line 981 "Vibrant.c"
}

static void
he_vibrant_scheme_class_init (HeVibrantSchemeClass * klass,
                              gpointer klass_data)
{
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	he_vibrant_scheme_parent_class = g_type_class_peek_parent (klass);
#line 990 "Vibrant.c"
}

static void
he_vibrant_scheme_he_scheme_factory_interface_init (HeSchemeFactoryIface * iface,
                                                    gpointer iface_data)
{
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	he_vibrant_scheme_he_scheme_factory_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../lib/Models/Schemes/Vibrant.vala"
	iface->generate = (void (*) (HeSchemeFactory*, HeColorCAM16Color*, gboolean, gboolean, HeScheme*)) he_vibrant_scheme_real_generate;
#line 1001 "Vibrant.c"
}

static void
he_vibrant_scheme_instance_init (HeVibrantScheme * self,
                                 gpointer klass)
{
}

static GType
he_vibrant_scheme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeVibrantSchemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_vibrant_scheme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeVibrantScheme), 0, (GInstanceInitFunc) he_vibrant_scheme_instance_init, NULL };
	static const GInterfaceInfo he_scheme_factory_info = { (GInterfaceInitFunc) he_vibrant_scheme_he_scheme_factory_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_vibrant_scheme_type_id;
	he_vibrant_scheme_type_id = g_type_register_static (G_TYPE_OBJECT, "HeVibrantScheme", &g_define_type_info, 0);
	g_type_add_interface_static (he_vibrant_scheme_type_id, HE_TYPE_SCHEME_FACTORY, &he_scheme_factory_info);
	return he_vibrant_scheme_type_id;
}

GType
he_vibrant_scheme_get_type (void)
{
	static volatile gsize he_vibrant_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_vibrant_scheme_type_id__once)) {
		GType he_vibrant_scheme_type_id;
		he_vibrant_scheme_type_id = he_vibrant_scheme_get_type_once ();
		g_once_init_leave (&he_vibrant_scheme_type_id__once, he_vibrant_scheme_type_id);
	}
	return he_vibrant_scheme_type_id__once;
}

