/* Desktop.c generated by valac 0.56.14, the Vala compiler
 * generated from Desktop.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define HE_PORTAL_TYPE_SETTINGS (he_portal_settings_get_type ())
#define HE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettings))
#define HE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_PORTAL_TYPE_SETTINGS))
#define HE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettingsIface))

typedef struct _HePortalSettings HePortalSettings;
typedef struct _HePortalSettingsIface HePortalSettingsIface;

#define HE_PORTAL_TYPE_SETTINGS_PROXY (he_portal_settings_proxy_get_type ())
enum  {
	HE_DESKTOP_0_PROPERTY,
	HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY,
	HE_DESKTOP_ENSOR_SCHEME_PROPERTY,
	HE_DESKTOP_ACCENT_COLOR_PROPERTY,
	HE_DESKTOP_FONT_WEIGHT_PROPERTY,
	HE_DESKTOP_ROUNDNESS_PROPERTY,
	HE_DESKTOP_CONTRAST_PROPERTY,
	HE_DESKTOP_NUM_PROPERTIES
};
static GParamSpec* he_desktop_properties[HE_DESKTOP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))

struct _HePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (HePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (HePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

struct _HeDesktopPrivate {
	HePortalSettings* portal;
	HeDesktopColorScheme* _prefers_color_scheme;
	HeDesktopEnsorScheme* _ensor_scheme;
	HeColorRGBColor* _accent_color;
	gdouble _font_weight;
	gdouble _roundness;
	HeDesktopContrastScheme* _contrast;
};

static gint HeDesktop_private_offset;
static gpointer he_desktop_parent_class = NULL;

VALA_EXTERN GType he_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint he_portal_settings_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType he_portal_settings_get_type (void) G_GNUC_CONST ;
static HeDesktopColorScheme* _he_desktop_color_scheme_dup (HeDesktopColorScheme* self);
static void he_desktop_setup_prefers_color_scheme (HeDesktop* self);
VALA_EXTERN GVariant* he_portal_settings_read (HePortalSettings* self,
                                   const gchar* namespace,
                                   const gchar* key,
                                   GError** error);
static void he_desktop_set_ensor_scheme (HeDesktop* self,
                                  HeDesktopEnsorScheme value);
static HeDesktopEnsorScheme* _he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self);
static void he_desktop_setup_ensor_scheme (HeDesktop* self);
static HeColorRGBColor* he_desktop_parse_accent_color (HeDesktop* self,
                                                GVariant* val);
static void he_desktop_setup_accent_color (HeDesktop* self);
static void he_desktop_setup_font_weight (HeDesktop* self);
static void he_desktop_setup_roundness (HeDesktop* self);
static HeDesktopContrastScheme* _he_desktop_contrast_scheme_dup (HeDesktopContrastScheme* self);
static void he_desktop_setup_contrast (HeDesktop* self);
static void he_desktop_init_handle_settings_change (HeDesktop* self);
static void __lambda4_ (HeDesktop* self,
                 const gchar* scheme,
                 const gchar* key,
                 GVariant* val);
static void ___lambda4__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                     const gchar* namespace,
                                                     const gchar* key,
                                                     GVariant* val,
                                                     gpointer self);
static GObject * he_desktop_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
VALA_EXTERN HePortalSettings* he_portal_settings_get (GError** error);
static void he_desktop_finalize (GObject * obj);
static GType he_desktop_get_type_once (void);
static void _vala_he_desktop_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_he_desktop_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_desktop_get_instance_private (HeDesktop* self)
{
	return G_STRUCT_MEMBER_P (self, HeDesktop_private_offset);
}

/**
    * The color scheme preference enum, which is used to determine the color scheme of the desktop.
    */
static GType
he_desktop_color_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE, "HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE", "no-preference"}, {HE_DESKTOP_COLOR_SCHEME_DARK, "HE_DESKTOP_COLOR_SCHEME_DARK", "dark"}, {HE_DESKTOP_COLOR_SCHEME_LIGHT, "HE_DESKTOP_COLOR_SCHEME_LIGHT", "light"}, {0, NULL, NULL}};
	GType he_desktop_color_scheme_type_id;
	he_desktop_color_scheme_type_id = g_enum_register_static ("HeDesktopColorScheme", values);
	return he_desktop_color_scheme_type_id;
}

GType
he_desktop_color_scheme_get_type (void)
{
	static volatile gsize he_desktop_color_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_color_scheme_type_id__once)) {
		GType he_desktop_color_scheme_type_id;
		he_desktop_color_scheme_type_id = he_desktop_color_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_color_scheme_type_id__once, he_desktop_color_scheme_type_id);
	}
	return he_desktop_color_scheme_type_id__once;
}

/**
    * The contrast scheme preference enum, which is used to determine the contrast scheme of the desktop.
    */
static GType
he_desktop_contrast_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_CONTRAST_SCHEME_DEFAULT, "HE_DESKTOP_CONTRAST_SCHEME_DEFAULT", "default"}, {HE_DESKTOP_CONTRAST_SCHEME_HIGH, "HE_DESKTOP_CONTRAST_SCHEME_HIGH", "high"}, {HE_DESKTOP_CONTRAST_SCHEME_LOW, "HE_DESKTOP_CONTRAST_SCHEME_LOW", "low"}, {0, NULL, NULL}};
	GType he_desktop_contrast_scheme_type_id;
	he_desktop_contrast_scheme_type_id = g_enum_register_static ("HeDesktopContrastScheme", values);
	return he_desktop_contrast_scheme_type_id;
}

GType
he_desktop_contrast_scheme_get_type (void)
{
	static volatile gsize he_desktop_contrast_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_contrast_scheme_type_id__once)) {
		GType he_desktop_contrast_scheme_type_id;
		he_desktop_contrast_scheme_type_id = he_desktop_contrast_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_contrast_scheme_type_id__once, he_desktop_contrast_scheme_type_id);
	}
	return he_desktop_contrast_scheme_type_id__once;
}

/**
    * The Ensor scheme preference enum, which is used to determine the Ensor scheme of the desktop.
    */
HeSchemeFactory*
he_desktop_ensor_scheme_to_factory (HeDesktopEnsorScheme self)
{
	HeSchemeFactory* result;
#line 83 "../lib/Utils/Desktop.vala"
	switch (self) {
#line 83 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_DEFAULT:
#line 194 "Desktop.c"
		{
			HeDefaultScheme* _tmp0_;
#line 85 "../lib/Utils/Desktop.vala"
			_tmp0_ = he_default_scheme_new ();
#line 85 "../lib/Utils/Desktop.vala"
			result = (HeSchemeFactory*) _tmp0_;
#line 85 "../lib/Utils/Desktop.vala"
			return result;
#line 203 "Desktop.c"
		}
#line 83 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_VIBRANT:
#line 207 "Desktop.c"
		{
			HeVibrantScheme* _tmp1_;
#line 87 "../lib/Utils/Desktop.vala"
			_tmp1_ = he_vibrant_scheme_new ();
#line 87 "../lib/Utils/Desktop.vala"
			result = (HeSchemeFactory*) _tmp1_;
#line 87 "../lib/Utils/Desktop.vala"
			return result;
#line 216 "Desktop.c"
		}
#line 83 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_MUTED:
#line 220 "Desktop.c"
		{
			HeMutedScheme* _tmp2_;
#line 89 "../lib/Utils/Desktop.vala"
			_tmp2_ = he_muted_scheme_new ();
#line 89 "../lib/Utils/Desktop.vala"
			result = (HeSchemeFactory*) _tmp2_;
#line 89 "../lib/Utils/Desktop.vala"
			return result;
#line 229 "Desktop.c"
		}
#line 83 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC:
#line 233 "Desktop.c"
		{
			HeMonochromaticScheme* _tmp3_;
#line 91 "../lib/Utils/Desktop.vala"
			_tmp3_ = he_monochromatic_scheme_new ();
#line 91 "../lib/Utils/Desktop.vala"
			result = (HeSchemeFactory*) _tmp3_;
#line 91 "../lib/Utils/Desktop.vala"
			return result;
#line 242 "Desktop.c"
		}
		default:
		{
			HeDefaultScheme* _tmp4_;
#line 93 "../lib/Utils/Desktop.vala"
			_tmp4_ = he_default_scheme_new ();
#line 93 "../lib/Utils/Desktop.vala"
			result = (HeSchemeFactory*) _tmp4_;
#line 93 "../lib/Utils/Desktop.vala"
			return result;
#line 253 "Desktop.c"
		}
	}
}

static GType
he_desktop_ensor_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_ENSOR_SCHEME_DEFAULT, "HE_DESKTOP_ENSOR_SCHEME_DEFAULT", "default"}, {HE_DESKTOP_ENSOR_SCHEME_VIBRANT, "HE_DESKTOP_ENSOR_SCHEME_VIBRANT", "vibrant"}, {HE_DESKTOP_ENSOR_SCHEME_MUTED, "HE_DESKTOP_ENSOR_SCHEME_MUTED", "muted"}, {HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC, "HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC", "monochromatic"}, {0, NULL, NULL}};
	GType he_desktop_ensor_scheme_type_id;
	he_desktop_ensor_scheme_type_id = g_enum_register_static ("HeDesktopEnsorScheme", values);
	return he_desktop_ensor_scheme_type_id;
}

GType
he_desktop_ensor_scheme_get_type (void)
{
	static volatile gsize he_desktop_ensor_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_ensor_scheme_type_id__once)) {
		GType he_desktop_ensor_scheme_type_id;
		he_desktop_ensor_scheme_type_id = he_desktop_ensor_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_ensor_scheme_type_id__once, he_desktop_ensor_scheme_type_id);
	}
	return he_desktop_ensor_scheme_type_id__once;
}

HeDesktopColorScheme
he_desktop_get_prefers_color_scheme (HeDesktop* self)
{
	HeDesktopColorScheme result;
	HeDesktopColorScheme* _tmp0_;
#line 50 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_prefers_color_scheme;
#line 51 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 51 "../lib/Utils/Desktop.vala"
	return result;
#line 292 "Desktop.c"
}

static HeDesktopColorScheme*
_he_desktop_color_scheme_dup (HeDesktopColorScheme* self)
{
	HeDesktopColorScheme* dup;
#line 54 "../lib/Utils/Desktop.vala"
	dup = g_new0 (HeDesktopColorScheme, 1);
#line 54 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (HeDesktopColorScheme));
#line 54 "../lib/Utils/Desktop.vala"
	return dup;
#line 305 "Desktop.c"
}

static gpointer
__he_desktop_color_scheme_dup0 (gpointer self)
{
#line 54 "../lib/Utils/Desktop.vala"
	return self ? _he_desktop_color_scheme_dup (self) : NULL;
#line 313 "Desktop.c"
}

void
he_desktop_set_prefers_color_scheme (HeDesktop* self,
                                     HeDesktopColorScheme value)
{
	HeDesktopColorScheme* _tmp0_;
#line 53 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 54 "../lib/Utils/Desktop.vala"
	_tmp0_ = __he_desktop_color_scheme_dup0 (&value);
#line 54 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_prefers_color_scheme);
#line 54 "../lib/Utils/Desktop.vala"
	self->priv->_prefers_color_scheme = _tmp0_;
#line 53 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY]);
#line 331 "Desktop.c"
}

static void
he_desktop_setup_prefers_color_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 58 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 340 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 60 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 60 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "color-scheme", &_inner_error0_);
#line 60 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 60 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "Desktop.c"
			goto __catch0_g_error;
		}
#line 60 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 60 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 60 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (_tmp4_));
#line 60 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 65 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 65 "../lib/Utils/Desktop.vala"
		return;
#line 370 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 59 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 59 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 67 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 67 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 67 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:67: %s", _tmp6_);
#line 59 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 390 "Desktop.c"
	}
	__finally0:
#line 59 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 59 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 59 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 59 "../lib/Utils/Desktop.vala"
		return;
#line 401 "Desktop.c"
	}
#line 70 "../lib/Utils/Desktop.vala"
	he_desktop_set_prefers_color_scheme (self, HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE);
#line 405 "Desktop.c"
}

HeDesktopEnsorScheme
he_desktop_get_ensor_scheme (HeDesktop* self)
{
	HeDesktopEnsorScheme result;
	HeDesktopEnsorScheme* _tmp0_;
#line 103 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 104 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_ensor_scheme;
#line 104 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 104 "../lib/Utils/Desktop.vala"
	return result;
#line 421 "Desktop.c"
}

static HeDesktopEnsorScheme*
_he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self)
{
	HeDesktopEnsorScheme* dup;
#line 107 "../lib/Utils/Desktop.vala"
	dup = g_new0 (HeDesktopEnsorScheme, 1);
#line 107 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (HeDesktopEnsorScheme));
#line 107 "../lib/Utils/Desktop.vala"
	return dup;
#line 434 "Desktop.c"
}

static gpointer
__he_desktop_ensor_scheme_dup0 (gpointer self)
{
#line 107 "../lib/Utils/Desktop.vala"
	return self ? _he_desktop_ensor_scheme_dup (self) : NULL;
#line 442 "Desktop.c"
}

static void
he_desktop_set_ensor_scheme (HeDesktop* self,
                             HeDesktopEnsorScheme value)
{
	HeDesktopEnsorScheme* _tmp0_;
#line 106 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 107 "../lib/Utils/Desktop.vala"
	_tmp0_ = __he_desktop_ensor_scheme_dup0 (&value);
#line 107 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_ensor_scheme);
#line 107 "../lib/Utils/Desktop.vala"
	self->priv->_ensor_scheme = _tmp0_;
#line 106 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY]);
#line 460 "Desktop.c"
}

static void
he_desktop_setup_ensor_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 111 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 469 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 113 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 113 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "ensor-scheme", &_inner_error0_);
#line 113 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 113 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 484 "Desktop.c"
			goto __catch0_g_error;
		}
#line 113 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 113 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 113 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (_tmp4_));
#line 113 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 118 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 118 "../lib/Utils/Desktop.vala"
		return;
#line 499 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 112 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 112 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 120 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 120 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 120 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:120: %s", _tmp6_);
#line 112 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 519 "Desktop.c"
	}
	__finally0:
#line 112 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 112 "../lib/Utils/Desktop.vala"
		return;
#line 530 "Desktop.c"
	}
#line 123 "../lib/Utils/Desktop.vala"
	he_desktop_set_ensor_scheme (self, HE_DESKTOP_ENSOR_SCHEME_DEFAULT);
#line 534 "Desktop.c"
}

HeColorRGBColor*
he_desktop_get_accent_color (HeDesktop* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
#line 131 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_accent_color;
#line 132 "../lib/Utils/Desktop.vala"
	result = _tmp0_;
#line 132 "../lib/Utils/Desktop.vala"
	return result;
#line 550 "Desktop.c"
}

static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
#line 135 "../lib/Utils/Desktop.vala"
	return self ? he_color_rgb_color_dup (self) : NULL;
#line 558 "Desktop.c"
}

void
he_desktop_set_accent_color (HeDesktop* self,
                             HeColorRGBColor* value)
{
	HeColorRGBColor* _tmp0_;
#line 134 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 135 "../lib/Utils/Desktop.vala"
	_tmp0_ = _he_color_rgb_color_dup0 (value);
#line 135 "../lib/Utils/Desktop.vala"
	_he_color_rgb_color_free0 (self->priv->_accent_color);
#line 135 "../lib/Utils/Desktop.vala"
	self->priv->_accent_color = _tmp0_;
#line 134 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY]);
#line 576 "Desktop.c"
}

static HeColorRGBColor*
he_desktop_parse_accent_color (HeDesktop* self,
                               GVariant* val)
{
	gdouble cr = 0.0;
	gdouble cg = 0.0;
	gdouble cb = 0.0;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp0_;
	GVariantIter* _tmp1_;
	gdouble _tmp2_ = 0.0;
	GVariantIter* _tmp3_;
	gdouble _tmp4_ = 0.0;
	GVariantIter* _tmp5_;
	gdouble _tmp6_ = 0.0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	HeColorRGBColor rgb_color = {0};
	HeColorRGBColor _tmp12_ = {0};
	HeColorRGBColor* _tmp13_;
	HeColorRGBColor* result;
#line 139 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 142 "../lib/Utils/Desktop.vala"
	cb = 0.0;
#line 144 "../lib/Utils/Desktop.vala"
	_tmp0_ = g_variant_iter_new (val);
#line 144 "../lib/Utils/Desktop.vala"
	iter = _tmp0_;
#line 145 "../lib/Utils/Desktop.vala"
	_tmp1_ = iter;
#line 145 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp1_, "d", &_tmp2_, NULL);
#line 145 "../lib/Utils/Desktop.vala"
	cr = _tmp2_;
#line 146 "../lib/Utils/Desktop.vala"
	_tmp3_ = iter;
#line 146 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp3_, "d", &_tmp4_, NULL);
#line 146 "../lib/Utils/Desktop.vala"
	cg = _tmp4_;
#line 147 "../lib/Utils/Desktop.vala"
	_tmp5_ = iter;
#line 147 "../lib/Utils/Desktop.vala"
	g_variant_iter_next (_tmp5_, "d", &_tmp6_, NULL);
#line 147 "../lib/Utils/Desktop.vala"
	cb = _tmp6_;
#line 150 "../lib/Utils/Desktop.vala"
	if (cr >= 0.0) {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp11_ = cr <= 1.0;
#line 635 "Desktop.c"
	} else {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp11_ = FALSE;
#line 639 "Desktop.c"
	}
#line 150 "../lib/Utils/Desktop.vala"
	if (_tmp11_) {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp10_ = cg >= 0.0;
#line 645 "Desktop.c"
	} else {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp10_ = FALSE;
#line 649 "Desktop.c"
	}
#line 150 "../lib/Utils/Desktop.vala"
	if (_tmp10_) {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp9_ = cg <= 1.0;
#line 655 "Desktop.c"
	} else {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp9_ = FALSE;
#line 659 "Desktop.c"
	}
#line 150 "../lib/Utils/Desktop.vala"
	if (_tmp9_) {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp8_ = cb >= 0.0;
#line 665 "Desktop.c"
	} else {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp8_ = FALSE;
#line 669 "Desktop.c"
	}
#line 150 "../lib/Utils/Desktop.vala"
	if (_tmp8_) {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp7_ = cb <= 1.0;
#line 675 "Desktop.c"
	} else {
#line 150 "../lib/Utils/Desktop.vala"
		_tmp7_ = FALSE;
#line 679 "Desktop.c"
	}
#line 150 "../lib/Utils/Desktop.vala"
	if (!_tmp7_) {
#line 151 "../lib/Utils/Desktop.vala"
		result = NULL;
#line 151 "../lib/Utils/Desktop.vala"
		_g_variant_iter_free0 (iter);
#line 151 "../lib/Utils/Desktop.vala"
		return result;
#line 689 "Desktop.c"
	}
#line 154 "../lib/Utils/Desktop.vala"
	_tmp12_.r = cr;
#line 154 "../lib/Utils/Desktop.vala"
	_tmp12_.g = cg;
#line 154 "../lib/Utils/Desktop.vala"
	_tmp12_.b = cb;
#line 154 "../lib/Utils/Desktop.vala"
	rgb_color = _tmp12_;
#line 160 "../lib/Utils/Desktop.vala"
	_tmp13_ = _he_color_rgb_color_dup0 (&rgb_color);
#line 160 "../lib/Utils/Desktop.vala"
	result = _tmp13_;
#line 160 "../lib/Utils/Desktop.vala"
	_g_variant_iter_free0 (iter);
#line 160 "../lib/Utils/Desktop.vala"
	return result;
#line 707 "Desktop.c"
}

static void
he_desktop_setup_accent_color (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 163 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 716 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* accent = NULL;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		HeColorRGBColor* _tmp5_;
		HeColorRGBColor* _tmp6_;
#line 165 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 165 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "accent-color", &_inner_error0_);
#line 165 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 165 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 734 "Desktop.c"
			goto __catch0_g_error;
		}
#line 165 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 165 "../lib/Utils/Desktop.vala"
		accent = _tmp3_;
#line 170 "../lib/Utils/Desktop.vala"
		_tmp4_ = accent;
#line 170 "../lib/Utils/Desktop.vala"
		_tmp5_ = he_desktop_parse_accent_color (self, _tmp4_);
#line 170 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_;
#line 170 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, _tmp6_);
#line 170 "../lib/Utils/Desktop.vala"
		_he_color_rgb_color_free0 (_tmp6_);
#line 172 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (accent);
#line 172 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 172 "../lib/Utils/Desktop.vala"
		return;
#line 757 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 164 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 164 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 174 "../lib/Utils/Desktop.vala"
		_tmp7_ = e;
#line 174 "../lib/Utils/Desktop.vala"
		_tmp8_ = _tmp7_->message;
#line 174 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:174: %s", _tmp8_);
#line 164 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 777 "Desktop.c"
	}
	__finally0:
#line 164 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../lib/Utils/Desktop.vala"
		return;
#line 788 "Desktop.c"
	}
#line 177 "../lib/Utils/Desktop.vala"
	he_desktop_set_accent_color (self, NULL);
#line 792 "Desktop.c"
}

gdouble
he_desktop_get_font_weight (HeDesktop* self)
{
	gdouble result;
#line 185 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 186 "../lib/Utils/Desktop.vala"
	result = self->priv->_font_weight;
#line 186 "../lib/Utils/Desktop.vala"
	return result;
#line 805 "Desktop.c"
}

void
he_desktop_set_font_weight (HeDesktop* self,
                            gdouble value)
{
#line 188 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 189 "../lib/Utils/Desktop.vala"
	self->priv->_font_weight = value;
#line 188 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY]);
#line 818 "Desktop.c"
}

static void
he_desktop_setup_font_weight (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 193 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 827 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		gdouble fw = 0.0;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		gdouble _tmp5_;
#line 195 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 195 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "font-weight", &_inner_error0_);
#line 195 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 195 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 844 "Desktop.c"
			goto __catch0_g_error;
		}
#line 195 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 195 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 195 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_variant_get_double (_tmp4_);
#line 195 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 195 "../lib/Utils/Desktop.vala"
		fw = _tmp5_;
#line 200 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, (gdouble) fw);
#line 202 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 202 "../lib/Utils/Desktop.vala"
		return;
#line 863 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 194 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 194 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 204 "../lib/Utils/Desktop.vala"
		_tmp6_ = e;
#line 204 "../lib/Utils/Desktop.vala"
		_tmp7_ = _tmp6_->message;
#line 204 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:204: %s", _tmp7_);
#line 194 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 883 "Desktop.c"
	}
	__finally0:
#line 194 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 194 "../lib/Utils/Desktop.vala"
		return;
#line 894 "Desktop.c"
	}
#line 207 "../lib/Utils/Desktop.vala"
	he_desktop_set_font_weight (self, 1.0);
#line 898 "Desktop.c"
}

gdouble
he_desktop_get_roundness (HeDesktop* self)
{
	gdouble result;
#line 215 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 216 "../lib/Utils/Desktop.vala"
	result = self->priv->_roundness;
#line 216 "../lib/Utils/Desktop.vala"
	return result;
#line 911 "Desktop.c"
}

void
he_desktop_set_roundness (HeDesktop* self,
                          gdouble value)
{
#line 218 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 219 "../lib/Utils/Desktop.vala"
	self->priv->_roundness = value;
#line 218 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ROUNDNESS_PROPERTY]);
#line 924 "Desktop.c"
}

static void
he_desktop_setup_roundness (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 223 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 933 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		gdouble round = 0.0;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		gdouble _tmp5_;
#line 225 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 225 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "roundness", &_inner_error0_);
#line 225 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 225 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 950 "Desktop.c"
			goto __catch0_g_error;
		}
#line 225 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 225 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 225 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_variant_get_double (_tmp4_);
#line 225 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 225 "../lib/Utils/Desktop.vala"
		round = _tmp5_;
#line 230 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, (gdouble) round);
#line 232 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 232 "../lib/Utils/Desktop.vala"
		return;
#line 969 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 224 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 224 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 234 "../lib/Utils/Desktop.vala"
		_tmp6_ = e;
#line 234 "../lib/Utils/Desktop.vala"
		_tmp7_ = _tmp6_->message;
#line 234 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:234: %s", _tmp7_);
#line 224 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 989 "Desktop.c"
	}
	__finally0:
#line 224 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 224 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 224 "../lib/Utils/Desktop.vala"
		return;
#line 1000 "Desktop.c"
	}
#line 237 "../lib/Utils/Desktop.vala"
	he_desktop_set_roundness (self, 1.0);
#line 1004 "Desktop.c"
}

HeDesktopContrastScheme
he_desktop_get_contrast (HeDesktop* self)
{
	HeDesktopContrastScheme result;
	HeDesktopContrastScheme* _tmp0_;
#line 245 "../lib/Utils/Desktop.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 246 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->_contrast;
#line 246 "../lib/Utils/Desktop.vala"
	result = *_tmp0_;
#line 246 "../lib/Utils/Desktop.vala"
	return result;
#line 1020 "Desktop.c"
}

static HeDesktopContrastScheme*
_he_desktop_contrast_scheme_dup (HeDesktopContrastScheme* self)
{
	HeDesktopContrastScheme* dup;
#line 249 "../lib/Utils/Desktop.vala"
	dup = g_new0 (HeDesktopContrastScheme, 1);
#line 249 "../lib/Utils/Desktop.vala"
	memcpy (dup, self, sizeof (HeDesktopContrastScheme));
#line 249 "../lib/Utils/Desktop.vala"
	return dup;
#line 1033 "Desktop.c"
}

static gpointer
__he_desktop_contrast_scheme_dup0 (gpointer self)
{
#line 249 "../lib/Utils/Desktop.vala"
	return self ? _he_desktop_contrast_scheme_dup (self) : NULL;
#line 1041 "Desktop.c"
}

void
he_desktop_set_contrast (HeDesktop* self,
                         HeDesktopContrastScheme value)
{
	HeDesktopContrastScheme* _tmp0_;
#line 248 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 249 "../lib/Utils/Desktop.vala"
	_tmp0_ = __he_desktop_contrast_scheme_dup0 (&value);
#line 249 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_contrast);
#line 249 "../lib/Utils/Desktop.vala"
	self->priv->_contrast = _tmp0_;
#line 248 "../lib/Utils/Desktop.vala"
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_CONTRAST_PROPERTY]);
#line 1059 "Desktop.c"
}

static void
he_desktop_setup_contrast (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
#line 252 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 1068 "Desktop.c"
	{
		GVariant* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 254 "../lib/Utils/Desktop.vala"
		_tmp1_ = self->priv->portal;
#line 254 "../lib/Utils/Desktop.vala"
		_tmp2_ = he_portal_settings_read (_tmp1_, "org.freedesktop.appearance", "contrast", &_inner_error0_);
#line 254 "../lib/Utils/Desktop.vala"
		_tmp0_ = _tmp2_;
#line 254 "../lib/Utils/Desktop.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "Desktop.c"
			goto __catch0_g_error;
		}
#line 254 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_variant_get_variant (_tmp0_);
#line 254 "../lib/Utils/Desktop.vala"
		_tmp4_ = _tmp3_;
#line 254 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, (HeDesktopContrastScheme) g_variant_get_uint32 (_tmp4_));
#line 254 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp4_);
#line 259 "../lib/Utils/Desktop.vala"
		_g_variant_unref0 (_tmp0_);
#line 259 "../lib/Utils/Desktop.vala"
		return;
#line 1098 "Desktop.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 253 "../lib/Utils/Desktop.vala"
		e = _inner_error0_;
#line 253 "../lib/Utils/Desktop.vala"
		_inner_error0_ = NULL;
#line 261 "../lib/Utils/Desktop.vala"
		_tmp5_ = e;
#line 261 "../lib/Utils/Desktop.vala"
		_tmp6_ = _tmp5_->message;
#line 261 "../lib/Utils/Desktop.vala"
		g_debug ("Desktop.vala:261: %s", _tmp6_);
#line 253 "../lib/Utils/Desktop.vala"
		_g_error_free0 (e);
#line 1118 "Desktop.c"
	}
	__finally0:
#line 253 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 253 "../lib/Utils/Desktop.vala"
		return;
#line 1129 "Desktop.c"
	}
#line 264 "../lib/Utils/Desktop.vala"
	he_desktop_set_contrast (self, HE_DESKTOP_CONTRAST_SCHEME_DEFAULT);
#line 1133 "Desktop.c"
}

static void
__lambda4_ (HeDesktop* self,
            const gchar* scheme,
            const gchar* key,
            GVariant* val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 268 "../lib/Utils/Desktop.vala"
	g_return_if_fail (scheme != NULL);
#line 268 "../lib/Utils/Desktop.vala"
	g_return_if_fail (key != NULL);
#line 268 "../lib/Utils/Desktop.vala"
	g_return_if_fail (val != NULL);
#line 269 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 269 "../lib/Utils/Desktop.vala"
		_tmp0_ = g_strcmp0 (key, "accent-color") == 0;
#line 1158 "Desktop.c"
	} else {
#line 269 "../lib/Utils/Desktop.vala"
		_tmp0_ = FALSE;
#line 1162 "Desktop.c"
	}
#line 269 "../lib/Utils/Desktop.vala"
	if (_tmp0_) {
#line 1166 "Desktop.c"
		HeColorRGBColor* _tmp1_;
		HeColorRGBColor* _tmp2_;
#line 270 "../lib/Utils/Desktop.vala"
		_tmp1_ = he_desktop_parse_accent_color (self, val);
#line 270 "../lib/Utils/Desktop.vala"
		_tmp2_ = _tmp1_;
#line 270 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, _tmp2_);
#line 270 "../lib/Utils/Desktop.vala"
		_he_color_rgb_color_free0 (_tmp2_);
#line 1177 "Desktop.c"
	}
#line 273 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 273 "../lib/Utils/Desktop.vala"
		_tmp3_ = g_strcmp0 (key, "font-weight") == 0;
#line 1183 "Desktop.c"
	} else {
#line 273 "../lib/Utils/Desktop.vala"
		_tmp3_ = FALSE;
#line 1187 "Desktop.c"
	}
#line 273 "../lib/Utils/Desktop.vala"
	if (_tmp3_) {
#line 274 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, (gdouble) g_variant_get_double (val));
#line 1193 "Desktop.c"
	}
#line 277 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 277 "../lib/Utils/Desktop.vala"
		_tmp4_ = g_strcmp0 (key, "roundness") == 0;
#line 1199 "Desktop.c"
	} else {
#line 277 "../lib/Utils/Desktop.vala"
		_tmp4_ = FALSE;
#line 1203 "Desktop.c"
	}
#line 277 "../lib/Utils/Desktop.vala"
	if (_tmp4_) {
#line 278 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, (gdouble) g_variant_get_double (val));
#line 1209 "Desktop.c"
	}
#line 281 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 281 "../lib/Utils/Desktop.vala"
		_tmp5_ = g_strcmp0 (key, "ensor-scheme") == 0;
#line 1215 "Desktop.c"
	} else {
#line 281 "../lib/Utils/Desktop.vala"
		_tmp5_ = FALSE;
#line 1219 "Desktop.c"
	}
#line 281 "../lib/Utils/Desktop.vala"
	if (_tmp5_) {
#line 282 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (val));
#line 1225 "Desktop.c"
	}
#line 285 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 285 "../lib/Utils/Desktop.vala"
		_tmp6_ = g_strcmp0 (key, "contrast") == 0;
#line 1231 "Desktop.c"
	} else {
#line 285 "../lib/Utils/Desktop.vala"
		_tmp6_ = FALSE;
#line 1235 "Desktop.c"
	}
#line 285 "../lib/Utils/Desktop.vala"
	if (_tmp6_) {
#line 286 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, (HeDesktopContrastScheme) g_variant_get_uint32 (val));
#line 1241 "Desktop.c"
	}
#line 289 "../lib/Utils/Desktop.vala"
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
#line 289 "../lib/Utils/Desktop.vala"
		_tmp7_ = g_strcmp0 (key, "color-scheme") == 0;
#line 1247 "Desktop.c"
	} else {
#line 289 "../lib/Utils/Desktop.vala"
		_tmp7_ = FALSE;
#line 1251 "Desktop.c"
	}
#line 289 "../lib/Utils/Desktop.vala"
	if (_tmp7_) {
#line 290 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (val));
#line 1257 "Desktop.c"
	}
}

static void
___lambda4__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                const gchar* namespace,
                                                const gchar* key,
                                                GVariant* val,
                                                gpointer self)
{
#line 268 "../lib/Utils/Desktop.vala"
	__lambda4_ ((HeDesktop*) self, namespace, key, val);
#line 1270 "Desktop.c"
}

static void
he_desktop_init_handle_settings_change (HeDesktop* self)
{
	HePortalSettings* _tmp0_;
#line 267 "../lib/Utils/Desktop.vala"
	g_return_if_fail (self != NULL);
#line 268 "../lib/Utils/Desktop.vala"
	_tmp0_ = self->priv->portal;
#line 268 "../lib/Utils/Desktop.vala"
	g_signal_connect_object (_tmp0_, "setting-changed", (GCallback) ___lambda4__he_portal_settings_setting_changed, self, 0);
#line 1283 "Desktop.c"
}

HeDesktop*
he_desktop_construct (GType object_type)
{
	HeDesktop * self = NULL;
#line 24 "../lib/Utils/Desktop.vala"
	self = (HeDesktop*) g_object_new (object_type, NULL);
#line 24 "../lib/Utils/Desktop.vala"
	return self;
#line 1294 "Desktop.c"
}

HeDesktop*
he_desktop_new (void)
{
#line 24 "../lib/Utils/Desktop.vala"
	return he_desktop_construct (HE_TYPE_DESKTOP);
#line 1302 "Desktop.c"
}

static GObject *
he_desktop_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
#line 295 "../lib/Utils/Desktop.vala"
	static GObject * HeDesktop_singleton__ref = NULL;
#line 295 "../lib/Utils/Desktop.vala"
	static GMutex HeDesktop_singleton__lock;
#line 295 "../lib/Utils/Desktop.vala"
	static volatile gsize HeDesktop_singleton__once = 0;
#line 1318 "Desktop.c"
	HeDesktop * self;
	HePortalSettings* _tmp0_ = NULL;
	HePortalSettings* _tmp1_;
	HePortalSettings* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 295 "../lib/Utils/Desktop.vala"
	if (g_once_init_enter (&HeDesktop_singleton__once)) {
#line 1326 "Desktop.c"
		g_mutex_init (&HeDesktop_singleton__lock);
		g_once_init_leave (&HeDesktop_singleton__once, 42);
	}
#line 295 "../lib/Utils/Desktop.vala"
	g_mutex_lock (&HeDesktop_singleton__lock);
#line 295 "../lib/Utils/Desktop.vala"
	if (HeDesktop_singleton__ref != NULL) {
#line 1334 "Desktop.c"
		g_object_ref (HeDesktop_singleton__ref);
		g_mutex_unlock (&HeDesktop_singleton__lock);
		return HeDesktop_singleton__ref;
	}
#line 295 "../lib/Utils/Desktop.vala"
	parent_class = G_OBJECT_CLASS (he_desktop_parent_class);
#line 295 "../lib/Utils/Desktop.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 295 "../lib/Utils/Desktop.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
#line 296 "../lib/Utils/Desktop.vala"
	_tmp1_ = he_portal_settings_get (&_inner_error0_);
#line 296 "../lib/Utils/Desktop.vala"
	_tmp0_ = _tmp1_;
#line 296 "../lib/Utils/Desktop.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../lib/Utils/Desktop.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 296 "../lib/Utils/Desktop.vala"
		g_clear_error (&_inner_error0_);
#line 1355 "Desktop.c"
	}
#line 296 "../lib/Utils/Desktop.vala"
	_tmp2_ = _tmp0_;
#line 296 "../lib/Utils/Desktop.vala"
	_tmp0_ = NULL;
#line 296 "../lib/Utils/Desktop.vala"
	_g_object_unref0 (self->priv->portal);
#line 296 "../lib/Utils/Desktop.vala"
	self->priv->portal = _tmp2_;
#line 297 "../lib/Utils/Desktop.vala"
	he_desktop_setup_prefers_color_scheme (self);
#line 298 "../lib/Utils/Desktop.vala"
	he_desktop_setup_contrast (self);
#line 299 "../lib/Utils/Desktop.vala"
	he_desktop_setup_roundness (self);
#line 300 "../lib/Utils/Desktop.vala"
	he_desktop_setup_accent_color (self);
#line 301 "../lib/Utils/Desktop.vala"
	he_desktop_setup_ensor_scheme (self);
#line 302 "../lib/Utils/Desktop.vala"
	he_desktop_setup_font_weight (self);
#line 303 "../lib/Utils/Desktop.vala"
	he_desktop_init_handle_settings_change (self);
#line 295 "../lib/Utils/Desktop.vala"
	_g_object_unref0 (_tmp0_);
#line 295 "../lib/Utils/Desktop.vala"
	HeDesktop_singleton__ref = obj;
#line 295 "../lib/Utils/Desktop.vala"
	g_object_add_weak_pointer (HeDesktop_singleton__ref, (gpointer) (&HeDesktop_singleton__ref));
#line 295 "../lib/Utils/Desktop.vala"
	g_mutex_unlock (&HeDesktop_singleton__lock);
#line 295 "../lib/Utils/Desktop.vala"
	return obj;
#line 1389 "Desktop.c"
}

static void
he_desktop_class_init (HeDesktopClass * klass,
                       gpointer klass_data)
{
#line 24 "../lib/Utils/Desktop.vala"
	he_desktop_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/Utils/Desktop.vala"
	g_type_class_adjust_private_offset (klass, &HeDesktop_private_offset);
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_desktop_get_property;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_desktop_set_property;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->constructor = he_desktop_constructor;
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (klass)->finalize = he_desktop_finalize;
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY] = g_param_spec_enum ("prefers-color-scheme", "prefers-color-scheme", "prefers-color-scheme", HE_DESKTOP_TYPE_COLOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ENSOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY] = g_param_spec_enum ("ensor-scheme", "ensor-scheme", "ensor-scheme", HE_DESKTOP_TYPE_ENSOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ACCENT_COLOR_PROPERTY, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_FONT_WEIGHT_PROPERTY, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY] = g_param_spec_double ("font-weight", "font-weight", "font-weight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ROUNDNESS_PROPERTY, he_desktop_properties[HE_DESKTOP_ROUNDNESS_PROPERTY] = g_param_spec_double ("roundness", "roundness", "roundness", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/Utils/Desktop.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_CONTRAST_PROPERTY, he_desktop_properties[HE_DESKTOP_CONTRAST_PROPERTY] = g_param_spec_enum ("contrast", "contrast", "contrast", HE_DESKTOP_TYPE_CONTRAST_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1420 "Desktop.c"
}

static void
he_desktop_instance_init (HeDesktop * self,
                          gpointer klass)
{
#line 24 "../lib/Utils/Desktop.vala"
	self->priv = he_desktop_get_instance_private (self);
#line 25 "../lib/Utils/Desktop.vala"
	self->priv->portal = NULL;
#line 48 "../lib/Utils/Desktop.vala"
	self->priv->_prefers_color_scheme = NULL;
#line 101 "../lib/Utils/Desktop.vala"
	self->priv->_ensor_scheme = NULL;
#line 183 "../lib/Utils/Desktop.vala"
	self->priv->_font_weight = 1.0;
#line 213 "../lib/Utils/Desktop.vala"
	self->priv->_roundness = 1.0;
#line 243 "../lib/Utils/Desktop.vala"
	self->priv->_contrast = NULL;
#line 1441 "Desktop.c"
}

static void
he_desktop_finalize (GObject * obj)
{
	HeDesktop * self;
#line 24 "../lib/Utils/Desktop.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
#line 25 "../lib/Utils/Desktop.vala"
	_g_object_unref0 (self->priv->portal);
#line 48 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_prefers_color_scheme);
#line 101 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_ensor_scheme);
#line 129 "../lib/Utils/Desktop.vala"
	_he_color_rgb_color_free0 (self->priv->_accent_color);
#line 243 "../lib/Utils/Desktop.vala"
	_g_free0 (self->priv->_contrast);
#line 24 "../lib/Utils/Desktop.vala"
	G_OBJECT_CLASS (he_desktop_parent_class)->finalize (obj);
#line 1462 "Desktop.c"
}

/**
* Helper class to deal with desktop-specific settings.
*/
static GType
he_desktop_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDesktopClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_desktop_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDesktop), 0, (GInstanceInitFunc) he_desktop_instance_init, NULL };
	GType he_desktop_type_id;
	he_desktop_type_id = g_type_register_static (G_TYPE_OBJECT, "HeDesktop", &g_define_type_info, 0);
	HeDesktop_private_offset = g_type_add_instance_private (he_desktop_type_id, sizeof (HeDesktopPrivate));
	return he_desktop_type_id;
}

GType
he_desktop_get_type (void)
{
	static volatile gsize he_desktop_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_type_id__once)) {
		GType he_desktop_type_id;
		he_desktop_type_id = he_desktop_get_type_once ();
		g_once_init_leave (&he_desktop_type_id__once, he_desktop_type_id);
	}
	return he_desktop_type_id__once;
}

static void
_vala_he_desktop_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
#line 24 "../lib/Utils/Desktop.vala"
	switch (property_id) {
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_enum (value, he_desktop_get_prefers_color_scheme (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_enum (value, he_desktop_get_ensor_scheme (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
#line 1514 "Desktop.c"
		{
			HeColorRGBColor* boxed;
#line 24 "../lib/Utils/Desktop.vala"
			boxed = he_desktop_get_accent_color (self);
#line 24 "../lib/Utils/Desktop.vala"
			g_value_set_boxed (value, boxed);
#line 1521 "Desktop.c"
		}
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_double (value, he_desktop_get_font_weight (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ROUNDNESS_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_double (value, he_desktop_get_roundness (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_CONTRAST_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		g_value_set_enum (value, he_desktop_get_contrast (self));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1543 "Desktop.c"
		default:
#line 24 "../lib/Utils/Desktop.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1549 "Desktop.c"
	}
}

static void
_vala_he_desktop_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
#line 24 "../lib/Utils/Desktop.vala"
	switch (property_id) {
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_prefers_color_scheme (self, g_value_get_enum (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_ensor_scheme (self, g_value_get_enum (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_accent_color (self, g_value_get_boxed (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_font_weight (self, g_value_get_double (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_ROUNDNESS_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_roundness (self, g_value_get_double (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 24 "../lib/Utils/Desktop.vala"
		case HE_DESKTOP_CONTRAST_PROPERTY:
#line 24 "../lib/Utils/Desktop.vala"
		he_desktop_set_contrast (self, g_value_get_enum (value));
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1599 "Desktop.c"
		default:
#line 24 "../lib/Utils/Desktop.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/Utils/Desktop.vala"
		break;
#line 1605 "Desktop.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

