/* ApplicationWindow.c generated by valac 0.56.14, the Vala compiler
 * generated from ApplicationWindow.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

enum  {
	HE_APPLICATION_WINDOW_0_PROPERTY,
	HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY,
	HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY,
	HE_APPLICATION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_application_window_properties[HE_APPLICATION_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeApplicationWindowPrivate {
	HeAppBar* title;
	gboolean _has_title;
	gboolean _has_back_button;
};

static gint HeApplicationWindow_private_offset;
static gpointer he_application_window_parent_class = NULL;

static GObject * he_application_window_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void he_application_window_finalize (GObject * obj);
static GType he_application_window_get_type_once (void);
static void _vala_he_application_window_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_he_application_window_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_application_window_get_instance_private (HeApplicationWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplicationWindow_private_offset);
}

/**
    * Creates a new ApplicationWindow.
    * @param app The application associated with this window.
    *
    * @since 1.0
    */
HeApplicationWindow*
he_application_window_construct (GType object_type,
                                 HeApplication* app)
{
	HeApplicationWindow * self = NULL;
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gboolean _tmp10_;
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 31 "../lib/Widgets/ApplicationWindow.vala"
	self = (HeApplicationWindow*) g_object_new (object_type, "application", app, NULL);
#line 33 "../lib/Widgets/ApplicationWindow.vala"
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) app);
#line 33 "../lib/Widgets/ApplicationWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 33 "../lib/Widgets/ApplicationWindow.vala"
	base_path = _tmp1_;
#line 34 "../lib/Widgets/ApplicationWindow.vala"
	_tmp2_ = base_path;
#line 34 "../lib/Widgets/ApplicationWindow.vala"
	if (_tmp2_ == NULL) {
#line 35 "../lib/Widgets/ApplicationWindow.vala"
		_g_free0 (base_path);
#line 35 "../lib/Widgets/ApplicationWindow.vala"
		return self;
#line 116 "ApplicationWindow.c"
	}
#line 38 "../lib/Widgets/ApplicationWindow.vala"
	_tmp3_ = base_path;
#line 38 "../lib/Widgets/ApplicationWindow.vala"
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
#line 38 "../lib/Widgets/ApplicationWindow.vala"
	base_uri = _tmp4_;
#line 39 "../lib/Widgets/ApplicationWindow.vala"
	_tmp5_ = base_uri;
#line 39 "../lib/Widgets/ApplicationWindow.vala"
	_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 39 "../lib/Widgets/ApplicationWindow.vala"
	base_file = _tmp6_;
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	_tmp7_ = base_file;
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	_tmp8_ = g_file_get_child (_tmp7_, "gtk/help-overlay.ui");
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	_tmp9_ = _tmp8_;
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	_tmp10_ = g_file_query_exists (_tmp9_, NULL);
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	_g_object_unref0 (_tmp9_);
#line 41 "../lib/Widgets/ApplicationWindow.vala"
	if (_tmp10_) {
#line 142 "ApplicationWindow.c"
		GtkBuilder* builder = NULL;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GtkBuilder* _tmp14_;
		GtkBuilder* _tmp15_;
		GtkBuilder* _tmp16_;
		GObject* _tmp17_;
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_tmp11_ = base_path;
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_tmp12_ = g_strconcat (_tmp11_, "/gtk/help-overlay.ui", NULL);
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_tmp13_ = _tmp12_;
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_tmp14_ = gtk_builder_new_from_file (_tmp13_);
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_tmp15_ = _tmp14_;
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		_g_free0 (_tmp13_);
#line 42 "../lib/Widgets/ApplicationWindow.vala"
		builder = _tmp15_;
#line 43 "../lib/Widgets/ApplicationWindow.vala"
		_tmp16_ = builder;
#line 43 "../lib/Widgets/ApplicationWindow.vala"
		_tmp17_ = gtk_builder_get_object (_tmp16_, "help_overlay");
#line 43 "../lib/Widgets/ApplicationWindow.vala"
		gtk_application_window_set_help_overlay ((GtkApplicationWindow*) self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gtk_shortcuts_window_get_type ()) ? ((GtkShortcutsWindow*) _tmp17_) : NULL);
#line 41 "../lib/Widgets/ApplicationWindow.vala"
		_g_object_unref0 (builder);
#line 173 "ApplicationWindow.c"
	}
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	_g_object_unref0 (base_file);
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	_g_free0 (base_uri);
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	_g_free0 (base_path);
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	return self;
#line 183 "ApplicationWindow.c"
}

HeApplicationWindow*
he_application_window_new (HeApplication* app)
{
#line 30 "../lib/Widgets/ApplicationWindow.vala"
	return he_application_window_construct (HE_TYPE_APPLICATION_WINDOW, app);
#line 191 "ApplicationWindow.c"
}

gboolean
he_application_window_get_has_title (HeApplicationWindow* self)
{
	gboolean result;
#line 54 "../lib/Widgets/ApplicationWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../lib/Widgets/ApplicationWindow.vala"
	result = self->priv->_has_title;
#line 55 "../lib/Widgets/ApplicationWindow.vala"
	return result;
#line 204 "ApplicationWindow.c"
}

void
he_application_window_set_has_title (HeApplicationWindow* self,
                                     gboolean value)
{
#line 57 "../lib/Widgets/ApplicationWindow.vala"
	g_return_if_fail (self != NULL);
#line 58 "../lib/Widgets/ApplicationWindow.vala"
	self->priv->_has_title = value;
#line 59 "../lib/Widgets/ApplicationWindow.vala"
	if (!value) {
#line 217 "ApplicationWindow.c"
		GtkBox* box = NULL;
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
#line 60 "../lib/Widgets/ApplicationWindow.vala"
		_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 60 "../lib/Widgets/ApplicationWindow.vala"
		g_object_ref_sink (_tmp0_);
#line 60 "../lib/Widgets/ApplicationWindow.vala"
		box = _tmp0_;
#line 61 "../lib/Widgets/ApplicationWindow.vala"
		_tmp1_ = box;
#line 61 "../lib/Widgets/ApplicationWindow.vala"
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
#line 59 "../lib/Widgets/ApplicationWindow.vala"
		_g_object_unref0 (box);
#line 233 "ApplicationWindow.c"
	} else {
		HeAppBar* _tmp2_;
		HeAppBar* _tmp3_;
#line 63 "../lib/Widgets/ApplicationWindow.vala"
		_tmp2_ = self->priv->title;
#line 63 "../lib/Widgets/ApplicationWindow.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "flat");
#line 64 "../lib/Widgets/ApplicationWindow.vala"
		_tmp3_ = self->priv->title;
#line 64 "../lib/Widgets/ApplicationWindow.vala"
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp3_);
#line 245 "ApplicationWindow.c"
	}
#line 57 "../lib/Widgets/ApplicationWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY]);
#line 249 "ApplicationWindow.c"
}

gboolean
he_application_window_get_has_back_button (HeApplicationWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 74 "../lib/Widgets/ApplicationWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../lib/Widgets/ApplicationWindow.vala"
	_tmp0_ = he_application_window_get_has_back_button (self);
#line 75 "../lib/Widgets/ApplicationWindow.vala"
	_tmp1_ = _tmp0_;
#line 75 "../lib/Widgets/ApplicationWindow.vala"
	result = _tmp1_;
#line 75 "../lib/Widgets/ApplicationWindow.vala"
	return result;
#line 268 "ApplicationWindow.c"
}

void
he_application_window_set_has_back_button (HeApplicationWindow* self,
                                           gboolean value)
{
	HeAppBar* _tmp0_;
#line 77 "../lib/Widgets/ApplicationWindow.vala"
	g_return_if_fail (self != NULL);
#line 78 "../lib/Widgets/ApplicationWindow.vala"
	self->priv->_has_back_button = value;
#line 79 "../lib/Widgets/ApplicationWindow.vala"
	_tmp0_ = self->priv->title;
#line 79 "../lib/Widgets/ApplicationWindow.vala"
	he_app_bar_set_show_back (_tmp0_, value);
#line 77 "../lib/Widgets/ApplicationWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY]);
#line 286 "ApplicationWindow.c"
}

static GObject *
he_application_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeApplicationWindow * self;
#line 83 "../lib/Widgets/ApplicationWindow.vala"
	parent_class = G_OBJECT_CLASS (he_application_window_parent_class);
#line 83 "../lib/Widgets/ApplicationWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 83 "../lib/Widgets/ApplicationWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
#line 84 "../lib/Widgets/ApplicationWindow.vala"
	he_application_window_set_has_title (self, FALSE);
#line 85 "../lib/Widgets/ApplicationWindow.vala"
	he_application_window_set_has_back_button (self, FALSE);
#line 83 "../lib/Widgets/ApplicationWindow.vala"
	return obj;
#line 309 "ApplicationWindow.c"
}

static void
he_application_window_class_init (HeApplicationWindowClass * klass,
                                  gpointer klass_data)
{
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	he_application_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeApplicationWindow_private_offset);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_window_get_property;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_window_set_property;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_application_window_constructor;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_application_window_finalize;
#line 328 "ApplicationWindow.c"
	/**
	    * Whether this window should display a title.
	    */
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY] = g_param_spec_boolean ("has-title", "has-title", "has-title", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 334 "ApplicationWindow.c"
	/**
	    * Whether this window should display a back button.
	    */
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY] = g_param_spec_boolean ("has-back-button", "has-back-button", "has-back-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 340 "ApplicationWindow.c"
}

static void
he_application_window_instance_init (HeApplicationWindow * self,
                                     gpointer klass)
{
	HeAppBar* _tmp0_;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	self->priv = he_application_window_get_instance_private (self);
#line 47 "../lib/Widgets/ApplicationWindow.vala"
	_tmp0_ = he_app_bar_new ();
#line 47 "../lib/Widgets/ApplicationWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 47 "../lib/Widgets/ApplicationWindow.vala"
	self->priv->title = _tmp0_;
#line 356 "ApplicationWindow.c"
}

static void
he_application_window_finalize (GObject * obj)
{
	HeApplicationWindow * self;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
#line 47 "../lib/Widgets/ApplicationWindow.vala"
	_g_object_unref0 (self->priv->title);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	G_OBJECT_CLASS (he_application_window_parent_class)->finalize (obj);
#line 369 "ApplicationWindow.c"
}

/**
* An ApplicationWindow is a Window for holding the main content of an application.
*/
static GType
he_application_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplicationWindow), 0, (GInstanceInitFunc) he_application_window_instance_init, NULL };
	GType he_application_window_type_id;
	he_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "HeApplicationWindow", &g_define_type_info, 0);
	HeApplicationWindow_private_offset = g_type_add_instance_private (he_application_window_type_id, sizeof (HeApplicationWindowPrivate));
	return he_application_window_type_id;
}

GType
he_application_window_get_type (void)
{
	static volatile gsize he_application_window_type_id__once = 0;
	if (g_once_init_enter (&he_application_window_type_id__once)) {
		GType he_application_window_type_id;
		he_application_window_type_id = he_application_window_get_type_once ();
		g_once_init_leave (&he_application_window_type_id__once, he_application_window_type_id);
	}
	return he_application_window_type_id__once;
}

static void
_vala_he_application_window_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	HeApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		case HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		g_value_set_boolean (value, he_application_window_get_has_title (self));
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		case HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		g_value_set_boolean (value, he_application_window_get_has_back_button (self));
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 419 "ApplicationWindow.c"
		default:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 425 "ApplicationWindow.c"
	}
}

static void
_vala_he_application_window_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	HeApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		case HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		he_application_window_set_has_title (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		case HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		he_application_window_set_has_back_button (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 451 "ApplicationWindow.c"
		default:
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/ApplicationWindow.vala"
		break;
#line 457 "ApplicationWindow.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

