/* Avatar.c generated by valac 0.56.14, the Vala compiler
 * generated from Avatar.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>

enum  {
	HE_AVATAR_0_PROPERTY,
	HE_AVATAR_SIZE_PROPERTY,
	HE_AVATAR_TEXT_PROPERTY,
	HE_AVATAR_STATUS_PROPERTY,
	HE_AVATAR_IMAGE_PROPERTY,
	HE_AVATAR_NUM_PROPERTIES
};
static GParamSpec* he_avatar_properties[HE_AVATAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeAvatarPrivate {
	gchar* _image;
	gint _size;
	gchar* _text;
	gboolean _status;
	GtkImage* img;
	GtkImage* img_blur;
	GtkLabel* label;
	HeModifierBadge* status_badge;
};

static gint HeAvatar_private_offset;
static gpointer he_avatar_parent_class = NULL;

VALA_EXTERN void he_misc_init_css_provider_from_string (GtkCssProvider* provider,
                                            const gchar* css);
static gchar* he_avatar_extract_initials (HeAvatar* self,
                                   const gchar* t);
static GObject * he_avatar_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void he_avatar_finalize (GObject * obj);
static GType he_avatar_get_type_once (void);
static void _vala_he_avatar_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_avatar_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_avatar_get_instance_private (HeAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, HeAvatar_private_offset);
}

gint
he_avatar_get_size (HeAvatar* self)
{
	gint result;
#line 39 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../lib/Widgets/Avatar.vala"
	result = self->priv->_size;
#line 40 "../lib/Widgets/Avatar.vala"
	return result;
#line 93 "Avatar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../lib/Widgets/Avatar.vala"
	return self ? g_object_ref (self) : NULL;
#line 101 "Avatar.c"
}

void
he_avatar_set_size (HeAvatar* self,
                    gint value)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkCssProvider* css_provider_label = NULL;
	GtkCssProvider* _tmp2_;
	gchar* css = NULL;
	gchar* _tmp3_;
	GtkStyleContext* context_label = NULL;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
#line 42 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 43 "../lib/Widgets/Avatar.vala"
	self->priv->_size = value;
#line 44 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, value, value);
#line 45 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->img;
#line 45 "../lib/Widgets/Avatar.vala"
	gtk_image_set_pixel_size (_tmp0_, value);
#line 46 "../lib/Widgets/Avatar.vala"
	_tmp1_ = self->priv->img_blur;
#line 46 "../lib/Widgets/Avatar.vala"
	gtk_image_set_pixel_size (_tmp1_, value);
#line 48 "../lib/Widgets/Avatar.vala"
	_tmp2_ = gtk_css_provider_new ();
#line 48 "../lib/Widgets/Avatar.vala"
	css_provider_label = _tmp2_;
#line 49 "../lib/Widgets/Avatar.vala"
	_tmp3_ = g_strdup_printf ("\n" \
"                .avatar-label {\n" \
"                    font-size: %0.2fpx;\n" \
"                    font-weight: 700;\n" \
"                    color: @accent_fg_color;\n" \
"                }\n" \
"            ", (self->priv->_size / 16) * 7.5);
#line 49 "../lib/Widgets/Avatar.vala"
	css = _tmp3_;
#line 56 "../lib/Widgets/Avatar.vala"
	he_misc_init_css_provider_from_string (css_provider_label, css);
#line 57 "../lib/Widgets/Avatar.vala"
	_tmp4_ = self->priv->label;
#line 57 "../lib/Widgets/Avatar.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 57 "../lib/Widgets/Avatar.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 57 "../lib/Widgets/Avatar.vala"
	context_label = _tmp6_;
#line 58 "../lib/Widgets/Avatar.vala"
	gtk_style_context_add_provider (context_label, (GtkStyleProvider*) css_provider_label, (guint) 69);
#line 42 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (context_label);
#line 42 "../lib/Widgets/Avatar.vala"
	_g_free0 (css);
#line 42 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (css_provider_label);
#line 42 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY]);
#line 160 "Avatar.c"
}

const gchar*
he_avatar_get_text (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_text;
#line 67 "../lib/Widgets/Avatar.vala"
	result = _tmp0_;
#line 67 "../lib/Widgets/Avatar.vala"
	return result;
#line 176 "Avatar.c"
}

void
he_avatar_set_text (HeAvatar* self,
                    const gchar* value)
{
	gchar* _tmp0_;
#line 69 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 70 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup (value);
#line 70 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_text);
#line 70 "../lib/Widgets/Avatar.vala"
	self->priv->_text = _tmp0_;
#line 71 "../lib/Widgets/Avatar.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 194 "Avatar.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 72 "../lib/Widgets/Avatar.vala"
		_tmp1_ = self->priv->label;
#line 72 "../lib/Widgets/Avatar.vala"
		_tmp2_ = he_avatar_extract_initials (self, value);
#line 72 "../lib/Widgets/Avatar.vala"
		_tmp3_ = _tmp2_;
#line 72 "../lib/Widgets/Avatar.vala"
		gtk_label_set_label (_tmp1_, _tmp3_);
#line 72 "../lib/Widgets/Avatar.vala"
		_g_free0 (_tmp3_);
#line 208 "Avatar.c"
	}
#line 69 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY]);
#line 212 "Avatar.c"
}

gboolean
he_avatar_get_status (HeAvatar* self)
{
	gboolean result;
#line 82 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../lib/Widgets/Avatar.vala"
	result = self->priv->_status;
#line 83 "../lib/Widgets/Avatar.vala"
	return result;
#line 225 "Avatar.c"
}

void
he_avatar_set_status (HeAvatar* self,
                      gboolean value)
{
#line 85 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 86 "../lib/Widgets/Avatar.vala"
	self->priv->_status = value;
#line 87 "../lib/Widgets/Avatar.vala"
	if (value) {
#line 238 "Avatar.c"
		HeModifierBadge* _tmp0_;
#line 88 "../lib/Widgets/Avatar.vala"
		_tmp0_ = self->priv->status_badge;
#line 88 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 244 "Avatar.c"
	} else {
		HeModifierBadge* _tmp1_;
#line 90 "../lib/Widgets/Avatar.vala"
		_tmp1_ = self->priv->status_badge;
#line 90 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 251 "Avatar.c"
	}
#line 85 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_STATUS_PROPERTY]);
#line 255 "Avatar.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 272 "Avatar.c"
}

static gchar*
he_avatar_extract_initials (HeAvatar* self,
                            const gchar* t)
{
	gchar* ret = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 95 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (t != NULL, NULL);
#line 96 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup ("");
#line 96 "../lib/Widgets/Avatar.vala"
	ret = _tmp0_;
#line 98 "../lib/Widgets/Avatar.vala"
	_tmp1_ = strlen (t);
#line 98 "../lib/Widgets/Avatar.vala"
	_tmp2_ = _tmp1_;
#line 98 "../lib/Widgets/Avatar.vala"
	if (_tmp2_ == 0) {
#line 304 "Avatar.c"
		gchar* _tmp3_;
#line 99 "../lib/Widgets/Avatar.vala"
		_tmp3_ = g_strdup ("");
#line 99 "../lib/Widgets/Avatar.vala"
		result = _tmp3_;
#line 99 "../lib/Widgets/Avatar.vala"
		_g_free0 (ret);
#line 99 "../lib/Widgets/Avatar.vala"
		return result;
#line 314 "Avatar.c"
	}
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp4_ = ret;
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp5_ = g_strdup_printf ("%c", string_get (t, (glong) 0));
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp6_ = _tmp5_;
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp7_ = g_utf8_strup (_tmp6_, (gssize) -1);
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp8_ = _tmp7_;
#line 101 "../lib/Widgets/Avatar.vala"
	_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 101 "../lib/Widgets/Avatar.vala"
	_g_free0 (ret);
#line 101 "../lib/Widgets/Avatar.vala"
	ret = _tmp9_;
#line 101 "../lib/Widgets/Avatar.vala"
	_g_free0 (_tmp8_);
#line 101 "../lib/Widgets/Avatar.vala"
	_g_free0 (_tmp6_);
#line 336 "Avatar.c"
	{
		gint i = 0;
#line 103 "../lib/Widgets/Avatar.vala"
		i = 1;
#line 341 "Avatar.c"
		{
			gboolean _tmp10_ = FALSE;
#line 103 "../lib/Widgets/Avatar.vala"
			_tmp10_ = TRUE;
#line 103 "../lib/Widgets/Avatar.vala"
			while (TRUE) {
#line 348 "Avatar.c"
				gint _tmp12_;
				gint _tmp13_;
#line 103 "../lib/Widgets/Avatar.vala"
				if (!_tmp10_) {
#line 353 "Avatar.c"
					gint _tmp11_;
#line 103 "../lib/Widgets/Avatar.vala"
					_tmp11_ = i;
#line 103 "../lib/Widgets/Avatar.vala"
					i = _tmp11_ + 1;
#line 359 "Avatar.c"
				}
#line 103 "../lib/Widgets/Avatar.vala"
				_tmp10_ = FALSE;
#line 103 "../lib/Widgets/Avatar.vala"
				_tmp12_ = strlen (t);
#line 103 "../lib/Widgets/Avatar.vala"
				_tmp13_ = _tmp12_;
#line 103 "../lib/Widgets/Avatar.vala"
				if (!(i < (_tmp13_ - 1))) {
#line 103 "../lib/Widgets/Avatar.vala"
					break;
#line 371 "Avatar.c"
				}
#line 104 "../lib/Widgets/Avatar.vala"
				if (string_get (t, (glong) i) == ' ') {
#line 375 "Avatar.c"
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp14_ = ret;
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp15_ = g_strdup_printf ("%c", string_get (t, (glong) (i + 1)));
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp16_ = _tmp15_;
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp17_ = g_utf8_strup (_tmp16_, (gssize) -1);
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp18_ = _tmp17_;
#line 105 "../lib/Widgets/Avatar.vala"
					_tmp19_ = g_strconcat (_tmp14_, _tmp18_, NULL);
#line 105 "../lib/Widgets/Avatar.vala"
					_g_free0 (ret);
#line 105 "../lib/Widgets/Avatar.vala"
					ret = _tmp19_;
#line 105 "../lib/Widgets/Avatar.vala"
					_g_free0 (_tmp18_);
#line 105 "../lib/Widgets/Avatar.vala"
					_g_free0 (_tmp16_);
#line 402 "Avatar.c"
				}
			}
		}
	}
#line 107 "../lib/Widgets/Avatar.vala"
	result = ret;
#line 107 "../lib/Widgets/Avatar.vala"
	return result;
#line 411 "Avatar.c"
}

const gchar*
he_avatar_get_image (HeAvatar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 114 "../lib/Widgets/Avatar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->_image;
#line 115 "../lib/Widgets/Avatar.vala"
	result = _tmp0_;
#line 115 "../lib/Widgets/Avatar.vala"
	return result;
#line 427 "Avatar.c"
}

void
he_avatar_set_image (HeAvatar* self,
                     const gchar* value)
{
	gchar* _tmp0_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp3_;
	gchar* css = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GtkCssProvider* _tmp6_;
	const gchar* _tmp7_;
	GtkStyleContext* context = NULL;
	GtkImage* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkCssProvider* _tmp12_;
	GtkCssProvider* css_provider_blur = NULL;
	GtkCssProvider* _tmp13_;
	GtkStyleContext* context_blur = NULL;
	GtkImage* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkCssProvider* _tmp25_;
#line 117 "../lib/Widgets/Avatar.vala"
	g_return_if_fail (self != NULL);
#line 118 "../lib/Widgets/Avatar.vala"
	_tmp0_ = g_strdup (value);
#line 118 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_image);
#line 118 "../lib/Widgets/Avatar.vala"
	self->priv->_image = _tmp0_;
#line 120 "../lib/Widgets/Avatar.vala"
	if (g_strcmp0 (value, "") != 0) {
#line 465 "Avatar.c"
		GtkLabel* _tmp1_;
#line 121 "../lib/Widgets/Avatar.vala"
		_tmp1_ = self->priv->label;
#line 121 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 471 "Avatar.c"
	} else {
		GtkLabel* _tmp2_;
#line 123 "../lib/Widgets/Avatar.vala"
		_tmp2_ = self->priv->label;
#line 123 "../lib/Widgets/Avatar.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 478 "Avatar.c"
	}
#line 126 "../lib/Widgets/Avatar.vala"
	_tmp3_ = gtk_css_provider_new ();
#line 126 "../lib/Widgets/Avatar.vala"
	css_provider = _tmp3_;
#line 127 "../lib/Widgets/Avatar.vala"
	_tmp4_ = self->priv->_image;
#line 127 "../lib/Widgets/Avatar.vala"
	_tmp5_ = g_strdup_printf ("\n" \
"            .avatar {\n" \
"                background-image: url('%s');\n" \
"                background-size: cover;\n" \
"                background-color: @accent_bg_color;\n" \
"                border-radius: 999px;\n" \
"                box-shadow: inset 0 0 0 1px @borders;\n" \
"            }\n" \
"            ", _tmp4_);
#line 127 "../lib/Widgets/Avatar.vala"
	css = _tmp5_;
#line 136 "../lib/Widgets/Avatar.vala"
	_tmp6_ = css_provider;
#line 136 "../lib/Widgets/Avatar.vala"
	_tmp7_ = css;
#line 136 "../lib/Widgets/Avatar.vala"
	he_misc_init_css_provider_from_string (_tmp6_, _tmp7_);
#line 137 "../lib/Widgets/Avatar.vala"
	_tmp8_ = self->priv->img;
#line 137 "../lib/Widgets/Avatar.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 137 "../lib/Widgets/Avatar.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 137 "../lib/Widgets/Avatar.vala"
	context = _tmp10_;
#line 138 "../lib/Widgets/Avatar.vala"
	_tmp11_ = context;
#line 138 "../lib/Widgets/Avatar.vala"
	_tmp12_ = css_provider;
#line 138 "../lib/Widgets/Avatar.vala"
	gtk_style_context_add_provider (_tmp11_, (GtkStyleProvider*) _tmp12_, (guint) 69);
#line 140 "../lib/Widgets/Avatar.vala"
	_tmp13_ = gtk_css_provider_new ();
#line 140 "../lib/Widgets/Avatar.vala"
	css_provider_blur = _tmp13_;
#line 141 "../lib/Widgets/Avatar.vala"
	if (self->priv->_size <= 32) {
#line 516 "Avatar.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GtkCssProvider* _tmp16_;
		const gchar* _tmp17_;
#line 142 "../lib/Widgets/Avatar.vala"
		_tmp14_ = self->priv->_image;
#line 142 "../lib/Widgets/Avatar.vala"
		_tmp15_ = g_strdup_printf ("\n" \
"                .avatar-blur {\n" \
"                    background-image: url('%s');\n" \
"                    background-size: cover;\n" \
"                    background-color: @accent_bg_color;\n" \
"                    border-radius: 999px;\n" \
"                    box-shadow: inset 0 0 0 1px @borders;\n" \
"                    filter: drop-shadow(0px 0px 1px @borders);\n" \
"                }\n" \
"                ", _tmp14_);
#line 142 "../lib/Widgets/Avatar.vala"
		_g_free0 (css);
#line 142 "../lib/Widgets/Avatar.vala"
		css = _tmp15_;
#line 152 "../lib/Widgets/Avatar.vala"
		_tmp16_ = css_provider_blur;
#line 152 "../lib/Widgets/Avatar.vala"
		_tmp17_ = css;
#line 152 "../lib/Widgets/Avatar.vala"
		he_misc_init_css_provider_from_string (_tmp16_, _tmp17_);
#line 535 "Avatar.c"
	} else {
		const gchar* _tmp18_;
		gchar* _tmp19_;
		GtkCssProvider* _tmp20_;
		const gchar* _tmp21_;
#line 154 "../lib/Widgets/Avatar.vala"
		_tmp18_ = self->priv->_image;
#line 154 "../lib/Widgets/Avatar.vala"
		_tmp19_ = g_strdup_printf ("\n" \
"                .avatar-blur {\n" \
"                    background-image: url('%s');\n" \
"                    background-size: cover;\n" \
"                    background-color: @accent_bg_color;\n" \
"                    border-radius: 999px;\n" \
"                    box-shadow: inset 0 0 0 1px @borders;\n" \
"                    filter: drop-shadow(0px 0px 1px @borders) blur(2px" \
");\n" \
"                }\n" \
"                ", _tmp18_);
#line 154 "../lib/Widgets/Avatar.vala"
		_g_free0 (css);
#line 154 "../lib/Widgets/Avatar.vala"
		css = _tmp19_;
#line 164 "../lib/Widgets/Avatar.vala"
		_tmp20_ = css_provider_blur;
#line 164 "../lib/Widgets/Avatar.vala"
		_tmp21_ = css;
#line 164 "../lib/Widgets/Avatar.vala"
		he_misc_init_css_provider_from_string (_tmp20_, _tmp21_);
#line 555 "Avatar.c"
	}
#line 166 "../lib/Widgets/Avatar.vala"
	_tmp22_ = self->priv->img_blur;
#line 166 "../lib/Widgets/Avatar.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
#line 166 "../lib/Widgets/Avatar.vala"
	_tmp24_ = _g_object_ref0 (_tmp23_);
#line 166 "../lib/Widgets/Avatar.vala"
	context_blur = _tmp24_;
#line 167 "../lib/Widgets/Avatar.vala"
	_tmp25_ = css_provider_blur;
#line 167 "../lib/Widgets/Avatar.vala"
	gtk_style_context_add_provider (context_blur, (GtkStyleProvider*) _tmp25_, (guint) 69);
#line 117 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (context_blur);
#line 117 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (css_provider_blur);
#line 117 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (context);
#line 117 "../lib/Widgets/Avatar.vala"
	_g_free0 (css);
#line 117 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (css_provider);
#line 117 "../lib/Widgets/Avatar.vala"
	g_object_notify_by_pspec ((GObject *) self, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY]);
#line 581 "Avatar.c"
}

/**
    * Creates a new Avatar.
    * @param image The image to display
    *
    * @since 1.1
    */
HeAvatar*
he_avatar_construct (GType object_type,
                     gint size,
                     const gchar* image,
                     const gchar* text,
                     gboolean* status)
{
	HeAvatar * self = NULL;
#line 179 "../lib/Widgets/Avatar.vala"
	self = (HeAvatar*) he_bin_construct (object_type);
#line 181 "../lib/Widgets/Avatar.vala"
	he_avatar_set_image (self, image);
#line 182 "../lib/Widgets/Avatar.vala"
	he_avatar_set_text (self, text);
#line 183 "../lib/Widgets/Avatar.vala"
	he_avatar_set_size (self, size);
#line 184 "../lib/Widgets/Avatar.vala"
	he_avatar_set_status (self, *status);
#line 178 "../lib/Widgets/Avatar.vala"
	return self;
#line 610 "Avatar.c"
}

HeAvatar*
he_avatar_new (gint size,
               const gchar* image,
               const gchar* text,
               gboolean* status)
{
#line 178 "../lib/Widgets/Avatar.vala"
	return he_avatar_construct (HE_TYPE_AVATAR, size, image, text, status);
#line 621 "Avatar.c"
}

static GObject *
he_avatar_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAvatar * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	HeModifierBadge* _tmp11_;
	HeModifierBadge* _tmp12_;
	HeModifierBadge* _tmp13_;
	HeModifierBadge* _tmp14_;
	GtkOverlay* ioverlay = NULL;
	GtkOverlay* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkImage* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* loverlay = NULL;
	GtkOverlay* _tmp20_;
	GtkOverlay* _tmp21_;
	GtkOverlay* _tmp22_;
	GtkOverlay* _tmp23_;
	GtkLabel* _tmp24_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp25_;
	GtkOverlay* _tmp26_;
	GtkOverlay* _tmp27_;
	GtkOverlay* _tmp28_;
	HeModifierBadge* _tmp29_;
	GtkOverlay* _tmp30_;
#line 187 "../lib/Widgets/Avatar.vala"
	parent_class = G_OBJECT_CLASS (he_avatar_parent_class);
#line 187 "../lib/Widgets/Avatar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 187 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
#line 188 "../lib/Widgets/Avatar.vala"
	_tmp0_ = self->priv->img;
#line 188 "../lib/Widgets/Avatar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "avatar");
#line 189 "../lib/Widgets/Avatar.vala"
	_tmp1_ = self->priv->img;
#line 189 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 190 "../lib/Widgets/Avatar.vala"
	_tmp2_ = self->priv->img;
#line 190 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 192 "../lib/Widgets/Avatar.vala"
	_tmp3_ = self->priv->img_blur;
#line 192 "../lib/Widgets/Avatar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "avatar-blur");
#line 193 "../lib/Widgets/Avatar.vala"
	_tmp4_ = self->priv->img_blur;
#line 193 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 194 "../lib/Widgets/Avatar.vala"
	_tmp5_ = self->priv->img_blur;
#line 194 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
#line 196 "../lib/Widgets/Avatar.vala"
	_tmp6_ = self->priv->label;
#line 196 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 197 "../lib/Widgets/Avatar.vala"
	_tmp7_ = self->priv->label;
#line 197 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 198 "../lib/Widgets/Avatar.vala"
	_tmp8_ = self->priv->label;
#line 198 "../lib/Widgets/Avatar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "dim-label");
#line 199 "../lib/Widgets/Avatar.vala"
	_tmp9_ = self->priv->label;
#line 199 "../lib/Widgets/Avatar.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "avatar-label");
#line 200 "../lib/Widgets/Avatar.vala"
	_tmp10_ = self->priv->label;
#line 200 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 202 "../lib/Widgets/Avatar.vala"
	_tmp11_ = self->priv->status_badge;
#line 202 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_END);
#line 203 "../lib/Widgets/Avatar.vala"
	_tmp12_ = self->priv->status_badge;
#line 203 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
#line 204 "../lib/Widgets/Avatar.vala"
	_tmp13_ = self->priv->status_badge;
#line 204 "../lib/Widgets/Avatar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 205 "../lib/Widgets/Avatar.vala"
	_tmp14_ = self->priv->status_badge;
#line 205 "../lib/Widgets/Avatar.vala"
	he_modifier_badge_set_color (_tmp14_, HE_COLORS_GREEN);
#line 207 "../lib/Widgets/Avatar.vala"
	_tmp15_ = (GtkOverlay*) gtk_overlay_new ();
#line 207 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp15_);
#line 207 "../lib/Widgets/Avatar.vala"
	ioverlay = _tmp15_;
#line 208 "../lib/Widgets/Avatar.vala"
	_tmp16_ = ioverlay;
#line 208 "../lib/Widgets/Avatar.vala"
	_tmp17_ = self->priv->img_blur;
#line 208 "../lib/Widgets/Avatar.vala"
	gtk_overlay_set_child (_tmp16_, (GtkWidget*) _tmp17_);
#line 209 "../lib/Widgets/Avatar.vala"
	_tmp18_ = ioverlay;
#line 209 "../lib/Widgets/Avatar.vala"
	_tmp19_ = self->priv->img;
#line 209 "../lib/Widgets/Avatar.vala"
	gtk_overlay_add_overlay (_tmp18_, (GtkWidget*) _tmp19_);
#line 211 "../lib/Widgets/Avatar.vala"
	_tmp20_ = (GtkOverlay*) gtk_overlay_new ();
#line 211 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp20_);
#line 211 "../lib/Widgets/Avatar.vala"
	loverlay = _tmp20_;
#line 212 "../lib/Widgets/Avatar.vala"
	_tmp21_ = loverlay;
#line 212 "../lib/Widgets/Avatar.vala"
	_tmp22_ = ioverlay;
#line 212 "../lib/Widgets/Avatar.vala"
	gtk_overlay_set_child (_tmp21_, (GtkWidget*) _tmp22_);
#line 213 "../lib/Widgets/Avatar.vala"
	_tmp23_ = loverlay;
#line 213 "../lib/Widgets/Avatar.vala"
	_tmp24_ = self->priv->label;
#line 213 "../lib/Widgets/Avatar.vala"
	gtk_overlay_add_overlay (_tmp23_, (GtkWidget*) _tmp24_);
#line 215 "../lib/Widgets/Avatar.vala"
	_tmp25_ = (GtkOverlay*) gtk_overlay_new ();
#line 215 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp25_);
#line 215 "../lib/Widgets/Avatar.vala"
	overlay = _tmp25_;
#line 216 "../lib/Widgets/Avatar.vala"
	_tmp26_ = overlay;
#line 216 "../lib/Widgets/Avatar.vala"
	_tmp27_ = loverlay;
#line 216 "../lib/Widgets/Avatar.vala"
	gtk_overlay_set_child (_tmp26_, (GtkWidget*) _tmp27_);
#line 217 "../lib/Widgets/Avatar.vala"
	_tmp28_ = overlay;
#line 217 "../lib/Widgets/Avatar.vala"
	_tmp29_ = self->priv->status_badge;
#line 217 "../lib/Widgets/Avatar.vala"
	gtk_overlay_add_overlay (_tmp28_, (GtkWidget*) _tmp29_);
#line 219 "../lib/Widgets/Avatar.vala"
	_tmp30_ = overlay;
#line 219 "../lib/Widgets/Avatar.vala"
	he_bin_set_child ((HeBin*) self, (GtkWidget*) _tmp30_);
#line 187 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (overlay);
#line 187 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (loverlay);
#line 187 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (ioverlay);
#line 187 "../lib/Widgets/Avatar.vala"
	return obj;
#line 798 "Avatar.c"
}

static void
he_avatar_class_init (HeAvatarClass * klass,
                      gpointer klass_data)
{
#line 23 "../lib/Widgets/Avatar.vala"
	he_avatar_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/Avatar.vala"
	g_type_class_adjust_private_offset (klass, &HeAvatar_private_offset);
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_avatar_get_property;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_avatar_set_property;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->constructor = he_avatar_constructor;
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = he_avatar_finalize;
#line 817 "Avatar.c"
	/**
	    * The size of the avatar.
	    */
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_SIZE_PROPERTY, he_avatar_properties[HE_AVATAR_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 823 "Avatar.c"
	/**
	    * The text of the avatar.
	    */
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_TEXT_PROPERTY, he_avatar_properties[HE_AVATAR_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 829 "Avatar.c"
	/**
	    * The status shown on top of the avatar with a badge.
	    * e.g. when the user is offline, set it to false.
	    */
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_STATUS_PROPERTY, he_avatar_properties[HE_AVATAR_STATUS_PROPERTY] = g_param_spec_boolean ("status", "status", "status", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 836 "Avatar.c"
	/**
	    * The image of the avatar.
	    */
#line 23 "../lib/Widgets/Avatar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_AVATAR_IMAGE_PROPERTY, he_avatar_properties[HE_AVATAR_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 842 "Avatar.c"
}

static void
he_avatar_instance_init (HeAvatar * self,
                         gpointer klass)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* _tmp2_;
	HeModifierBadge* _tmp3_;
#line 23 "../lib/Widgets/Avatar.vala"
	self->priv = he_avatar_get_instance_private (self);
#line 29 "../lib/Widgets/Avatar.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 29 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp0_);
#line 29 "../lib/Widgets/Avatar.vala"
	self->priv->img = _tmp0_;
#line 30 "../lib/Widgets/Avatar.vala"
	_tmp1_ = (GtkImage*) gtk_image_new ();
#line 30 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp1_);
#line 30 "../lib/Widgets/Avatar.vala"
	self->priv->img_blur = _tmp1_;
#line 31 "../lib/Widgets/Avatar.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new ("");
#line 31 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp2_);
#line 31 "../lib/Widgets/Avatar.vala"
	self->priv->label = _tmp2_;
#line 33 "../lib/Widgets/Avatar.vala"
	_tmp3_ = he_modifier_badge_new ("");
#line 33 "../lib/Widgets/Avatar.vala"
	g_object_ref_sink (_tmp3_);
#line 33 "../lib/Widgets/Avatar.vala"
	self->priv->status_badge = _tmp3_;
#line 879 "Avatar.c"
}

static void
he_avatar_finalize (GObject * obj)
{
	HeAvatar * self;
#line 23 "../lib/Widgets/Avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_AVATAR, HeAvatar);
#line 24 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_image);
#line 26 "../lib/Widgets/Avatar.vala"
	_g_free0 (self->priv->_text);
#line 29 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->img);
#line 30 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->img_blur);
#line 31 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->label);
#line 33 "../lib/Widgets/Avatar.vala"
	_g_object_unref0 (self->priv->status_badge);
#line 23 "../lib/Widgets/Avatar.vala"
	G_OBJECT_CLASS (he_avatar_parent_class)->finalize (obj);
#line 902 "Avatar.c"
}

/**
* An Avatar is an element that displays an image that represents a person.
*/
static GType
he_avatar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAvatar), 0, (GInstanceInitFunc) he_avatar_instance_init, NULL };
	GType he_avatar_type_id;
	he_avatar_type_id = g_type_register_static (HE_TYPE_BIN, "HeAvatar", &g_define_type_info, 0);
	HeAvatar_private_offset = g_type_add_instance_private (he_avatar_type_id, sizeof (HeAvatarPrivate));
	return he_avatar_type_id;
}

GType
he_avatar_get_type (void)
{
	static volatile gsize he_avatar_type_id__once = 0;
	if (g_once_init_enter (&he_avatar_type_id__once)) {
		GType he_avatar_type_id;
		he_avatar_type_id = he_avatar_get_type_once ();
		g_once_init_leave (&he_avatar_type_id__once, he_avatar_type_id);
	}
	return he_avatar_type_id__once;
}

static void
_vala_he_avatar_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
#line 23 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_SIZE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_int (value, he_avatar_get_size (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_TEXT_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_string (value, he_avatar_get_text (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_boolean (value, he_avatar_get_status (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_IMAGE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		g_value_set_string (value, he_avatar_get_image (self));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 964 "Avatar.c"
		default:
#line 23 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 970 "Avatar.c"
	}
}

static void
_vala_he_avatar_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_AVATAR, HeAvatar);
#line 23 "../lib/Widgets/Avatar.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_SIZE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_size (self, g_value_get_int (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_TEXT_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_text (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_STATUS_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_status (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 23 "../lib/Widgets/Avatar.vala"
		case HE_AVATAR_IMAGE_PROPERTY:
#line 23 "../lib/Widgets/Avatar.vala"
		he_avatar_set_image (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1008 "Avatar.c"
		default:
#line 23 "../lib/Widgets/Avatar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Avatar.vala"
		break;
#line 1014 "Avatar.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

