/* SegmentedButton.c generated by valac 0.56.14, the Vala compiler
 * generated from SegmentedButton.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

enum  {
	HE_SEGMENTED_BUTTON_0_PROPERTY,
	HE_SEGMENTED_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_segmented_button_properties[HE_SEGMENTED_BUTTON_NUM_PROPERTIES];

static gpointer he_segmented_button_parent_class = NULL;

static GObject * he_segmented_button_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static GType he_segmented_button_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
     * Adds a widget to SegmentedButton, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
     *
     * @since 1.0
     */
void
he_segmented_button_add_child (HeSegmentedButton* self,
                               GtkBuilder* builder,
                               GObject* child,
                               const gchar* type)
{
#line 31 "../lib/Widgets/SegmentedButton.vala"
	g_return_if_fail (self != NULL);
#line 31 "../lib/Widgets/SegmentedButton.vala"
	g_return_if_fail (builder != NULL);
#line 31 "../lib/Widgets/SegmentedButton.vala"
	g_return_if_fail (child != NULL);
#line 32 "../lib/Widgets/SegmentedButton.vala"
	if (g_strcmp0 (type, "segment") == 0) {
#line 33 "../lib/Widgets/SegmentedButton.vala"
		gtk_widget_set_parent (G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget), (GtkWidget*) self);
#line 67 "SegmentedButton.c"
	}
}

HeSegmentedButton*
he_segmented_button_construct (GType object_type)
{
	HeSegmentedButton * self = NULL;
#line 25 "../lib/Widgets/SegmentedButton.vala"
	self = (HeSegmentedButton*) g_object_new (object_type, NULL);
#line 25 "../lib/Widgets/SegmentedButton.vala"
	return self;
#line 79 "SegmentedButton.c"
}

HeSegmentedButton*
he_segmented_button_new (void)
{
#line 25 "../lib/Widgets/SegmentedButton.vala"
	return he_segmented_button_construct (HE_TYPE_SEGMENTED_BUTTON);
#line 87 "SegmentedButton.c"
}

static GObject *
he_segmented_button_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeSegmentedButton * self;
#line 37 "../lib/Widgets/SegmentedButton.vala"
	parent_class = G_OBJECT_CLASS (he_segmented_button_parent_class);
#line 37 "../lib/Widgets/SegmentedButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../lib/Widgets/SegmentedButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SEGMENTED_BUTTON, HeSegmentedButton);
#line 38 "../lib/Widgets/SegmentedButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "segmented-button");
#line 39 "../lib/Widgets/SegmentedButton.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 37 "../lib/Widgets/SegmentedButton.vala"
	return obj;
#line 110 "SegmentedButton.c"
}

static void
he_segmented_button_class_init (HeSegmentedButtonClass * klass,
                                gpointer klass_data)
{
#line 25 "../lib/Widgets/SegmentedButton.vala"
	he_segmented_button_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Widgets/SegmentedButton.vala"
	G_OBJECT_CLASS (klass)->constructor = he_segmented_button_constructor;
#line 121 "SegmentedButton.c"
}

static void
he_segmented_button_instance_init (HeSegmentedButton * self,
                                   gpointer klass)
{
}

/**
 * A SegmentedButton is a group of buttons that selects a setting.
 * The developer supplies the buttons as children for further coding
 * in their app.
 */
static GType
he_segmented_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSegmentedButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_segmented_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSegmentedButton), 0, (GInstanceInitFunc) he_segmented_button_instance_init, NULL };
	GType he_segmented_button_type_id;
	he_segmented_button_type_id = g_type_register_static (gtk_box_get_type (), "HeSegmentedButton", &g_define_type_info, 0);
	return he_segmented_button_type_id;
}

GType
he_segmented_button_get_type (void)
{
	static volatile gsize he_segmented_button_type_id__once = 0;
	if (g_once_init_enter (&he_segmented_button_type_id__once)) {
		GType he_segmented_button_type_id;
		he_segmented_button_type_id = he_segmented_button_get_type_once ();
		g_once_init_leave (&he_segmented_button_type_id__once, he_segmented_button_type_id);
	}
	return he_segmented_button_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

