/* Tab.c generated by valac 0.56.14, the Vala compiler
 * generated from Tab.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#define HE_TAB_ACTION_CLOSE "action-close"
#define HE_TAB_ACTION_CLOSE_OTHER "action-close-other"
#define HE_TAB_ACTION_CLOSE_RIGHT "action-close-right"
#define HE_TAB_ACTION_DUPLICATE "action-duplicate"
#define HE_TAB_ACTION_PIN "action-pin"
#define HE_TAB_ACTION_NEW_WINDOW "action-new-window"

enum  {
	HE_TAB_0_PROPERTY,
	HE_TAB_LABEL_PROPERTY,
	HE_TAB_TOOLTIP_PROPERTY,
	HE_TAB_IS_CURRENT_TAB_PROPERTY,
	HE_TAB_PINNED_PROPERTY,
	HE_TAB_CAN_PIN_PROPERTY,
	HE_TAB_CAN_CLOSE_PROPERTY,
	HE_TAB_PAGE_PROPERTY,
	HE_TAB_MENU_PROPERTY,
	HE_TAB_ACTIONS_PROPERTY,
	HE_TAB_NUM_PROPERTIES
};
static GParamSpec* he_tab_properties[HE_TAB_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	HE_TAB_CLOSED_SIGNAL,
	HE_TAB_CLOSE_OTHERS_SIGNAL,
	HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL,
	HE_TAB_DUPLICATE_SIGNAL,
	HE_TAB_PIN_SIGNAL,
	HE_TAB_NEW_WINDOW_SIGNAL,
	HE_TAB_NUM_SIGNALS
};
static guint he_tab_signals[HE_TAB_NUM_SIGNALS] = {0};

struct _HeTabPrivate {
	GtkLabel* _label;
	gboolean _is_current_tab;
	gboolean _pinned;
	gboolean _pinnable;
	gboolean _closable;
	GMenu* _menu;
	GMenuItem* pin_menuitem;
	GtkButton* close_button;
	GtkCenterBox* tab_layout;
	GtkPopoverMenu* _popover;
	GSimpleActionGroup* _actions;
};

struct _Block7Data {
	int _ref_count_;
	HeTab* self;
	GtkGestureClick* click;
};

static gint HeTab_private_offset;
static gpointer he_tab_parent_class = NULL;

static void he_tab_action_close (HeTab* self);
static void _he_tab_action_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void he_tab_action_close_other (HeTab* self);
static void _he_tab_action_close_other_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void he_tab_action_close_right (HeTab* self);
static void _he_tab_action_close_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void he_tab_action_duplicate (HeTab* self);
static void _he_tab_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void he_tab_action_pin (HeTab* self);
static void _he_tab_action_pin_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self);
static void he_tab_action_new_window (HeTab* self);
static void _he_tab_action_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
VALA_EXTERN void he_tab_set_is_current_tab (HeTab* self,
                                gboolean value);
static void he_tab_update_close_btn_visibility (HeTab* self);
static HeTabSwitcher* he_tab_get_tab_switcher (HeTab* self);
static void he_tab_set_menu (HeTab* self,
                      GMenu* value);
static GtkPopoverMenu* he_tab_get_popover (HeTab* self);
static void he_tab_set_popover (HeTab* self,
                         GtkPopoverMenu* value);
static void he_tab_handle_events (HeTab* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda37_ (Block7Data* _data7_,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda37__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static GObject * he_tab_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties);
static void _he_tab___lambda38_ (HeTab* self);
static void __he_tab___lambda38__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self);
static void he_tab_finalize (GObject * obj);
static GType he_tab_get_type_once (void);
static void _vala_he_tab_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_he_tab_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry HE_TAB_ENTRIES[6] = {{HE_TAB_ACTION_CLOSE, _he_tab_action_close_gsimple_action_activate_callback}, {HE_TAB_ACTION_CLOSE_OTHER, _he_tab_action_close_other_gsimple_action_activate_callback}, {HE_TAB_ACTION_CLOSE_RIGHT, _he_tab_action_close_right_gsimple_action_activate_callback}, {HE_TAB_ACTION_DUPLICATE, _he_tab_action_duplicate_gsimple_action_activate_callback}, {HE_TAB_ACTION_PIN, _he_tab_action_pin_gsimple_action_activate_callback}, {HE_TAB_ACTION_NEW_WINDOW, _he_tab_action_new_window_gsimple_action_activate_callback}};

static inline gpointer
he_tab_get_instance_private (HeTab* self)
{
	return G_STRUCT_MEMBER_P (self, HeTab_private_offset);
}

static void
_he_tab_action_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_close ((HeTab*) self);
#line 173 "Tab.c"
}

static void
_he_tab_action_close_other_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_close_other ((HeTab*) self);
#line 183 "Tab.c"
}

static void
_he_tab_action_close_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_close_right ((HeTab*) self);
#line 193 "Tab.c"
}

static void
_he_tab_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_duplicate ((HeTab*) self);
#line 203 "Tab.c"
}

static void
_he_tab_action_pin_gsimple_action_activate_callback (GSimpleAction* action,
                                                     GVariant* parameter,
                                                     gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_pin ((HeTab*) self);
#line 213 "Tab.c"
}

static void
_he_tab_action_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 161 "../lib/Widgets/Tab.vala"
	he_tab_action_new_window ((HeTab*) self);
#line 223 "Tab.c"
}

const gchar*
he_tab_get_label (HeTab* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 28 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_label;
#line 28 "../lib/Widgets/Tab.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 28 "../lib/Widgets/Tab.vala"
	_tmp2_ = _tmp1_;
#line 28 "../lib/Widgets/Tab.vala"
	result = _tmp2_;
#line 28 "../lib/Widgets/Tab.vala"
	return result;
#line 245 "Tab.c"
}

void
he_tab_set_label (HeTab* self,
                  const gchar* value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 29 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 30 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_label;
#line 30 "../lib/Widgets/Tab.vala"
	gtk_label_set_label (_tmp0_, value);
#line 31 "../lib/Widgets/Tab.vala"
	_tmp1_ = self->priv->_label;
#line 31 "../lib/Widgets/Tab.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp1_, value);
#line 29 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_LABEL_PROPERTY]);
#line 266 "Tab.c"
}

void
he_tab_set_tooltip (HeTab* self,
                    const gchar* value)
{
	GtkLabel* _tmp0_;
#line 40 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_label;
#line 41 "../lib/Widgets/Tab.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp0_, value);
#line 40 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_TOOLTIP_PROPERTY]);
#line 282 "Tab.c"
}

void
he_tab_set_is_current_tab (HeTab* self,
                           gboolean value)
{
#line 47 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/Widgets/Tab.vala"
	self->priv->_is_current_tab = value;
#line 49 "../lib/Widgets/Tab.vala"
	he_tab_update_close_btn_visibility (self);
#line 47 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_IS_CURRENT_TAB_PROPERTY]);
#line 297 "Tab.c"
}

gboolean
he_tab_get_pinned (HeTab* self)
{
	gboolean result;
#line 58 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../lib/Widgets/Tab.vala"
	result = self->priv->_pinned;
#line 58 "../lib/Widgets/Tab.vala"
	return result;
#line 310 "Tab.c"
}

void
he_tab_set_pinned (HeTab* self,
                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 59 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 60 "../lib/Widgets/Tab.vala"
	_tmp0_ = he_tab_get_can_pin (self);
#line 60 "../lib/Widgets/Tab.vala"
	_tmp1_ = _tmp0_;
#line 60 "../lib/Widgets/Tab.vala"
	if (_tmp1_) {
#line 61 "../lib/Widgets/Tab.vala"
		if (value != self->priv->_pinned) {
#line 62 "../lib/Widgets/Tab.vala"
			if (value) {
#line 331 "Tab.c"
				GtkLabel* _tmp2_;
				GMenu* _tmp3_;
				GMenuItem* _tmp4_;
				GMenu* _tmp5_;
				GMenuItem* _tmp6_;
#line 63 "../lib/Widgets/Tab.vala"
				_tmp2_ = self->priv->_label;
#line 63 "../lib/Widgets/Tab.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 65 "../lib/Widgets/Tab.vala"
				_tmp3_ = self->priv->_menu;
#line 65 "../lib/Widgets/Tab.vala"
				g_menu_remove (_tmp3_, 5);
#line 66 "../lib/Widgets/Tab.vala"
				_tmp4_ = self->priv->pin_menuitem;
#line 66 "../lib/Widgets/Tab.vala"
				g_menu_item_set_label (_tmp4_, "Unpin");
#line 67 "../lib/Widgets/Tab.vala"
				_tmp5_ = self->priv->_menu;
#line 67 "../lib/Widgets/Tab.vala"
				_tmp6_ = self->priv->pin_menuitem;
#line 67 "../lib/Widgets/Tab.vala"
				g_menu_insert_item (_tmp5_, 5, _tmp6_);
#line 355 "Tab.c"
			} else {
				GtkLabel* _tmp7_;
				GMenu* _tmp8_;
				GMenuItem* _tmp9_;
				GMenu* _tmp10_;
				GMenuItem* _tmp11_;
#line 69 "../lib/Widgets/Tab.vala"
				_tmp7_ = self->priv->_label;
#line 69 "../lib/Widgets/Tab.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
#line 71 "../lib/Widgets/Tab.vala"
				_tmp8_ = self->priv->_menu;
#line 71 "../lib/Widgets/Tab.vala"
				g_menu_remove (_tmp8_, 5);
#line 72 "../lib/Widgets/Tab.vala"
				_tmp9_ = self->priv->pin_menuitem;
#line 72 "../lib/Widgets/Tab.vala"
				g_menu_item_set_label (_tmp9_, "Pin");
#line 73 "../lib/Widgets/Tab.vala"
				_tmp10_ = self->priv->_menu;
#line 73 "../lib/Widgets/Tab.vala"
				_tmp11_ = self->priv->pin_menuitem;
#line 73 "../lib/Widgets/Tab.vala"
				g_menu_insert_item (_tmp10_, 5, _tmp11_);
#line 380 "Tab.c"
			}
#line 76 "../lib/Widgets/Tab.vala"
			self->priv->_pinned = value;
#line 77 "../lib/Widgets/Tab.vala"
			he_tab_update_close_btn_visibility (self);
#line 78 "../lib/Widgets/Tab.vala"
			g_signal_emit (self, he_tab_signals[HE_TAB_PIN_SIGNAL], 0);
#line 388 "Tab.c"
		}
	}
#line 59 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_PINNED_PROPERTY]);
#line 393 "Tab.c"
}

gboolean
he_tab_get_can_pin (HeTab* self)
{
	gboolean result;
#line 89 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../lib/Widgets/Tab.vala"
	result = self->priv->_pinnable;
#line 89 "../lib/Widgets/Tab.vala"
	return result;
#line 406 "Tab.c"
}

void
he_tab_set_can_pin (HeTab* self,
                    gboolean value)
{
#line 90 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 91 "../lib/Widgets/Tab.vala"
	if (!value) {
#line 92 "../lib/Widgets/Tab.vala"
		he_tab_set_pinned (self, FALSE);
#line 419 "Tab.c"
	}
#line 95 "../lib/Widgets/Tab.vala"
	self->priv->_pinnable = value;
#line 90 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_CAN_PIN_PROPERTY]);
#line 425 "Tab.c"
}

gboolean
he_tab_get_can_close (HeTab* self)
{
	gboolean result;
#line 104 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../lib/Widgets/Tab.vala"
	result = self->priv->_closable;
#line 104 "../lib/Widgets/Tab.vala"
	return result;
#line 438 "Tab.c"
}

void
he_tab_set_can_close (HeTab* self,
                      gboolean value)
{
#line 105 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/Widgets/Tab.vala"
	if (value == self->priv->_closable) {
#line 107 "../lib/Widgets/Tab.vala"
		return;
#line 451 "Tab.c"
	}
#line 109 "../lib/Widgets/Tab.vala"
	self->priv->_closable = value;
#line 110 "../lib/Widgets/Tab.vala"
	he_tab_update_close_btn_visibility (self);
#line 105 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_CAN_CLOSE_PROPERTY]);
#line 459 "Tab.c"
}

GtkWidget*
he_tab_get_page (HeTab* self)
{
	GtkWidget* result;
	HeTabPage* _tmp0_;
	GtkWidget* _tmp1_;
#line 118 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->page_container;
#line 119 "../lib/Widgets/Tab.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 119 "../lib/Widgets/Tab.vala"
	result = _tmp1_;
#line 119 "../lib/Widgets/Tab.vala"
	return result;
#line 478 "Tab.c"
}

void
he_tab_set_page (HeTab* self,
                 GtkWidget* value)
{
	GtkWidget* container_child = NULL;
	HeTabPage* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	HeTabPage* _tmp4_;
#line 121 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 122 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->page_container;
#line 122 "../lib/Widgets/Tab.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 122 "../lib/Widgets/Tab.vala"
	container_child = _tmp1_;
#line 123 "../lib/Widgets/Tab.vala"
	_tmp2_ = container_child;
#line 123 "../lib/Widgets/Tab.vala"
	if (_tmp2_ != NULL) {
#line 502 "Tab.c"
		GtkWidget* _tmp3_;
#line 124 "../lib/Widgets/Tab.vala"
		_tmp3_ = container_child;
#line 124 "../lib/Widgets/Tab.vala"
		gtk_widget_unparent (_tmp3_);
#line 508 "Tab.c"
	}
#line 127 "../lib/Widgets/Tab.vala"
	_tmp4_ = self->page_container;
#line 127 "../lib/Widgets/Tab.vala"
	gtk_widget_set_parent (value, (GtkWidget*) _tmp4_);
#line 121 "../lib/Widgets/Tab.vala"
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_PAGE_PROPERTY]);
#line 516 "Tab.c"
}

static HeTabSwitcher*
he_tab_get_tab_switcher (HeTab* self)
{
	HeTabSwitcher* result;
	GtkNotebook* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
#line 133 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../lib/Widgets/Tab.vala"
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 133 "../lib/Widgets/Tab.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp1_) : NULL;
#line 133 "../lib/Widgets/Tab.vala"
	_tmp2_ = NULL;
#line 133 "../lib/Widgets/Tab.vala"
	if (_tmp0_ != NULL) {
#line 536 "Tab.c"
		GtkWidget* _tmp3_;
#line 133 "../lib/Widgets/Tab.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp0_);
#line 133 "../lib/Widgets/Tab.vala"
		_tmp2_ = _tmp3_;
#line 542 "Tab.c"
	}
#line 133 "../lib/Widgets/Tab.vala"
	result = HE_IS_TAB_SWITCHER (_tmp2_) ? ((HeTabSwitcher*) _tmp2_) : NULL;
#line 133 "../lib/Widgets/Tab.vala"
	return result;
#line 548 "Tab.c"
}

GMenu*
he_tab_get_menu (HeTab* self)
{
	GMenu* result;
	GMenu* _tmp0_;
#line 139 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_menu;
#line 139 "../lib/Widgets/Tab.vala"
	result = _tmp0_;
#line 139 "../lib/Widgets/Tab.vala"
	return result;
#line 564 "Tab.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 139 "../lib/Widgets/Tab.vala"
	return self ? g_object_ref (self) : NULL;
#line 572 "Tab.c"
}

static void
he_tab_set_menu (HeTab* self,
                 GMenu* value)
{
	GMenu* old_value;
#line 139 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 139 "../lib/Widgets/Tab.vala"
	old_value = he_tab_get_menu (self);
#line 139 "../lib/Widgets/Tab.vala"
	if (old_value != value) {
#line 586 "Tab.c"
		GMenu* _tmp0_;
#line 139 "../lib/Widgets/Tab.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 139 "../lib/Widgets/Tab.vala"
		_g_object_unref0 (self->priv->_menu);
#line 139 "../lib/Widgets/Tab.vala"
		self->priv->_menu = _tmp0_;
#line 139 "../lib/Widgets/Tab.vala"
		g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_MENU_PROPERTY]);
#line 596 "Tab.c"
	}
}

static GtkPopoverMenu*
he_tab_get_popover (HeTab* self)
{
	GtkPopoverMenu* result;
	GtkPopoverMenu* _tmp0_;
#line 145 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_popover;
#line 145 "../lib/Widgets/Tab.vala"
	result = _tmp0_;
#line 145 "../lib/Widgets/Tab.vala"
	return result;
#line 613 "Tab.c"
}

static void
he_tab_set_popover (HeTab* self,
                    GtkPopoverMenu* value)
{
	GtkPopoverMenu* _tmp0_;
#line 145 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 145 "../lib/Widgets/Tab.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 145 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_popover);
#line 145 "../lib/Widgets/Tab.vala"
	self->priv->_popover = _tmp0_;
#line 629 "Tab.c"
}

GSimpleActionGroup*
he_tab_get_actions (HeTab* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 154 "../lib/Widgets/Tab.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 154 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->_actions;
#line 154 "../lib/Widgets/Tab.vala"
	result = _tmp0_;
#line 154 "../lib/Widgets/Tab.vala"
	return result;
#line 645 "Tab.c"
}

static void
he_tab_set_actions (HeTab* self,
                    GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 154 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 154 "../lib/Widgets/Tab.vala"
	old_value = he_tab_get_actions (self);
#line 154 "../lib/Widgets/Tab.vala"
	if (old_value != value) {
#line 659 "Tab.c"
		GSimpleActionGroup* _tmp0_;
#line 154 "../lib/Widgets/Tab.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 154 "../lib/Widgets/Tab.vala"
		_g_object_unref0 (self->priv->_actions);
#line 154 "../lib/Widgets/Tab.vala"
		self->priv->_actions = _tmp0_;
#line 154 "../lib/Widgets/Tab.vala"
		g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_ACTIONS_PROPERTY]);
#line 669 "Tab.c"
	}
}

static void
he_tab_action_close (HeTab* self)
{
#line 170 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 171 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSED_SIGNAL], 0);
#line 680 "Tab.c"
}

static void
he_tab_action_close_other (HeTab* self)
{
#line 173 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 174 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 690 "Tab.c"
}

static void
he_tab_action_close_right (HeTab* self)
{
#line 176 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 177 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL], 0);
#line 700 "Tab.c"
}

static void
he_tab_action_duplicate (HeTab* self)
{
#line 179 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 180 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_DUPLICATE_SIGNAL], 0);
#line 710 "Tab.c"
}

static void
he_tab_action_pin (HeTab* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 182 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 183 "../lib/Widgets/Tab.vala"
	_tmp0_ = he_tab_get_pinned (self);
#line 183 "../lib/Widgets/Tab.vala"
	_tmp1_ = _tmp0_;
#line 183 "../lib/Widgets/Tab.vala"
	he_tab_set_pinned (self, !_tmp1_);
#line 726 "Tab.c"
}

static void
he_tab_action_new_window (HeTab* self)
{
#line 185 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_NEW_WINDOW_SIGNAL], 0);
#line 736 "Tab.c"
}

/**
     * Create a new Tab
     *
     * @since 1.0
     */
HeTab*
he_tab_construct (GType object_type,
                  const gchar* label,
                  GtkWidget* page)
{
	HeTab * self = NULL;
#line 195 "../lib/Widgets/Tab.vala"
	self = (HeTab*) g_object_new (object_type, "label", label, NULL);
#line 199 "../lib/Widgets/Tab.vala"
	if (page != NULL) {
#line 200 "../lib/Widgets/Tab.vala"
		he_tab_set_page (self, page);
#line 756 "Tab.c"
	}
#line 203 "../lib/Widgets/Tab.vala"
	he_tab_handle_events (self);
#line 194 "../lib/Widgets/Tab.vala"
	return self;
#line 762 "Tab.c"
}

HeTab*
he_tab_new (const gchar* label,
            GtkWidget* page)
{
#line 194 "../lib/Widgets/Tab.vala"
	return he_tab_construct (HE_TYPE_TAB, label, page);
#line 771 "Tab.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 263 "../lib/Widgets/Tab.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 263 "../lib/Widgets/Tab.vala"
	return _data7_;
#line 781 "Tab.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 263 "../lib/Widgets/Tab.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 791 "Tab.c"
		HeTab* self;
#line 263 "../lib/Widgets/Tab.vala"
		self = _data7_->self;
#line 263 "../lib/Widgets/Tab.vala"
		_g_object_unref0 (_data7_->click);
#line 263 "../lib/Widgets/Tab.vala"
		_g_object_unref0 (self);
#line 263 "../lib/Widgets/Tab.vala"
		g_slice_free (Block7Data, _data7_);
#line 801 "Tab.c"
	}
}

static void
__lambda37_ (Block7Data* _data7_,
             gint n_press,
             gdouble x,
             gdouble y)
{
	HeTab* self;
#line 270 "../lib/Widgets/Tab.vala"
	self = _data7_->self;
#line 271 "../lib/Widgets/Tab.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _data7_->click) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 816 "Tab.c"
		GdkRectangle rect = {0};
		GdkRectangle _tmp0_ = {0};
		GtkPopoverMenu* _tmp1_;
		GdkRectangle _tmp2_;
		GtkPopoverMenu* _tmp3_;
#line 272 "../lib/Widgets/Tab.vala"
		_tmp0_.x = (gint) x;
#line 272 "../lib/Widgets/Tab.vala"
		_tmp0_.y = (gint) y;
#line 272 "../lib/Widgets/Tab.vala"
		_tmp0_.width = 0;
#line 272 "../lib/Widgets/Tab.vala"
		_tmp0_.height = 0;
#line 272 "../lib/Widgets/Tab.vala"
		rect = _tmp0_;
#line 276 "../lib/Widgets/Tab.vala"
		_tmp1_ = self->priv->_popover;
#line 276 "../lib/Widgets/Tab.vala"
		_tmp2_ = rect;
#line 276 "../lib/Widgets/Tab.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp1_, &_tmp2_);
#line 277 "../lib/Widgets/Tab.vala"
		_tmp3_ = self->priv->_popover;
#line 277 "../lib/Widgets/Tab.vala"
		gtk_popover_popup ((GtkPopover*) _tmp3_);
#line 842 "Tab.c"
	}
}

static void
___lambda37__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
#line 270 "../lib/Widgets/Tab.vala"
	__lambda37_ (self, n_press, x, y);
#line 855 "Tab.c"
}

static void
he_tab_handle_events (HeTab* self)
{
	Block7Data* _data7_;
	GtkGestureClick* _tmp0_ = NULL;
	GtkEventController* _tmp1_;
	GtkPopoverMenu* _tmp2_;
#line 263 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 263 "../lib/Widgets/Tab.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 263 "../lib/Widgets/Tab.vala"
	_data7_->_ref_count_ = 1;
#line 263 "../lib/Widgets/Tab.vala"
	_data7_->self = g_object_ref (self);
#line 264 "../lib/Widgets/Tab.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 264 "../lib/Widgets/Tab.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp0_, (guint) 0);
#line 264 "../lib/Widgets/Tab.vala"
	_data7_->click = _tmp0_;
#line 267 "../lib/Widgets/Tab.vala"
	_tmp1_ = _g_object_ref0 ((GtkEventController*) _data7_->click);
#line 267 "../lib/Widgets/Tab.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
#line 268 "../lib/Widgets/Tab.vala"
	_tmp2_ = self->priv->_popover;
#line 268 "../lib/Widgets/Tab.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp2_, (GtkWidget*) self);
#line 270 "../lib/Widgets/Tab.vala"
	g_signal_connect_data (_data7_->click, "pressed", (GCallback) ___lambda37__gtk_gesture_click_pressed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 263 "../lib/Widgets/Tab.vala"
	block7_data_unref (_data7_);
#line 263 "../lib/Widgets/Tab.vala"
	_data7_ = NULL;
#line 893 "Tab.c"
}

static void
he_tab_update_close_btn_visibility (HeTab* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 282 "../lib/Widgets/Tab.vala"
	g_return_if_fail (self != NULL);
#line 283 "../lib/Widgets/Tab.vala"
	_tmp1_ = he_tab_get_pinned (self);
#line 283 "../lib/Widgets/Tab.vala"
	_tmp2_ = _tmp1_;
#line 283 "../lib/Widgets/Tab.vala"
	if (_tmp2_) {
#line 283 "../lib/Widgets/Tab.vala"
		_tmp0_ = TRUE;
#line 912 "Tab.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 283 "../lib/Widgets/Tab.vala"
		_tmp3_ = he_tab_get_can_close (self);
#line 283 "../lib/Widgets/Tab.vala"
		_tmp4_ = _tmp3_;
#line 283 "../lib/Widgets/Tab.vala"
		_tmp0_ = !_tmp4_;
#line 922 "Tab.c"
	}
#line 283 "../lib/Widgets/Tab.vala"
	if (_tmp0_) {
#line 926 "Tab.c"
		GtkButton* _tmp5_;
#line 284 "../lib/Widgets/Tab.vala"
		_tmp5_ = self->priv->close_button;
#line 284 "../lib/Widgets/Tab.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 932 "Tab.c"
	} else {
		GtkButton* _tmp6_;
#line 286 "../lib/Widgets/Tab.vala"
		_tmp6_ = self->priv->close_button;
#line 286 "../lib/Widgets/Tab.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 939 "Tab.c"
	}
}

static void
_he_tab___lambda38_ (HeTab* self)
{
#line 217 "../lib/Widgets/Tab.vala"
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSED_SIGNAL], 0);
#line 948 "Tab.c"
}

static void
__he_tab___lambda38__gtk_button_clicked (GtkButton* _sender,
                                         gpointer self)
{
#line 216 "../lib/Widgets/Tab.vala"
	_he_tab___lambda38_ ((HeTab*) self);
#line 957 "Tab.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 970 "Tab.c"
}

static GObject *
he_tab_constructor (GType type,
                    guint n_construct_properties,
                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTab * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkCenterBox* _tmp8_;
	GtkCenterBox* _tmp9_;
	GtkCenterBox* _tmp10_;
	GtkCenterBox* _tmp11_;
	GtkButton* _tmp12_;
	GtkCenterBox* _tmp13_;
	GtkLabel* _tmp14_;
	GtkCenterBox* _tmp15_;
	GMenu* _tmp16_;
	GMenu* _tmp17_;
	GMenu* _tmp18_;
	GtkPopoverMenu* _tmp19_;
	GtkPopoverMenu* _tmp20_;
	GSimpleActionGroup* _tmp21_;
	GSimpleActionGroup* _tmp22_;
	GSimpleActionGroup* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GSimpleActionGroup* _tmp26_;
	GMenu* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GMenu* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GMenu* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GMenu* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	GMenu* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gboolean _tmp57_;
	gboolean _tmp58_;
	GtkPopoverMenu* _tmp67_;
	GMenu* _tmp68_;
	HeTabPage* _tmp69_;
#line 206 "../lib/Widgets/Tab.vala"
	parent_class = G_OBJECT_CLASS (he_tab_parent_class);
#line 206 "../lib/Widgets/Tab.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 206 "../lib/Widgets/Tab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB, HeTab);
#line 207 "../lib/Widgets/Tab.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 207 "../lib/Widgets/Tab.vala"
	g_object_ref_sink (_tmp0_);
#line 207 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_label);
#line 207 "../lib/Widgets/Tab.vala"
	self->priv->_label = _tmp0_;
#line 208 "../lib/Widgets/Tab.vala"
	_tmp1_ = self->priv->_label;
#line 208 "../lib/Widgets/Tab.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 209 "../lib/Widgets/Tab.vala"
	_tmp2_ = self->priv->_label;
#line 209 "../lib/Widgets/Tab.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 210 "../lib/Widgets/Tab.vala"
	_tmp3_ = self->priv->_label;
#line 210 "../lib/Widgets/Tab.vala"
	gtk_label_set_ellipsize (_tmp3_, PANGO_ELLIPSIZE_END);
#line 212 "../lib/Widgets/Tab.vala"
	_tmp4_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close");
#line 212 "../lib/Widgets/Tab.vala"
	g_object_ref_sink (_tmp4_);
#line 212 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->close_button);
#line 212 "../lib/Widgets/Tab.vala"
	self->priv->close_button = _tmp4_;
#line 213 "../lib/Widgets/Tab.vala"
	_tmp5_ = self->priv->close_button;
#line 213 "../lib/Widgets/Tab.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_CENTER);
#line 214 "../lib/Widgets/Tab.vala"
	_tmp6_ = self->priv->close_button;
#line 214 "../lib/Widgets/Tab.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "tab-button");
#line 216 "../lib/Widgets/Tab.vala"
	_tmp7_ = self->priv->close_button;
#line 216 "../lib/Widgets/Tab.vala"
	g_signal_connect_object (_tmp7_, "clicked", (GCallback) __he_tab___lambda38__gtk_button_clicked, self, 0);
#line 220 "../lib/Widgets/Tab.vala"
	_tmp8_ = (GtkCenterBox*) gtk_center_box_new ();
#line 220 "../lib/Widgets/Tab.vala"
	g_object_ref_sink (_tmp8_);
#line 220 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->tab_layout);
#line 220 "../lib/Widgets/Tab.vala"
	self->priv->tab_layout = _tmp8_;
#line 221 "../lib/Widgets/Tab.vala"
	_tmp9_ = self->priv->tab_layout;
#line 221 "../lib/Widgets/Tab.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 222 "../lib/Widgets/Tab.vala"
	_tmp10_ = self->priv->tab_layout;
#line 222 "../lib/Widgets/Tab.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 223 "../lib/Widgets/Tab.vala"
	_tmp11_ = self->priv->tab_layout;
#line 223 "../lib/Widgets/Tab.vala"
	_tmp12_ = self->priv->close_button;
#line 223 "../lib/Widgets/Tab.vala"
	gtk_center_box_set_end_widget (_tmp11_, (GtkWidget*) _tmp12_);
#line 224 "../lib/Widgets/Tab.vala"
	_tmp13_ = self->priv->tab_layout;
#line 224 "../lib/Widgets/Tab.vala"
	_tmp14_ = self->priv->_label;
#line 224 "../lib/Widgets/Tab.vala"
	gtk_center_box_set_center_widget (_tmp13_, (GtkWidget*) _tmp14_);
#line 226 "../lib/Widgets/Tab.vala"
	_tmp15_ = self->priv->tab_layout;
#line 226 "../lib/Widgets/Tab.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp15_, (GtkWidget*) self);
#line 228 "../lib/Widgets/Tab.vala"
	_tmp16_ = g_menu_new ();
#line 228 "../lib/Widgets/Tab.vala"
	_tmp17_ = _tmp16_;
#line 228 "../lib/Widgets/Tab.vala"
	he_tab_set_menu (self, _tmp17_);
#line 228 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (_tmp17_);
#line 229 "../lib/Widgets/Tab.vala"
	_tmp18_ = self->priv->_menu;
#line 229 "../lib/Widgets/Tab.vala"
	_tmp19_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model ((GMenuModel*) _tmp18_);
#line 229 "../lib/Widgets/Tab.vala"
	g_object_ref_sink (_tmp19_);
#line 229 "../lib/Widgets/Tab.vala"
	_tmp20_ = _tmp19_;
#line 229 "../lib/Widgets/Tab.vala"
	he_tab_set_popover (self, _tmp20_);
#line 229 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (_tmp20_);
#line 230 "../lib/Widgets/Tab.vala"
	_tmp21_ = g_simple_action_group_new ();
#line 230 "../lib/Widgets/Tab.vala"
	_tmp22_ = _tmp21_;
#line 230 "../lib/Widgets/Tab.vala"
	he_tab_set_actions (self, _tmp22_);
#line 230 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (_tmp22_);
#line 231 "../lib/Widgets/Tab.vala"
	_tmp23_ = self->priv->_actions;
#line 231 "../lib/Widgets/Tab.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp23_, HE_TAB_ENTRIES, (gint) G_N_ELEMENTS (HE_TAB_ENTRIES), self);
#line 232 "../lib/Widgets/Tab.vala"
	_tmp24_ = he_tab_get_label (self);
#line 232 "../lib/Widgets/Tab.vala"
	_tmp25_ = _tmp24_;
#line 232 "../lib/Widgets/Tab.vala"
	_tmp26_ = self->priv->_actions;
#line 232 "../lib/Widgets/Tab.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, _tmp25_, (GActionGroup*) _tmp26_);
#line 235 "../lib/Widgets/Tab.vala"
	_tmp27_ = self->priv->_menu;
#line 235 "../lib/Widgets/Tab.vala"
	_tmp28_ = he_tab_get_label (self);
#line 235 "../lib/Widgets/Tab.vala"
	_tmp29_ = _tmp28_;
#line 235 "../lib/Widgets/Tab.vala"
	_tmp30_ = string_to_string (_tmp29_);
#line 235 "../lib/Widgets/Tab.vala"
	_tmp31_ = g_strconcat (_tmp30_, ".action-new-window", NULL);
#line 235 "../lib/Widgets/Tab.vala"
	_tmp32_ = _tmp31_;
#line 235 "../lib/Widgets/Tab.vala"
	g_menu_append (_tmp27_, "Open in New Window", _tmp32_);
#line 235 "../lib/Widgets/Tab.vala"
	_g_free0 (_tmp32_);
#line 236 "../lib/Widgets/Tab.vala"
	_tmp33_ = self->priv->_menu;
#line 236 "../lib/Widgets/Tab.vala"
	_tmp34_ = he_tab_get_label (self);
#line 236 "../lib/Widgets/Tab.vala"
	_tmp35_ = _tmp34_;
#line 236 "../lib/Widgets/Tab.vala"
	_tmp36_ = string_to_string (_tmp35_);
#line 236 "../lib/Widgets/Tab.vala"
	_tmp37_ = g_strconcat (_tmp36_, ".action-close", NULL);
#line 236 "../lib/Widgets/Tab.vala"
	_tmp38_ = _tmp37_;
#line 236 "../lib/Widgets/Tab.vala"
	g_menu_append (_tmp33_, "Close", _tmp38_);
#line 236 "../lib/Widgets/Tab.vala"
	_g_free0 (_tmp38_);
#line 237 "../lib/Widgets/Tab.vala"
	_tmp39_ = self->priv->_menu;
#line 237 "../lib/Widgets/Tab.vala"
	_tmp40_ = he_tab_get_label (self);
#line 237 "../lib/Widgets/Tab.vala"
	_tmp41_ = _tmp40_;
#line 237 "../lib/Widgets/Tab.vala"
	_tmp42_ = string_to_string (_tmp41_);
#line 237 "../lib/Widgets/Tab.vala"
	_tmp43_ = g_strconcat (_tmp42_, ".action-close-other", NULL);
#line 237 "../lib/Widgets/Tab.vala"
	_tmp44_ = _tmp43_;
#line 237 "../lib/Widgets/Tab.vala"
	g_menu_append (_tmp39_, "Close Others", _tmp44_);
#line 237 "../lib/Widgets/Tab.vala"
	_g_free0 (_tmp44_);
#line 238 "../lib/Widgets/Tab.vala"
	_tmp45_ = self->priv->_menu;
#line 238 "../lib/Widgets/Tab.vala"
	_tmp46_ = he_tab_get_label (self);
#line 238 "../lib/Widgets/Tab.vala"
	_tmp47_ = _tmp46_;
#line 238 "../lib/Widgets/Tab.vala"
	_tmp48_ = string_to_string (_tmp47_);
#line 238 "../lib/Widgets/Tab.vala"
	_tmp49_ = g_strconcat (_tmp48_, ".action-close-right", NULL);
#line 238 "../lib/Widgets/Tab.vala"
	_tmp50_ = _tmp49_;
#line 238 "../lib/Widgets/Tab.vala"
	g_menu_append (_tmp45_, "Close Tab to the Right", _tmp50_);
#line 238 "../lib/Widgets/Tab.vala"
	_g_free0 (_tmp50_);
#line 239 "../lib/Widgets/Tab.vala"
	_tmp51_ = self->priv->_menu;
#line 239 "../lib/Widgets/Tab.vala"
	_tmp52_ = he_tab_get_label (self);
#line 239 "../lib/Widgets/Tab.vala"
	_tmp53_ = _tmp52_;
#line 239 "../lib/Widgets/Tab.vala"
	_tmp54_ = string_to_string (_tmp53_);
#line 239 "../lib/Widgets/Tab.vala"
	_tmp55_ = g_strconcat (_tmp54_, ".action-duplicate", NULL);
#line 239 "../lib/Widgets/Tab.vala"
	_tmp56_ = _tmp55_;
#line 239 "../lib/Widgets/Tab.vala"
	g_menu_append (_tmp51_, "Duplicate", _tmp56_);
#line 239 "../lib/Widgets/Tab.vala"
	_g_free0 (_tmp56_);
#line 241 "../lib/Widgets/Tab.vala"
	_tmp57_ = he_tab_get_can_pin (self);
#line 241 "../lib/Widgets/Tab.vala"
	_tmp58_ = _tmp57_;
#line 241 "../lib/Widgets/Tab.vala"
	if (_tmp58_) {
#line 1247 "Tab.c"
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		GMenuItem* _tmp64_;
		GMenu* _tmp65_;
		GMenuItem* _tmp66_;
#line 242 "../lib/Widgets/Tab.vala"
		_tmp59_ = he_tab_get_label (self);
#line 242 "../lib/Widgets/Tab.vala"
		_tmp60_ = _tmp59_;
#line 242 "../lib/Widgets/Tab.vala"
		_tmp61_ = string_to_string (_tmp60_);
#line 242 "../lib/Widgets/Tab.vala"
		_tmp62_ = g_strconcat (_tmp61_, ".pin", NULL);
#line 242 "../lib/Widgets/Tab.vala"
		_tmp63_ = _tmp62_;
#line 242 "../lib/Widgets/Tab.vala"
		_tmp64_ = g_menu_item_new ("Pin", _tmp63_);
#line 242 "../lib/Widgets/Tab.vala"
		_g_object_unref0 (self->priv->pin_menuitem);
#line 242 "../lib/Widgets/Tab.vala"
		self->priv->pin_menuitem = _tmp64_;
#line 242 "../lib/Widgets/Tab.vala"
		_g_free0 (_tmp63_);
#line 244 "../lib/Widgets/Tab.vala"
		_tmp65_ = self->priv->_menu;
#line 244 "../lib/Widgets/Tab.vala"
		_tmp66_ = self->priv->pin_menuitem;
#line 244 "../lib/Widgets/Tab.vala"
		g_menu_insert_item (_tmp65_, 5, _tmp66_);
#line 1280 "Tab.c"
	}
#line 247 "../lib/Widgets/Tab.vala"
	_tmp67_ = self->priv->_popover;
#line 247 "../lib/Widgets/Tab.vala"
	_tmp68_ = self->priv->_menu;
#line 247 "../lib/Widgets/Tab.vala"
	gtk_popover_menu_set_menu_model (_tmp67_, (GMenuModel*) _tmp68_);
#line 249 "../lib/Widgets/Tab.vala"
	_tmp69_ = he_tab_page_new (self);
#line 249 "../lib/Widgets/Tab.vala"
	g_object_ref_sink (_tmp69_);
#line 249 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->page_container);
#line 249 "../lib/Widgets/Tab.vala"
	self->page_container = _tmp69_;
#line 251 "../lib/Widgets/Tab.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 252 "../lib/Widgets/Tab.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "tab-child");
#line 206 "../lib/Widgets/Tab.vala"
	return obj;
#line 1302 "Tab.c"
}

static void
he_tab_class_init (HeTabClass * klass,
                   gpointer klass_data)
{
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/Tab.vala"
	g_type_class_adjust_private_offset (klass, &HeTab_private_offset);
#line 23 "../lib/Widgets/Tab.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tab_get_property;
#line 23 "../lib/Widgets/Tab.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tab_set_property;
#line 23 "../lib/Widgets/Tab.vala"
	G_OBJECT_CLASS (klass)->constructor = he_tab_constructor;
#line 23 "../lib/Widgets/Tab.vala"
	G_OBJECT_CLASS (klass)->finalize = he_tab_finalize;
#line 1321 "Tab.c"
	/**
	     * The label/title of the tab
	     **/
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_LABEL_PROPERTY, he_tab_properties[HE_TAB_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1327 "Tab.c"
	/**
	     * The Pango marked up text that will be shown in a tooltip when the tab is hovered.
	     **/
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_TOOLTIP_PROPERTY, he_tab_properties[HE_TAB_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_IS_CURRENT_TAB_PROPERTY, he_tab_properties[HE_TAB_IS_CURRENT_TAB_PROPERTY] = g_param_spec_boolean ("is-current-tab", "is-current-tab", "is-current-tab", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_PINNED_PROPERTY, he_tab_properties[HE_TAB_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1337 "Tab.c"
	/**
	     * Whether a Tab can be pinned or not
	     */
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_CAN_PIN_PROPERTY, he_tab_properties[HE_TAB_CAN_PIN_PROPERTY] = g_param_spec_boolean ("can-pin", "can-pin", "can-pin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1343 "Tab.c"
	/**
	     * Whether a Tab can be closed or not
	     */
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_CAN_CLOSE_PROPERTY, he_tab_properties[HE_TAB_CAN_CLOSE_PROPERTY] = g_param_spec_boolean ("can-close", "can-close", "can-close", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1349 "Tab.c"
	/**
	     * The TabPage to hold children, to appear when this tab is active
	     */
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_PAGE_PROPERTY, he_tab_properties[HE_TAB_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1355 "Tab.c"
	/**
	     * The menu appearing when the tab is clicked
	     */
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_MENU_PROPERTY, he_tab_properties[HE_TAB_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", g_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../lib/Widgets/Tab.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_ACTIONS_PROPERTY, he_tab_properties[HE_TAB_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_CLOSED_SIGNAL] = g_signal_new ("closed", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_CLOSE_OTHERS_SIGNAL] = g_signal_new ("close-others", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL] = g_signal_new ("close-others-right", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_DUPLICATE_SIGNAL] = g_signal_new ("duplicate", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_PIN_SIGNAL] = g_signal_new ("pin", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../lib/Widgets/Tab.vala"
	he_tab_signals[HE_TAB_NEW_WINDOW_SIGNAL] = g_signal_new ("new-window", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 256 "../lib/Widgets/Tab.vala"
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
#line 1377 "Tab.c"
}

static void
he_tab_instance_init (HeTab * self,
                      gpointer klass)
{
#line 23 "../lib/Widgets/Tab.vala"
	self->priv = he_tab_get_instance_private (self);
#line 45 "../lib/Widgets/Tab.vala"
	self->priv->_is_current_tab = FALSE;
#line 56 "../lib/Widgets/Tab.vala"
	self->priv->_pinned = FALSE;
#line 84 "../lib/Widgets/Tab.vala"
	self->priv->_pinnable = TRUE;
#line 99 "../lib/Widgets/Tab.vala"
	self->priv->_closable = TRUE;
#line 1394 "Tab.c"
}

static void
he_tab_finalize (GObject * obj)
{
	HeTab * self;
	GtkCenterBox* _tmp0_;
#line 23 "../lib/Widgets/Tab.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB, HeTab);
#line 260 "../lib/Widgets/Tab.vala"
	_tmp0_ = self->priv->tab_layout;
#line 260 "../lib/Widgets/Tab.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 34 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_label);
#line 130 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->page_container);
#line 139 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_menu);
#line 140 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->pin_menuitem);
#line 142 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->close_button);
#line 144 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->tab_layout);
#line 145 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_popover);
#line 154 "../lib/Widgets/Tab.vala"
	_g_object_unref0 (self->priv->_actions);
#line 23 "../lib/Widgets/Tab.vala"
	G_OBJECT_CLASS (he_tab_parent_class)->finalize (obj);
#line 1426 "Tab.c"
}

/**
 * Standard tab designed for TabSwitcher, used to form a tabbed UI
 */
static GType
he_tab_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTab), 0, (GInstanceInitFunc) he_tab_instance_init, NULL };
	GType he_tab_type_id;
	he_tab_type_id = g_type_register_static (HE_TYPE_BIN, "HeTab", &g_define_type_info, 0);
	HeTab_private_offset = g_type_add_instance_private (he_tab_type_id, sizeof (HeTabPrivate));
	return he_tab_type_id;
}

GType
he_tab_get_type (void)
{
	static volatile gsize he_tab_type_id__once = 0;
	if (g_once_init_enter (&he_tab_type_id__once)) {
		GType he_tab_type_id;
		he_tab_type_id = he_tab_get_type_once ();
		g_once_init_leave (&he_tab_type_id__once, he_tab_type_id);
	}
	return he_tab_type_id__once;
}

static void
_vala_he_tab_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	HeTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB, HeTab);
#line 23 "../lib/Widgets/Tab.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_LABEL_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_string (value, he_tab_get_label (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_PINNED_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_boolean (value, he_tab_get_pinned (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_CAN_PIN_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_boolean (value, he_tab_get_can_pin (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_CAN_CLOSE_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_boolean (value, he_tab_get_can_close (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_PAGE_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_object (value, he_tab_get_page (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_MENU_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_object (value, he_tab_get_menu (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_ACTIONS_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		g_value_set_object (value, he_tab_get_actions (self));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 1506 "Tab.c"
		default:
#line 23 "../lib/Widgets/Tab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 1512 "Tab.c"
	}
}

static void
_vala_he_tab_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	HeTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB, HeTab);
#line 23 "../lib/Widgets/Tab.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_LABEL_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_label (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_TOOLTIP_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_tooltip (self, g_value_get_string (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_IS_CURRENT_TAB_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_is_current_tab (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_PINNED_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_pinned (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_CAN_PIN_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_can_pin (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_CAN_CLOSE_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_can_close (self, g_value_get_boolean (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_PAGE_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_page (self, g_value_get_object (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_MENU_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_menu (self, g_value_get_object (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 23 "../lib/Widgets/Tab.vala"
		case HE_TAB_ACTIONS_PROPERTY:
#line 23 "../lib/Widgets/Tab.vala"
		he_tab_set_actions (self, g_value_get_object (value));
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 1580 "Tab.c"
		default:
#line 23 "../lib/Widgets/Tab.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/Tab.vala"
		break;
#line 1586 "Tab.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

