/* TextButton.c generated by valac 0.56.14, the Vala compiler
 * generated from TextButton.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	HE_TEXT_BUTTON_0_PROPERTY,
	HE_TEXT_BUTTON_COLOR_PROPERTY,
	HE_TEXT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_text_button_properties[HE_TEXT_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeTextButtonPrivate {
	HeColors _color;
};

static gint HeTextButton_private_offset;
static gpointer he_text_button_parent_class = NULL;

static GObject * he_text_button_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void he_text_button_finalize (GObject * obj);
static GType he_text_button_get_type_once (void);
static void _vala_he_text_button_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_text_button_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_text_button_get_instance_private (HeTextButton* self)
{
	return G_STRUCT_MEMBER_P (self, HeTextButton_private_offset);
}

static HeColors
he_text_button_real_get_color (HeButton* base)
{
	HeColors result;
	HeTextButton* self;
#line 37 "../lib/Widgets/TextButton.vala"
	self = (HeTextButton*) base;
#line 38 "../lib/Widgets/TextButton.vala"
	result = self->priv->_color;
#line 38 "../lib/Widgets/TextButton.vala"
	return result;
#line 79 "TextButton.c"
}

static void
he_text_button_real_set_color (HeButton* base,
                               HeColors value)
{
	HeTextButton* self;
#line 30 "../lib/Widgets/TextButton.vala"
	self = (HeTextButton*) base;
#line 31 "../lib/Widgets/TextButton.vala"
	if (self->priv->_color != HE_COLORS_NONE) {
#line 91 "TextButton.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 31 "../lib/Widgets/TextButton.vala"
		_tmp0_ = he_colors_to_css_class (self->priv->_color);
#line 31 "../lib/Widgets/TextButton.vala"
		_tmp1_ = _tmp0_;
#line 31 "../lib/Widgets/TextButton.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, _tmp1_);
#line 31 "../lib/Widgets/TextButton.vala"
		_g_free0 (_tmp1_);
#line 102 "TextButton.c"
	}
#line 32 "../lib/Widgets/TextButton.vala"
	if (value != HE_COLORS_NONE) {
#line 106 "TextButton.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 32 "../lib/Widgets/TextButton.vala"
		_tmp2_ = he_colors_to_css_class (value);
#line 32 "../lib/Widgets/TextButton.vala"
		_tmp3_ = _tmp2_;
#line 32 "../lib/Widgets/TextButton.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, _tmp3_);
#line 32 "../lib/Widgets/TextButton.vala"
		_g_free0 (_tmp3_);
#line 117 "TextButton.c"
	}
#line 34 "../lib/Widgets/TextButton.vala"
	self->priv->_color = value;
#line 30 "../lib/Widgets/TextButton.vala"
	g_object_notify_by_pspec ((GObject *) self, he_text_button_properties[HE_TEXT_BUTTON_COLOR_PROPERTY]);
#line 123 "TextButton.c"
}

/**
     * Creates a new TextButton.
     * @param label The text to display on the button.
     */
HeTextButton*
he_text_button_construct (GType object_type,
                          const gchar* label)
{
	HeTextButton * self = NULL;
#line 46 "../lib/Widgets/TextButton.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 46 "../lib/Widgets/TextButton.vala"
	self = (HeTextButton*) he_button_construct (object_type);
#line 47 "../lib/Widgets/TextButton.vala"
	gtk_button_set_label ((GtkButton*) self, label);
#line 46 "../lib/Widgets/TextButton.vala"
	return self;
#line 143 "TextButton.c"
}

HeTextButton*
he_text_button_new (const gchar* label)
{
#line 46 "../lib/Widgets/TextButton.vala"
	return he_text_button_construct (HE_TYPE_TEXT_BUTTON, label);
#line 151 "TextButton.c"
}

/**
     * Creates a new TextButton from an icon.
     * @param icon The icon to display on the button.
     *
     * @since 1.0
     */
HeTextButton*
he_text_button_construct_from_icon (GType object_type,
                                    const gchar* icon)
{
	HeTextButton * self = NULL;
#line 56 "../lib/Widgets/TextButton.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 56 "../lib/Widgets/TextButton.vala"
	self = (HeTextButton*) he_button_construct (object_type);
#line 57 "../lib/Widgets/TextButton.vala"
	he_button_set_icon ((HeButton*) self, icon);
#line 56 "../lib/Widgets/TextButton.vala"
	return self;
#line 173 "TextButton.c"
}

HeTextButton*
he_text_button_new_from_icon (const gchar* icon)
{
#line 56 "../lib/Widgets/TextButton.vala"
	return he_text_button_construct_from_icon (HE_TYPE_TEXT_BUTTON, icon);
#line 181 "TextButton.c"
}

static GObject *
he_text_button_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTextButton * self;
#line 60 "../lib/Widgets/TextButton.vala"
	parent_class = G_OBJECT_CLASS (he_text_button_parent_class);
#line 60 "../lib/Widgets/TextButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../lib/Widgets/TextButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TEXT_BUTTON, HeTextButton);
#line 61 "../lib/Widgets/TextButton.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "textual-button");
#line 60 "../lib/Widgets/TextButton.vala"
	return obj;
#line 202 "TextButton.c"
}

static void
he_text_button_class_init (HeTextButtonClass * klass,
                           gpointer klass_data)
{
#line 23 "../lib/Widgets/TextButton.vala"
	he_text_button_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/TextButton.vala"
	g_type_class_adjust_private_offset (klass, &HeTextButton_private_offset);
#line 23 "../lib/Widgets/TextButton.vala"
	HE_BUTTON_CLASS (klass)->get_color = (HeColors (*) (HeButton*)) he_text_button_real_get_color;
#line 23 "../lib/Widgets/TextButton.vala"
	HE_BUTTON_CLASS (klass)->set_color = (void (*) (HeButton*, HeColors)) he_text_button_real_set_color;
#line 23 "../lib/Widgets/TextButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_text_button_get_property;
#line 23 "../lib/Widgets/TextButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_text_button_set_property;
#line 23 "../lib/Widgets/TextButton.vala"
	G_OBJECT_CLASS (klass)->constructor = he_text_button_constructor;
#line 23 "../lib/Widgets/TextButton.vala"
	G_OBJECT_CLASS (klass)->finalize = he_text_button_finalize;
#line 225 "TextButton.c"
	/**
	     * The color of the button.
	     */
#line 23 "../lib/Widgets/TextButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TEXT_BUTTON_COLOR_PROPERTY, he_text_button_properties[HE_TEXT_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 231 "TextButton.c"
}

static void
he_text_button_instance_init (HeTextButton * self,
                              gpointer klass)
{
#line 23 "../lib/Widgets/TextButton.vala"
	self->priv = he_text_button_get_instance_private (self);
#line 240 "TextButton.c"
}

static void
he_text_button_finalize (GObject * obj)
{
	HeTextButton * self;
#line 23 "../lib/Widgets/TextButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TEXT_BUTTON, HeTextButton);
#line 23 "../lib/Widgets/TextButton.vala"
	G_OBJECT_CLASS (he_text_button_parent_class)->finalize (obj);
#line 251 "TextButton.c"
}

/**
 * A TextButton is a button that displays text. It has a transparent background.
 */
static GType
he_text_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTextButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_text_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTextButton), 0, (GInstanceInitFunc) he_text_button_instance_init, NULL };
	GType he_text_button_type_id;
	he_text_button_type_id = g_type_register_static (HE_TYPE_BUTTON, "HeTextButton", &g_define_type_info, 0);
	HeTextButton_private_offset = g_type_add_instance_private (he_text_button_type_id, sizeof (HeTextButtonPrivate));
	return he_text_button_type_id;
}

GType
he_text_button_get_type (void)
{
	static volatile gsize he_text_button_type_id__once = 0;
	if (g_once_init_enter (&he_text_button_type_id__once)) {
		GType he_text_button_type_id;
		he_text_button_type_id = he_text_button_get_type_once ();
		g_once_init_leave (&he_text_button_type_id__once, he_text_button_type_id);
	}
	return he_text_button_type_id__once;
}

static void
_vala_he_text_button_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeTextButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TEXT_BUTTON, HeTextButton);
#line 23 "../lib/Widgets/TextButton.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TextButton.vala"
		case HE_TEXT_BUTTON_COLOR_PROPERTY:
#line 23 "../lib/Widgets/TextButton.vala"
		g_value_set_enum (value, he_button_get_color ((HeButton*) self));
#line 23 "../lib/Widgets/TextButton.vala"
		break;
#line 295 "TextButton.c"
		default:
#line 23 "../lib/Widgets/TextButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TextButton.vala"
		break;
#line 301 "TextButton.c"
	}
}

static void
_vala_he_text_button_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeTextButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TEXT_BUTTON, HeTextButton);
#line 23 "../lib/Widgets/TextButton.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/TextButton.vala"
		case HE_TEXT_BUTTON_COLOR_PROPERTY:
#line 23 "../lib/Widgets/TextButton.vala"
		he_button_set_color ((HeButton*) self, g_value_get_enum (value));
#line 23 "../lib/Widgets/TextButton.vala"
		break;
#line 321 "TextButton.c"
		default:
#line 23 "../lib/Widgets/TextButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/TextButton.vala"
		break;
#line 327 "TextButton.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

