/* TimePicker.c generated by valac 0.56.14, the Vala compiler
 * generated from TimePicker.vala, do not modify */

/*
 * Copyright (c) 2022-2023 Fyra Labs
 * Copyright (c) 2014–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

enum  {
	HE_TIME_PICKER_0_PROPERTY,
	HE_TIME_PICKER_FORMAT_12_PROPERTY,
	HE_TIME_PICKER_FORMAT_24_PROPERTY,
	HE_TIME_PICKER_TIME_PROPERTY,
	HE_TIME_PICKER_NUM_PROPERTIES
};
static GParamSpec* he_time_picker_properties[HE_TIME_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	HE_TIME_PICKER_TIME_CHANGED_SIGNAL,
	HE_TIME_PICKER_NUM_SIGNALS
};
static guint he_time_picker_signals[HE_TIME_PICKER_NUM_SIGNALS] = {0};

struct _HeTimePickerPrivate {
	gchar* _format_12;
	gchar* _format_24;
	GDateTime* _time;
	gboolean changing_time;
	gchar* old_string;
	GtkBox* am_pm_box;
	GtkPopover* popover;
	GtkSpinButton* hours_spinbutton;
	GtkSpinButton* minutes_spinbutton;
	GtkToggleButton* am_togglebutton;
	GtkToggleButton* pm_togglebutton;
};

static gint HeTimePicker_private_offset;
static gpointer he_time_picker_parent_class = NULL;

static void he_time_picker_update_text (HeTimePicker* self,
                                 gboolean no_signal);
static gboolean he_time_picker_is_clock_format_12h (void);
static void he_time_picker_update_am_pm (HeTimePicker* self,
                                  gint hours);
static void he_time_picker_update_time (HeTimePicker* self,
                                 gboolean is_hour);
static void he_time_picker_on_icon_press (HeTimePicker* self,
                                   GtkEntryIconPosition position);
static void he_time_picker_is_unfocused (HeTimePicker* self);
static void he_time_picker_parse_time (HeTimePicker* self,
                                const gchar* timestr);
static gint* _int_dup (gint* self);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
static GObject * he_time_picker_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                           GtkEntryIconPosition icon_pos,
                                                           gpointer self);
static void _he_time_picker___lambda43_ (HeTimePicker* self);
static void __he_time_picker___lambda43__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                 gpointer self);
static void _he_time_picker___lambda44_ (HeTimePicker* self);
static void __he_time_picker___lambda44__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                 gpointer self);
static gboolean _he_time_picker___lambda45_ (HeTimePicker* self);
static gboolean __he_time_picker___lambda45__gtk_spin_button_output (GtkSpinButton* _sender,
                                                              gpointer self);
static void _he_time_picker___lambda46_ (HeTimePicker* self);
static void __he_time_picker___lambda46__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                    gpointer self);
static gboolean _he_time_picker___lambda47_ (HeTimePicker* self,
                                      gdouble dx,
                                      gdouble dy);
static gboolean __he_time_picker___lambda47__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                          gdouble dx,
                                                                          gdouble dy,
                                                                          gpointer self);
static void _he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                      gpointer self);
static void _he_time_picker___lambda48_ (HeTimePicker* self);
static void __he_time_picker___lambda48__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void _he_time_picker___lambda49_ (HeTimePicker* self);
static void __he_time_picker___lambda49__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void he_time_picker_finalize (GObject * obj);
static GType he_time_picker_get_type_once (void);
static void _vala_he_time_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_time_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_time_picker_get_instance_private (HeTimePicker* self)
{
	return G_STRUCT_MEMBER_P (self, HeTimePicker_private_offset);
}

const gchar*
he_time_picker_get_format_12 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 28 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
	return result;
#line 149 "TimePicker.c"
}

static void
he_time_picker_set_format_12 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 28 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 28 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_12 (self);
#line 28 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 163 "TimePicker.c"
		gchar* _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_12);
#line 28 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_12 = _tmp0_;
#line 28 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY]);
#line 173 "TimePicker.c"
	}
}

const gchar*
he_time_picker_get_format_24 (HeTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_24;
#line 33 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
	return result;
#line 190 "TimePicker.c"
}

static void
he_time_picker_set_format_24 (HeTimePicker* self,
                              const gchar* value)
{
	gchar* old_value;
#line 33 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	old_value = he_time_picker_get_format_24 (self);
#line 33 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 204 "TimePicker.c"
		gchar* _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_24);
#line 33 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_24 = _tmp0_;
#line 33 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY]);
#line 214 "TimePicker.c"
	}
}

GDateTime*
he_time_picker_get_time (HeTimePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp3_;
#line 37 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 38 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 230 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 39 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 39 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp2_);
#line 39 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp2_);
#line 241 "TimePicker.c"
	}
#line 42 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_time;
#line 42 "../lib/Widgets/TimePicker.vala"
	result = _tmp3_;
#line 42 "../lib/Widgets/TimePicker.vala"
	return result;
#line 249 "TimePicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 46 "../lib/Widgets/TimePicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 257 "TimePicker.c"
}

void
he_time_picker_set_time (HeTimePicker* self,
                         GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 46 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 46 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 46 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = _tmp0_;
#line 47 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 49 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_time;
#line 49 "../lib/Widgets/TimePicker.vala"
	if (g_date_time_get_hour (_tmp1_) >= 12) {
#line 280 "TimePicker.c"
		GtkToggleButton* _tmp2_;
#line 50 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->pm_togglebutton;
#line 50 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp2_, TRUE);
#line 286 "TimePicker.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 52 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->am_togglebutton;
#line 52 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp3_, TRUE);
#line 293 "TimePicker.c"
	}
#line 55 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 56 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 45 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY]);
#line 301 "TimePicker.c"
}

/**
    * Creates a new TimePicker widget with the given format strings.
    *
    * @param format_12 The string format of how to display the time when in 12h mode.
    * @param format_24 The string format of how to display the time when in 24h mode.
    */
HeTimePicker*
he_time_picker_construct_with_format (GType object_type,
                                      const gchar* format_12,
                                      const gchar* format_24)
{
	HeTimePicker * self = NULL;
#line 75 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_12 != NULL, NULL);
#line 75 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_24 != NULL, NULL);
#line 76 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, "format-12", format_12, "format-24", format_24, NULL);
#line 75 "../lib/Widgets/TimePicker.vala"
	return self;
#line 324 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new_with_format (const gchar* format_12,
                                const gchar* format_24)
{
#line 75 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct_with_format (HE_TYPE_TIME_PICKER, format_12, format_24);
#line 333 "TimePicker.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 352 "TimePicker.c"
}

static gboolean
he_time_picker_is_clock_format_12h (void)
{
	gchar* format = NULL;
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 202 "../lib/Widgets/TimePicker.vala"
	format = NULL;
#line 203 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
#line 203 "../lib/Widgets/TimePicker.vala"
	h24_settings = _tmp0_;
#line 204 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
#line 204 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 204 "../lib/Widgets/TimePicker.vala"
	format = _tmp1_;
#line 205 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = format;
#line 205 "../lib/Widgets/TimePicker.vala"
	result = string_contains (_tmp2_, "12h");
#line 205 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (h24_settings);
#line 205 "../lib/Widgets/TimePicker.vala"
	_g_free0 (format);
#line 205 "../lib/Widgets/TimePicker.vala"
	return result;
#line 386 "TimePicker.c"
}

static void
he_time_picker_update_am_pm (HeTimePicker* self,
                             gint hours)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 208 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 209 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 210 "../lib/Widgets/TimePicker.vala"
		return;
#line 402 "TimePicker.c"
	}
#line 213 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 213 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_date_time_add_hours (_tmp0_, hours);
#line 213 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 213 "../lib/Widgets/TimePicker.vala"
	he_time_picker_set_time (self, _tmp2_);
#line 213 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (_tmp2_);
#line 214 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 216 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, TRUE);
#line 418 "TimePicker.c"
}

static void
he_time_picker_update_time (HeTimePicker* self,
                            gboolean is_hour)
{
#line 219 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 220 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 221 "../lib/Widgets/TimePicker.vala"
		return;
#line 431 "TimePicker.c"
	}
#line 224 "../lib/Widgets/TimePicker.vala"
	if (is_hour) {
#line 435 "TimePicker.c"
		gint new_hour = 0;
		GtkSpinButton* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 225 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->hours_spinbutton;
#line 225 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 225 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 225 "../lib/Widgets/TimePicker.vala"
		new_hour = gtk_spin_button_get_value_as_int (_tmp0_) - g_date_time_get_hour (_tmp2_);
#line 227 "../lib/Widgets/TimePicker.vala"
		if (he_time_picker_is_clock_format_12h ()) {
#line 450 "TimePicker.c"
			gboolean _tmp3_ = FALSE;
			GtkSpinButton* _tmp4_;
#line 228 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = self->priv->hours_spinbutton;
#line 228 "../lib/Widgets/TimePicker.vala"
			if (gtk_spin_button_get_value_as_int (_tmp4_) == 12) {
#line 457 "TimePicker.c"
				GtkToggleButton* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 228 "../lib/Widgets/TimePicker.vala"
				_tmp5_ = self->priv->am_togglebutton;
#line 228 "../lib/Widgets/TimePicker.vala"
				_tmp6_ = gtk_toggle_button_get_active (_tmp5_);
#line 228 "../lib/Widgets/TimePicker.vala"
				_tmp7_ = _tmp6_;
#line 228 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = _tmp7_;
#line 469 "TimePicker.c"
			} else {
#line 228 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = FALSE;
#line 473 "TimePicker.c"
			}
#line 228 "../lib/Widgets/TimePicker.vala"
			_tmp3_ = TRUE;
#line 228 "../lib/Widgets/TimePicker.vala"
			if (_tmp3_) {
#line 479 "TimePicker.c"
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
				GDateTime* _tmp10_;
#line 229 "../lib/Widgets/TimePicker.vala"
				_tmp8_ = self->priv->_time;
#line 229 "../lib/Widgets/TimePicker.vala"
				_tmp9_ = self->priv->_time;
#line 229 "../lib/Widgets/TimePicker.vala"
				_tmp10_ = g_date_time_add_hours (_tmp8_, -g_date_time_get_hour (_tmp9_));
#line 229 "../lib/Widgets/TimePicker.vala"
				_g_date_time_unref0 (self->priv->_time);
#line 229 "../lib/Widgets/TimePicker.vala"
				self->priv->_time = _tmp10_;
#line 493 "TimePicker.c"
			} else {
				gboolean _tmp11_ = FALSE;
				GtkSpinButton* _tmp12_;
#line 230 "../lib/Widgets/TimePicker.vala"
				_tmp12_ = self->priv->hours_spinbutton;
#line 230 "../lib/Widgets/TimePicker.vala"
				if (gtk_spin_button_get_value_as_int (_tmp12_) < 12) {
#line 501 "TimePicker.c"
					GtkToggleButton* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 230 "../lib/Widgets/TimePicker.vala"
					_tmp13_ = self->priv->am_togglebutton;
#line 230 "../lib/Widgets/TimePicker.vala"
					_tmp14_ = gtk_toggle_button_get_active (_tmp13_);
#line 230 "../lib/Widgets/TimePicker.vala"
					_tmp15_ = _tmp14_;
#line 230 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = _tmp15_;
#line 513 "TimePicker.c"
				} else {
#line 230 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = FALSE;
#line 517 "TimePicker.c"
				}
#line 230 "../lib/Widgets/TimePicker.vala"
				_tmp11_ = TRUE;
#line 230 "../lib/Widgets/TimePicker.vala"
				if (_tmp11_) {
#line 523 "TimePicker.c"
					GDateTime* _tmp16_;
					GDateTime* _tmp17_;
#line 231 "../lib/Widgets/TimePicker.vala"
					_tmp16_ = self->priv->_time;
#line 231 "../lib/Widgets/TimePicker.vala"
					_tmp17_ = g_date_time_add_hours (_tmp16_, new_hour);
#line 231 "../lib/Widgets/TimePicker.vala"
					_g_date_time_unref0 (self->priv->_time);
#line 231 "../lib/Widgets/TimePicker.vala"
					self->priv->_time = _tmp17_;
#line 534 "TimePicker.c"
				} else {
					gboolean _tmp18_ = FALSE;
					GtkSpinButton* _tmp19_;
#line 232 "../lib/Widgets/TimePicker.vala"
					_tmp19_ = self->priv->hours_spinbutton;
#line 232 "../lib/Widgets/TimePicker.vala"
					if (gtk_spin_button_get_value_as_int (_tmp19_) == 12) {
#line 542 "TimePicker.c"
						GtkToggleButton* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 232 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = self->priv->pm_togglebutton;
#line 232 "../lib/Widgets/TimePicker.vala"
						_tmp21_ = gtk_toggle_button_get_active (_tmp20_);
#line 232 "../lib/Widgets/TimePicker.vala"
						_tmp22_ = _tmp21_;
#line 232 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = _tmp22_;
#line 554 "TimePicker.c"
					} else {
#line 232 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = FALSE;
#line 558 "TimePicker.c"
					}
#line 232 "../lib/Widgets/TimePicker.vala"
					_tmp18_ = TRUE;
#line 232 "../lib/Widgets/TimePicker.vala"
					if (_tmp18_) {
#line 564 "TimePicker.c"
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
#line 233 "../lib/Widgets/TimePicker.vala"
						_tmp23_ = self->priv->_time;
#line 233 "../lib/Widgets/TimePicker.vala"
						_tmp24_ = self->priv->_time;
#line 233 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = g_date_time_add_hours (_tmp23_, (-g_date_time_get_hour (_tmp24_)) + 12);
#line 233 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (self->priv->_time);
#line 233 "../lib/Widgets/TimePicker.vala"
						self->priv->_time = _tmp25_;
#line 578 "TimePicker.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GtkSpinButton* _tmp27_;
#line 234 "../lib/Widgets/TimePicker.vala"
						_tmp27_ = self->priv->hours_spinbutton;
#line 234 "../lib/Widgets/TimePicker.vala"
						if (gtk_spin_button_get_value_as_int (_tmp27_) < 12) {
#line 586 "TimePicker.c"
							GtkToggleButton* _tmp28_;
							gboolean _tmp29_;
							gboolean _tmp30_;
#line 234 "../lib/Widgets/TimePicker.vala"
							_tmp28_ = self->priv->pm_togglebutton;
#line 234 "../lib/Widgets/TimePicker.vala"
							_tmp29_ = gtk_toggle_button_get_active (_tmp28_);
#line 234 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = _tmp29_;
#line 234 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = _tmp30_;
#line 598 "TimePicker.c"
						} else {
#line 234 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = FALSE;
#line 602 "TimePicker.c"
						}
#line 234 "../lib/Widgets/TimePicker.vala"
						_tmp26_ = TRUE;
#line 234 "../lib/Widgets/TimePicker.vala"
						if (_tmp26_) {
#line 608 "TimePicker.c"
							GDateTime* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							GDateTime* _tmp34_;
#line 235 "../lib/Widgets/TimePicker.vala"
							_tmp31_ = self->priv->_time;
#line 235 "../lib/Widgets/TimePicker.vala"
							_tmp32_ = g_date_time_add_hours (_tmp31_, new_hour + 12);
#line 235 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (self->priv->_time);
#line 235 "../lib/Widgets/TimePicker.vala"
							self->priv->_time = _tmp32_;
#line 237 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = he_time_picker_get_time (self);
#line 237 "../lib/Widgets/TimePicker.vala"
							_tmp34_ = _tmp33_;
#line 237 "../lib/Widgets/TimePicker.vala"
							if (g_date_time_get_hour (_tmp34_) <= 12) {
#line 627 "TimePicker.c"
								GDateTime* _tmp35_;
								GDateTime* _tmp36_;
#line 238 "../lib/Widgets/TimePicker.vala"
								_tmp35_ = self->priv->_time;
#line 238 "../lib/Widgets/TimePicker.vala"
								_tmp36_ = g_date_time_add_hours (_tmp35_, 12);
#line 238 "../lib/Widgets/TimePicker.vala"
								_g_date_time_unref0 (self->priv->_time);
#line 238 "../lib/Widgets/TimePicker.vala"
								self->priv->_time = _tmp36_;
#line 638 "TimePicker.c"
							}
						}
					}
				}
			}
		} else {
			GDateTime* _tmp37_;
			GDateTime* _tmp38_;
#line 242 "../lib/Widgets/TimePicker.vala"
			_tmp37_ = self->priv->_time;
#line 242 "../lib/Widgets/TimePicker.vala"
			_tmp38_ = g_date_time_add_hours (_tmp37_, new_hour);
#line 242 "../lib/Widgets/TimePicker.vala"
			_g_date_time_unref0 (self->priv->_time);
#line 242 "../lib/Widgets/TimePicker.vala"
			self->priv->_time = _tmp38_;
#line 655 "TimePicker.c"
		}
	} else {
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GtkSpinButton* _tmp41_;
		GDateTime* _tmp42_;
		GDateTime* _tmp43_;
		GDateTime* _tmp44_;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp39_ = he_time_picker_get_time (self);
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp40_ = _tmp39_;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp41_ = self->priv->minutes_spinbutton;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp42_ = he_time_picker_get_time (self);
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = _tmp42_;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = g_date_time_add_minutes (_tmp40_, gtk_spin_button_get_value_as_int (_tmp41_) - g_date_time_get_minute (_tmp43_));
#line 245 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 245 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp44_;
#line 680 "TimePicker.c"
	}
#line 248 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 684 "TimePicker.c"
}

static void
he_time_picker_on_icon_press (HeTimePicker* self,
                              GtkEntryIconPosition position)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp27_;
	GDateTime* _tmp28_;
	GDateTime* _tmp29_;
	GtkPopover* _tmp30_;
#line 251 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 253 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 254 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 256 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 704 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 256 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = he_time_picker_get_time (self);
#line 256 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 256 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_date_time_get_hour (_tmp2_) > 12;
#line 713 "TimePicker.c"
	} else {
#line 256 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 717 "TimePicker.c"
	}
#line 256 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 721 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 257 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->hours_spinbutton;
#line 257 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = he_time_picker_get_time (self);
#line 257 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 257 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp3_, (gdouble) (g_date_time_get_hour (_tmp5_) - 12));
#line 733 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
#line 259 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = self->priv->hours_spinbutton;
#line 259 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = he_time_picker_get_time (self);
#line 259 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 259 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp6_, (gdouble) g_date_time_get_hour (_tmp8_));
#line 746 "TimePicker.c"
	}
#line 262 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 750 "TimePicker.c"
		GtkBox* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GtkSpinButton* _tmp21_;
#line 263 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = self->priv->am_pm_box;
#line 263 "../lib/Widgets/TimePicker.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 265 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = he_time_picker_get_time (self);
#line 265 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 265 "../lib/Widgets/TimePicker.vala"
		if (g_date_time_get_hour (_tmp11_) > 12) {
#line 765 "TimePicker.c"
			GtkSpinButton* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 266 "../lib/Widgets/TimePicker.vala"
			_tmp12_ = self->priv->hours_spinbutton;
#line 266 "../lib/Widgets/TimePicker.vala"
			_tmp13_ = he_time_picker_get_time (self);
#line 266 "../lib/Widgets/TimePicker.vala"
			_tmp14_ = _tmp13_;
#line 266 "../lib/Widgets/TimePicker.vala"
			gtk_spin_button_set_value (_tmp12_, (gdouble) (g_date_time_get_hour (_tmp14_) - 12));
#line 777 "TimePicker.c"
		} else {
			GDateTime* _tmp15_;
			GDateTime* _tmp16_;
#line 267 "../lib/Widgets/TimePicker.vala"
			_tmp15_ = he_time_picker_get_time (self);
#line 267 "../lib/Widgets/TimePicker.vala"
			_tmp16_ = _tmp15_;
#line 267 "../lib/Widgets/TimePicker.vala"
			if (g_date_time_get_hour (_tmp16_) == 0) {
#line 787 "TimePicker.c"
				GtkSpinButton* _tmp17_;
#line 268 "../lib/Widgets/TimePicker.vala"
				_tmp17_ = self->priv->hours_spinbutton;
#line 268 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp17_, (gdouble) 12);
#line 793 "TimePicker.c"
			} else {
				GtkSpinButton* _tmp18_;
				GDateTime* _tmp19_;
				GDateTime* _tmp20_;
#line 270 "../lib/Widgets/TimePicker.vala"
				_tmp18_ = self->priv->hours_spinbutton;
#line 270 "../lib/Widgets/TimePicker.vala"
				_tmp19_ = he_time_picker_get_time (self);
#line 270 "../lib/Widgets/TimePicker.vala"
				_tmp20_ = _tmp19_;
#line 270 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp18_, (gdouble) g_date_time_get_hour (_tmp20_));
#line 806 "TimePicker.c"
			}
		}
#line 274 "../lib/Widgets/TimePicker.vala"
		_tmp21_ = self->priv->hours_spinbutton;
#line 274 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp21_, (gdouble) 1, (gdouble) 12);
#line 813 "TimePicker.c"
	} else {
		GtkBox* _tmp22_;
		GtkSpinButton* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
		GtkSpinButton* _tmp26_;
#line 276 "../lib/Widgets/TimePicker.vala"
		_tmp22_ = self->priv->am_pm_box;
#line 276 "../lib/Widgets/TimePicker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp22_);
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp23_ = self->priv->hours_spinbutton;
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp24_ = he_time_picker_get_time (self);
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp25_ = _tmp24_;
#line 277 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp23_, (gdouble) g_date_time_get_hour (_tmp25_));
#line 279 "../lib/Widgets/TimePicker.vala"
		_tmp26_ = self->priv->hours_spinbutton;
#line 279 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp26_, (gdouble) 0, (gdouble) 23);
#line 836 "TimePicker.c"
	}
#line 282 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 282 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = he_time_picker_get_time (self);
#line 282 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = _tmp28_;
#line 282 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_value (_tmp27_, (gdouble) g_date_time_get_minute (_tmp29_));
#line 283 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 285 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = self->priv->popover;
#line 285 "../lib/Widgets/TimePicker.vala"
	gtk_popover_popup (_tmp30_);
#line 852 "TimePicker.c"
}

static void
he_time_picker_is_unfocused (HeTimePicker* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 288 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->popover;
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 289 "../lib/Widgets/TimePicker.vala"
	if (!_tmp3_) {
#line 872 "TimePicker.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = self->priv->old_string;
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) self);
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_utf8_collate (_tmp4_, _tmp6_) != 0;
#line 884 "TimePicker.c"
	} else {
#line 289 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 888 "TimePicker.c"
	}
#line 289 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 892 "TimePicker.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 290 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) self);
#line 290 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 290 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 290 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->old_string);
#line 290 "../lib/Widgets/TimePicker.vala"
		self->priv->old_string = _tmp9_;
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 291 "../lib/Widgets/TimePicker.vala"
		_tmp13_ = _tmp12_;
#line 291 "../lib/Widgets/TimePicker.vala"
		he_time_picker_parse_time (self, _tmp13_);
#line 291 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp13_);
#line 922 "TimePicker.c"
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1573 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1574 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1574 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1574 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1575 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1575 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1575 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1575 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1576 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1576 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1577 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1578 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1578 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1578 "glib-2.0.vapi"
	if (result_length1) {
#line 1578 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 971 "TimePicker.c"
	}
#line 1578 "glib-2.0.vapi"
	result = _tmp4_;
#line 1578 "glib-2.0.vapi"
	return result;
#line 977 "TimePicker.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 311 "../lib/Widgets/TimePicker.vala"
	dup = g_new0 (gint, 1);
#line 311 "../lib/Widgets/TimePicker.vala"
	memcpy (dup, self, sizeof (gint));
#line 311 "../lib/Widgets/TimePicker.vala"
	return dup;
#line 990 "TimePicker.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 311 "../lib/Widgets/TimePicker.vala"
	return self ? _int_dup (self) : NULL;
#line 998 "TimePicker.c"
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 339 "../lib/Widgets/TimePicker.vala"
	if (s1 == s2) {
#line 339 "../lib/Widgets/TimePicker.vala"
		return TRUE;
#line 1009 "TimePicker.c"
	}
#line 339 "../lib/Widgets/TimePicker.vala"
	if (s1 == NULL) {
#line 339 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1015 "TimePicker.c"
	}
#line 339 "../lib/Widgets/TimePicker.vala"
	if (s2 == NULL) {
#line 339 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 1021 "TimePicker.c"
	}
#line 339 "../lib/Widgets/TimePicker.vala"
	return (*s1) == (*s2);
#line 1025 "TimePicker.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 1052 "TimePicker.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 1058 "TimePicker.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1064 "TimePicker.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1068 "TimePicker.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1076 "TimePicker.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1080 "TimePicker.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 1092 "TimePicker.c"
}

static void
he_time_picker_parse_time (HeTimePicker* self,
                           const gchar* timestr)
{
	gchar* current = NULL;
	gchar* _tmp0_;
	gboolean is_hours = FALSE;
	gboolean is_suffix = FALSE;
	gboolean has_suffix = FALSE;
	gint* hour = NULL;
	gint* minute = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint* _tmp71_;
	gboolean _tmp96_ = FALSE;
	gint* _tmp97_;
#line 295 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 295 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (timestr != NULL);
#line 296 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 296 "../lib/Widgets/TimePicker.vala"
	current = _tmp0_;
#line 297 "../lib/Widgets/TimePicker.vala"
	is_hours = TRUE;
#line 298 "../lib/Widgets/TimePicker.vala"
	is_suffix = FALSE;
#line 299 "../lib/Widgets/TimePicker.vala"
	has_suffix = FALSE;
#line 301 "../lib/Widgets/TimePicker.vala"
	hour = NULL;
#line 302 "../lib/Widgets/TimePicker.vala"
	minute = NULL;
#line 303 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_utf8_strdown (timestr, (gssize) -1);
#line 303 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 303 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
#line 303 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = _tmp4_;
#line 303 "../lib/Widgets/TimePicker.vala"
	_tmp5__length1 = _tmp3_;
#line 303 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 1147 "TimePicker.c"
	{
		gchar* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 303 "../lib/Widgets/TimePicker.vala"
		c_collection = _tmp5_;
#line 303 "../lib/Widgets/TimePicker.vala"
		c_collection_length1 = _tmp5__length1;
#line 303 "../lib/Widgets/TimePicker.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 1159 "TimePicker.c"
			gchar c = '\0';
#line 303 "../lib/Widgets/TimePicker.vala"
			c = c_collection[c_it];
#line 1163 "TimePicker.c"
			{
#line 304 "../lib/Widgets/TimePicker.vala"
				if (g_ascii_isdigit (c)) {
#line 1167 "TimePicker.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 305 "../lib/Widgets/TimePicker.vala"
					_tmp6_ = current;
#line 305 "../lib/Widgets/TimePicker.vala"
					_tmp7_ = g_strdup_printf ("%s%c", _tmp6_, (gint) c);
#line 305 "../lib/Widgets/TimePicker.vala"
					_g_free0 (current);
#line 305 "../lib/Widgets/TimePicker.vala"
					current = _tmp7_;
#line 1178 "TimePicker.c"
				} else {
					gboolean _tmp25_ = FALSE;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_;
#line 307 "../lib/Widgets/TimePicker.vala"
					if (!is_suffix) {
#line 1186 "TimePicker.c"
						const gchar* _tmp8_;
						gboolean _tmp17_ = FALSE;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gboolean _tmp20_;
#line 308 "../lib/Widgets/TimePicker.vala"
						_tmp8_ = current;
#line 308 "../lib/Widgets/TimePicker.vala"
						if (g_strcmp0 (_tmp8_, "") != 0) {
#line 309 "../lib/Widgets/TimePicker.vala"
							if (is_hours) {
#line 1198 "TimePicker.c"
								const gchar* _tmp9_;
								gint _tmp10_;
								gint* _tmp11_;
								gchar* _tmp12_;
#line 310 "../lib/Widgets/TimePicker.vala"
								is_hours = FALSE;
#line 311 "../lib/Widgets/TimePicker.vala"
								_tmp9_ = current;
#line 311 "../lib/Widgets/TimePicker.vala"
								_tmp10_ = atoi (_tmp9_);
#line 311 "../lib/Widgets/TimePicker.vala"
								_tmp11_ = __int_dup0 (&_tmp10_);
#line 311 "../lib/Widgets/TimePicker.vala"
								_g_free0 (hour);
#line 311 "../lib/Widgets/TimePicker.vala"
								hour = _tmp11_;
#line 312 "../lib/Widgets/TimePicker.vala"
								_tmp12_ = g_strdup ("");
#line 312 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 312 "../lib/Widgets/TimePicker.vala"
								current = _tmp12_;
#line 1221 "TimePicker.c"
							} else {
								const gchar* _tmp13_;
								gint _tmp14_;
								gint* _tmp15_;
								gchar* _tmp16_;
#line 314 "../lib/Widgets/TimePicker.vala"
								_tmp13_ = current;
#line 314 "../lib/Widgets/TimePicker.vala"
								_tmp14_ = atoi (_tmp13_);
#line 314 "../lib/Widgets/TimePicker.vala"
								_tmp15_ = __int_dup0 (&_tmp14_);
#line 314 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 314 "../lib/Widgets/TimePicker.vala"
								minute = _tmp15_;
#line 315 "../lib/Widgets/TimePicker.vala"
								_tmp16_ = g_strdup ("");
#line 315 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 315 "../lib/Widgets/TimePicker.vala"
								current = _tmp16_;
#line 1243 "TimePicker.c"
							}
						}
#line 319 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = g_strdup_printf ("%c", c);
#line 319 "../lib/Widgets/TimePicker.vala"
						_tmp19_ = _tmp18_;
#line 319 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = string_contains (_tmp19_, "a");
#line 319 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp19_);
#line 319 "../lib/Widgets/TimePicker.vala"
						if (_tmp20_) {
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = TRUE;
#line 1258 "TimePicker.c"
						} else {
							gchar* _tmp21_;
							gchar* _tmp22_;
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp21_ = g_strdup_printf ("%c", c);
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp22_ = _tmp21_;
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = string_contains (_tmp22_, "p");
#line 319 "../lib/Widgets/TimePicker.vala"
							_g_free0 (_tmp22_);
#line 1270 "TimePicker.c"
						}
#line 319 "../lib/Widgets/TimePicker.vala"
						if (_tmp17_) {
#line 1274 "TimePicker.c"
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 320 "../lib/Widgets/TimePicker.vala"
							is_suffix = TRUE;
#line 321 "../lib/Widgets/TimePicker.vala"
							_tmp23_ = current;
#line 321 "../lib/Widgets/TimePicker.vala"
							_tmp24_ = g_strdup_printf ("%s%c", _tmp23_, (gint) c);
#line 321 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 321 "../lib/Widgets/TimePicker.vala"
							current = _tmp24_;
#line 1287 "TimePicker.c"
						}
					}
#line 325 "../lib/Widgets/TimePicker.vala"
					_tmp26_ = g_strdup_printf ("%c", c);
#line 325 "../lib/Widgets/TimePicker.vala"
					_tmp27_ = _tmp26_;
#line 325 "../lib/Widgets/TimePicker.vala"
					_tmp28_ = string_contains (_tmp27_, "m");
#line 325 "../lib/Widgets/TimePicker.vala"
					_g_free0 (_tmp27_);
#line 325 "../lib/Widgets/TimePicker.vala"
					if (_tmp28_) {
#line 325 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = is_suffix;
#line 1302 "TimePicker.c"
					} else {
#line 325 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = FALSE;
#line 1306 "TimePicker.c"
					}
#line 325 "../lib/Widgets/TimePicker.vala"
					if (_tmp25_) {
#line 1310 "TimePicker.c"
						gint* _tmp29_;
						gboolean _tmp33_ = FALSE;
						const gchar* _tmp34_;
						gboolean _tmp50_ = FALSE;
						const gchar* _tmp51_;
						GDateTime* _tmp58_;
						GDateTime* _tmp59_;
						gint* _tmp60_;
						GDateTime* _tmp61_;
						GDateTime* _tmp62_;
						GDateTime* _tmp63_;
						GDateTime* _tmp64_;
#line 326 "../lib/Widgets/TimePicker.vala"
						_tmp29_ = hour;
#line 326 "../lib/Widgets/TimePicker.vala"
						if (_tmp29_ == NULL) {
#line 327 "../lib/Widgets/TimePicker.vala"
							c_collection = (g_free (c_collection), NULL);
#line 327 "../lib/Widgets/TimePicker.vala"
							_g_free0 (minute);
#line 327 "../lib/Widgets/TimePicker.vala"
							_g_free0 (hour);
#line 327 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 327 "../lib/Widgets/TimePicker.vala"
							return;
#line 1337 "TimePicker.c"
						} else {
							gint* _tmp30_;
#line 328 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = minute;
#line 328 "../lib/Widgets/TimePicker.vala"
							if (_tmp30_ == NULL) {
#line 1344 "TimePicker.c"
								gint _tmp31_;
								gint* _tmp32_;
#line 329 "../lib/Widgets/TimePicker.vala"
								_tmp31_ = 0;
#line 329 "../lib/Widgets/TimePicker.vala"
								_tmp32_ = __int_dup0 (&_tmp31_);
#line 329 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 329 "../lib/Widgets/TimePicker.vala"
								minute = _tmp32_;
#line 1355 "TimePicker.c"
							}
						}
#line 333 "../lib/Widgets/TimePicker.vala"
						_tmp34_ = current;
#line 333 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp34_, "a")) {
#line 333 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = TRUE;
#line 1364 "TimePicker.c"
						} else {
							gint* _tmp35_;
#line 333 "../lib/Widgets/TimePicker.vala"
							_tmp35_ = hour;
#line 333 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = (*_tmp35_) >= 12;
#line 1371 "TimePicker.c"
						}
#line 333 "../lib/Widgets/TimePicker.vala"
						if (_tmp33_) {
#line 1375 "TimePicker.c"
							GDateTime* _tmp36_;
							GDateTime* _tmp37_;
							gint* _tmp38_;
							GDateTime* _tmp39_;
							GDateTime* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp36_ = he_time_picker_get_time (self);
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp37_ = _tmp36_;
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp38_ = hour;
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp39_ = he_time_picker_get_time (self);
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp40_ = _tmp39_;
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp41_ = g_date_time_add_hours (_tmp37_, (*_tmp38_) - g_date_time_get_hour (_tmp40_));
#line 334 "../lib/Widgets/TimePicker.vala"
							_tmp42_ = _tmp41_;
#line 334 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp42_);
#line 334 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp42_);
#line 1401 "TimePicker.c"
						} else {
							GDateTime* _tmp43_;
							GDateTime* _tmp44_;
							gint* _tmp45_;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							GDateTime* _tmp48_;
							GDateTime* _tmp49_;
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp43_ = he_time_picker_get_time (self);
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp44_ = _tmp43_;
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp45_ = hour;
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp46_ = he_time_picker_get_time (self);
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp47_ = _tmp46_;
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp48_ = g_date_time_add_hours (_tmp44_, ((*_tmp45_) + 12) - g_date_time_get_hour (_tmp47_));
#line 336 "../lib/Widgets/TimePicker.vala"
							_tmp49_ = _tmp48_;
#line 336 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp49_);
#line 336 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp49_);
#line 1428 "TimePicker.c"
						}
#line 339 "../lib/Widgets/TimePicker.vala"
						_tmp51_ = current;
#line 339 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp51_, "a")) {
#line 1434 "TimePicker.c"
							gint* _tmp52_;
							gint _tmp53_;
#line 339 "../lib/Widgets/TimePicker.vala"
							_tmp52_ = hour;
#line 339 "../lib/Widgets/TimePicker.vala"
							_tmp53_ = 12;
#line 339 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = _int_equal (_tmp52_, &_tmp53_) == TRUE;
#line 1443 "TimePicker.c"
						} else {
#line 339 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = FALSE;
#line 1447 "TimePicker.c"
						}
#line 339 "../lib/Widgets/TimePicker.vala"
						if (_tmp50_) {
#line 1451 "TimePicker.c"
							GDateTime* _tmp54_;
							GDateTime* _tmp55_;
							GDateTime* _tmp56_;
							GDateTime* _tmp57_;
#line 340 "../lib/Widgets/TimePicker.vala"
							_tmp54_ = he_time_picker_get_time (self);
#line 340 "../lib/Widgets/TimePicker.vala"
							_tmp55_ = _tmp54_;
#line 340 "../lib/Widgets/TimePicker.vala"
							_tmp56_ = g_date_time_add_hours (_tmp55_, -12);
#line 340 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = _tmp56_;
#line 340 "../lib/Widgets/TimePicker.vala"
							he_time_picker_set_time (self, _tmp57_);
#line 340 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp57_);
#line 1468 "TimePicker.c"
						}
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp58_ = he_time_picker_get_time (self);
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp59_ = _tmp58_;
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp60_ = minute;
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp61_ = he_time_picker_get_time (self);
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp62_ = _tmp61_;
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp63_ = g_date_time_add_minutes (_tmp59_, (*_tmp60_) - g_date_time_get_minute (_tmp62_));
#line 343 "../lib/Widgets/TimePicker.vala"
						_tmp64_ = _tmp63_;
#line 343 "../lib/Widgets/TimePicker.vala"
						he_time_picker_set_time (self, _tmp64_);
#line 343 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (_tmp64_);
#line 344 "../lib/Widgets/TimePicker.vala"
						has_suffix = TRUE;
#line 1490 "TimePicker.c"
					}
				}
			}
		}
#line 303 "../lib/Widgets/TimePicker.vala"
		c_collection = (g_free (c_collection), NULL);
#line 1497 "TimePicker.c"
	}
#line 349 "../lib/Widgets/TimePicker.vala"
	if (is_hours == FALSE) {
#line 349 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = is_suffix == FALSE;
#line 1503 "TimePicker.c"
	} else {
#line 349 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = FALSE;
#line 1507 "TimePicker.c"
	}
#line 349 "../lib/Widgets/TimePicker.vala"
	if (_tmp66_) {
#line 1511 "TimePicker.c"
		const gchar* _tmp67_;
#line 349 "../lib/Widgets/TimePicker.vala"
		_tmp67_ = current;
#line 349 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1517 "TimePicker.c"
	} else {
#line 349 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = FALSE;
#line 1521 "TimePicker.c"
	}
#line 349 "../lib/Widgets/TimePicker.vala"
	if (_tmp65_) {
#line 1525 "TimePicker.c"
		const gchar* _tmp68_;
		gint _tmp69_;
		gint* _tmp70_;
#line 350 "../lib/Widgets/TimePicker.vala"
		_tmp68_ = current;
#line 350 "../lib/Widgets/TimePicker.vala"
		_tmp69_ = atoi (_tmp68_);
#line 350 "../lib/Widgets/TimePicker.vala"
		_tmp70_ = __int_dup0 (&_tmp69_);
#line 350 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 350 "../lib/Widgets/TimePicker.vala"
		minute = _tmp70_;
#line 1539 "TimePicker.c"
	}
#line 353 "../lib/Widgets/TimePicker.vala"
	_tmp71_ = hour;
#line 353 "../lib/Widgets/TimePicker.vala"
	if (_tmp71_ == NULL) {
#line 1545 "TimePicker.c"
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 354 "../lib/Widgets/TimePicker.vala"
		_tmp72_ = current;
#line 354 "../lib/Widgets/TimePicker.vala"
		_tmp73_ = strlen (_tmp72_);
#line 354 "../lib/Widgets/TimePicker.vala"
		_tmp74_ = _tmp73_;
#line 354 "../lib/Widgets/TimePicker.vala"
		if (_tmp74_ < 3) {
#line 1557 "TimePicker.c"
			const gchar* _tmp75_;
			gint _tmp76_;
			gint* _tmp77_;
			gint _tmp78_;
			gint* _tmp79_;
#line 355 "../lib/Widgets/TimePicker.vala"
			_tmp75_ = current;
#line 355 "../lib/Widgets/TimePicker.vala"
			_tmp76_ = atoi (_tmp75_);
#line 355 "../lib/Widgets/TimePicker.vala"
			_tmp77_ = __int_dup0 (&_tmp76_);
#line 355 "../lib/Widgets/TimePicker.vala"
			_g_free0 (hour);
#line 355 "../lib/Widgets/TimePicker.vala"
			hour = _tmp77_;
#line 356 "../lib/Widgets/TimePicker.vala"
			_tmp78_ = 0;
#line 356 "../lib/Widgets/TimePicker.vala"
			_tmp79_ = __int_dup0 (&_tmp78_);
#line 356 "../lib/Widgets/TimePicker.vala"
			_g_free0 (minute);
#line 356 "../lib/Widgets/TimePicker.vala"
			minute = _tmp79_;
#line 1581 "TimePicker.c"
		} else {
			const gchar* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 357 "../lib/Widgets/TimePicker.vala"
			_tmp80_ = current;
#line 357 "../lib/Widgets/TimePicker.vala"
			_tmp81_ = strlen (_tmp80_);
#line 357 "../lib/Widgets/TimePicker.vala"
			_tmp82_ = _tmp81_;
#line 357 "../lib/Widgets/TimePicker.vala"
			if (_tmp82_ == 4) {
#line 1594 "TimePicker.c"
				const gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gint _tmp86_;
				gint* _tmp87_;
				const gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				gint _tmp91_;
				gint* _tmp92_;
				gboolean _tmp93_ = FALSE;
				gint* _tmp94_;
#line 358 "../lib/Widgets/TimePicker.vala"
				_tmp83_ = current;
#line 358 "../lib/Widgets/TimePicker.vala"
				_tmp84_ = string_slice (_tmp83_, (glong) 0, (glong) 2);
#line 358 "../lib/Widgets/TimePicker.vala"
				_tmp85_ = _tmp84_;
#line 358 "../lib/Widgets/TimePicker.vala"
				_tmp86_ = atoi (_tmp85_);
#line 358 "../lib/Widgets/TimePicker.vala"
				_tmp87_ = __int_dup0 (&_tmp86_);
#line 358 "../lib/Widgets/TimePicker.vala"
				_g_free0 (hour);
#line 358 "../lib/Widgets/TimePicker.vala"
				hour = _tmp87_;
#line 358 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp85_);
#line 359 "../lib/Widgets/TimePicker.vala"
				_tmp88_ = current;
#line 359 "../lib/Widgets/TimePicker.vala"
				_tmp89_ = string_slice (_tmp88_, (glong) 2, (glong) 4);
#line 359 "../lib/Widgets/TimePicker.vala"
				_tmp90_ = _tmp89_;
#line 359 "../lib/Widgets/TimePicker.vala"
				_tmp91_ = atoi (_tmp90_);
#line 359 "../lib/Widgets/TimePicker.vala"
				_tmp92_ = __int_dup0 (&_tmp91_);
#line 359 "../lib/Widgets/TimePicker.vala"
				_g_free0 (minute);
#line 359 "../lib/Widgets/TimePicker.vala"
				minute = _tmp92_;
#line 359 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp90_);
#line 360 "../lib/Widgets/TimePicker.vala"
				_tmp94_ = hour;
#line 360 "../lib/Widgets/TimePicker.vala"
				if ((*_tmp94_) > 23) {
#line 360 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = TRUE;
#line 1645 "TimePicker.c"
				} else {
					gint* _tmp95_;
#line 360 "../lib/Widgets/TimePicker.vala"
					_tmp95_ = minute;
#line 360 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = (*_tmp95_) > 59;
#line 1652 "TimePicker.c"
				}
#line 360 "../lib/Widgets/TimePicker.vala"
				if (_tmp93_) {
#line 361 "../lib/Widgets/TimePicker.vala"
					_g_free0 (hour);
#line 361 "../lib/Widgets/TimePicker.vala"
					hour = NULL;
#line 362 "../lib/Widgets/TimePicker.vala"
					_g_free0 (minute);
#line 362 "../lib/Widgets/TimePicker.vala"
					minute = NULL;
#line 1664 "TimePicker.c"
				}
			}
		}
	}
#line 367 "../lib/Widgets/TimePicker.vala"
	_tmp97_ = hour;
#line 367 "../lib/Widgets/TimePicker.vala"
	if (_tmp97_ == NULL) {
#line 367 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = TRUE;
#line 1675 "TimePicker.c"
	} else {
		gint* _tmp98_;
#line 367 "../lib/Widgets/TimePicker.vala"
		_tmp98_ = minute;
#line 367 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = _tmp98_ == NULL;
#line 1682 "TimePicker.c"
	}
#line 367 "../lib/Widgets/TimePicker.vala"
	if (_tmp96_) {
#line 368 "../lib/Widgets/TimePicker.vala"
		he_time_picker_update_text (self, FALSE);
#line 369 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 369 "../lib/Widgets/TimePicker.vala"
		_g_free0 (hour);
#line 369 "../lib/Widgets/TimePicker.vala"
		_g_free0 (current);
#line 369 "../lib/Widgets/TimePicker.vala"
		return;
#line 1696 "TimePicker.c"
	}
#line 372 "../lib/Widgets/TimePicker.vala"
	if (has_suffix == FALSE) {
#line 1700 "TimePicker.c"
		GDateTime* _tmp99_;
		GDateTime* _tmp100_;
		gint* _tmp101_;
		GDateTime* _tmp102_;
		GDateTime* _tmp103_;
		GDateTime* _tmp104_;
		GDateTime* _tmp105_;
		GDateTime* _tmp106_;
		GDateTime* _tmp107_;
		gint* _tmp108_;
		GDateTime* _tmp109_;
		GDateTime* _tmp110_;
		GDateTime* _tmp111_;
		GDateTime* _tmp112_;
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp99_ = he_time_picker_get_time (self);
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp100_ = _tmp99_;
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp101_ = hour;
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp102_ = he_time_picker_get_time (self);
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp103_ = _tmp102_;
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp104_ = g_date_time_add_hours (_tmp100_, (*_tmp101_) - g_date_time_get_hour (_tmp103_));
#line 373 "../lib/Widgets/TimePicker.vala"
		_tmp105_ = _tmp104_;
#line 373 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp105_);
#line 373 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp105_);
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp106_ = he_time_picker_get_time (self);
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp107_ = _tmp106_;
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp108_ = minute;
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp109_ = he_time_picker_get_time (self);
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp110_ = _tmp109_;
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp111_ = g_date_time_add_minutes (_tmp107_, (*_tmp108_) - g_date_time_get_minute (_tmp110_));
#line 374 "../lib/Widgets/TimePicker.vala"
		_tmp112_ = _tmp111_;
#line 374 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, _tmp112_);
#line 374 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp112_);
#line 1751 "TimePicker.c"
	}
#line 377 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 295 "../lib/Widgets/TimePicker.vala"
	_g_free0 (minute);
#line 295 "../lib/Widgets/TimePicker.vala"
	_g_free0 (hour);
#line 295 "../lib/Widgets/TimePicker.vala"
	_g_free0 (current);
#line 1761 "TimePicker.c"
}

static void
he_time_picker_update_text (HeTimePicker* self,
                            gboolean no_signal)
{
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 380 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 381 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 1775 "TimePicker.c"
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = he_time_picker_get_time (self);
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp0_;
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->_format_12;
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = g_date_time_format (_tmp1_, _tmp2_);
#line 382 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = _tmp3_;
#line 382 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp4_);
#line 382 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp4_);
#line 1795 "TimePicker.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 384 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = he_time_picker_get_time (self);
#line 384 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 384 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = self->priv->_format_24;
#line 384 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 384 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = _tmp8_;
#line 384 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp9_);
#line 384 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp9_);
#line 1816 "TimePicker.c"
	}
#line 387 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 387 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = _tmp10_;
#line 387 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 387 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 387 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp12_;
#line 389 "../lib/Widgets/TimePicker.vala"
	if (no_signal == FALSE) {
#line 390 "../lib/Widgets/TimePicker.vala"
		g_signal_emit (self, he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 1832 "TimePicker.c"
	}
}

HeTimePicker*
he_time_picker_construct (GType object_type)
{
	HeTimePicker * self = NULL;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = (HeTimePicker*) g_object_new (object_type, NULL);
#line 19 "../lib/Widgets/TimePicker.vala"
	return self;
#line 1844 "TimePicker.c"
}

HeTimePicker*
he_time_picker_new (void)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	return he_time_picker_construct (HE_TYPE_TIME_PICKER);
#line 1852 "TimePicker.c"
}

static void
_he_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                      GtkEntryIconPosition icon_pos,
                                                      gpointer self)
{
#line 91 "../lib/Widgets/TimePicker.vala"
	he_time_picker_on_icon_press ((HeTimePicker*) self, icon_pos);
#line 1862 "TimePicker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 96 "../lib/Widgets/TimePicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 1870 "TimePicker.c"
}

static void
_he_time_picker___lambda43_ (HeTimePicker* self)
{
#line 119 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, TRUE);
#line 1878 "TimePicker.c"
}

static void
__he_time_picker___lambda43__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                            gpointer self)
{
#line 119 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda43_ ((HeTimePicker*) self);
#line 1887 "TimePicker.c"
}

static void
_he_time_picker___lambda44_ (HeTimePicker* self)
{
#line 126 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_time (self, FALSE);
#line 1895 "TimePicker.c"
}

static void
__he_time_picker___lambda44__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                            gpointer self)
{
#line 126 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda44_ ((HeTimePicker*) self);
#line 1904 "TimePicker.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 1935 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda45_ (HeTimePicker* self)
{
	gdouble val = 0.0;
	GtkSpinButton* _tmp0_;
	gboolean result;
#line 129 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->minutes_spinbutton;
#line 129 "../lib/Widgets/TimePicker.vala"
	val = gtk_spin_button_get_value (_tmp0_);
#line 130 "../lib/Widgets/TimePicker.vala"
	if (val < ((gdouble) 10)) {
#line 1950 "TimePicker.c"
		GtkSpinButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 131 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->minutes_spinbutton;
#line 131 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = double_to_string (val);
#line 131 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = _tmp2_;
#line 131 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strconcat ("0", _tmp3_, NULL);
#line 131 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 131 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp1_, _tmp5_);
#line 131 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 131 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp3_);
#line 132 "../lib/Widgets/TimePicker.vala"
		result = TRUE;
#line 132 "../lib/Widgets/TimePicker.vala"
		return result;
#line 1976 "TimePicker.c"
	}
#line 135 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 135 "../lib/Widgets/TimePicker.vala"
	return result;
#line 1982 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda45__gtk_spin_button_output (GtkSpinButton* _sender,
                                                     gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda45_ ((HeTimePicker*) self);
#line 128 "../lib/Widgets/TimePicker.vala"
	return result;
#line 1993 "TimePicker.c"
}

static void
_he_time_picker___lambda46_ (HeTimePicker* self)
{
#line 171 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused (self);
#line 2001 "TimePicker.c"
}

static void
__he_time_picker___lambda46__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                               gpointer self)
{
#line 170 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda46_ ((HeTimePicker*) self);
#line 2010 "TimePicker.c"
}

static gboolean
_he_time_picker___lambda47_ (HeTimePicker* self,
                             gdouble dx,
                             gdouble dy)
{
	gdouble _tmp0_ = 0.0;
	gdouble largest = 0.0;
	gboolean result;
#line 175 "../lib/Widgets/TimePicker.vala"
	if (fabs (dx) > fabs (dy)) {
#line 175 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dx;
#line 2025 "TimePicker.c"
	} else {
#line 175 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dy;
#line 2029 "TimePicker.c"
	}
#line 175 "../lib/Widgets/TimePicker.vala"
	largest = _tmp0_;
#line 176 "../lib/Widgets/TimePicker.vala"
	if (largest < ((gdouble) 0)) {
#line 2035 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 177 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_time;
#line 177 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = g_date_time_add_minutes (_tmp1_, 1);
#line 177 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 177 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp2_;
#line 2046 "TimePicker.c"
	} else {
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 179 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_time;
#line 179 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_date_time_add_minutes (_tmp3_, -1);
#line 179 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 179 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp4_;
#line 2058 "TimePicker.c"
	}
#line 182 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 183 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 183 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2066 "TimePicker.c"
}

static gboolean
__he_time_picker___lambda47__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                 gdouble dx,
                                                                 gdouble dy,
                                                                 gpointer self)
{
	gboolean result;
	result = _he_time_picker___lambda47_ ((HeTimePicker*) self, dx, dy);
#line 174 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2079 "TimePicker.c"
}

static void
_he_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                 gpointer self)
{
#line 186 "../lib/Widgets/TimePicker.vala"
	he_time_picker_is_unfocused ((HeTimePicker*) self);
#line 2088 "TimePicker.c"
}

static void
_he_time_picker___lambda48_ (HeTimePicker* self)
{
#line 189 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, -12);
#line 2096 "TimePicker.c"
}

static void
__he_time_picker___lambda48__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 188 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda48_ ((HeTimePicker*) self);
#line 2105 "TimePicker.c"
}

static void
_he_time_picker___lambda49_ (HeTimePicker* self)
{
#line 193 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_am_pm (self, 12);
#line 2113 "TimePicker.c"
}

static void
__he_time_picker___lambda49__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 192 "../lib/Widgets/TimePicker.vala"
	_he_time_picker___lambda49_ ((HeTimePicker*) self);
#line 2122 "TimePicker.c"
}

static GObject *
he_time_picker_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTimePicker * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GThemedIcon* _tmp4_;
	GThemedIcon* _tmp5_;
	GtkToggleButton* _tmp6_ = NULL;
	GtkToggleButton* _tmp7_;
	GtkToggleButton* _tmp8_;
	GtkToggleButton* _tmp9_ = NULL;
	GtkBox* _tmp10_ = NULL;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkBox* _tmp14_;
	GtkToggleButton* _tmp15_;
	GtkSpinButton* _tmp18_;
	GtkSpinButton* _tmp19_;
	GtkSpinButton* _tmp20_;
	GtkSpinButton* _tmp21_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkSpinButton* _tmp25_;
	GtkSpinButton* _tmp26_;
	GtkSpinButton* _tmp27_;
	GtkSpinButton* _tmp28_;
	GtkSpinButton* _tmp29_;
	GtkLabel* separation_label = NULL;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* pop_grid = NULL;
	GtkBox* _tmp32_ = NULL;
	GtkBox* _tmp33_;
	GtkSpinButton* _tmp34_;
	GtkBox* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkSpinButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkWidget* _tmp42_;
	GtkPopover* _tmp43_ = NULL;
	GtkPopover* _tmp44_;
	GtkPopover* _tmp45_;
	GtkEventControllerFocus* focus_controller = NULL;
	GtkEventControllerFocus* _tmp46_;
	GtkEventControllerScroll* scroll_controller = NULL;
	GtkEventControllerScroll* _tmp47_;
	GtkEventControllerFocus* _tmp48_;
	GtkEventController* _tmp49_;
	GtkEventControllerScroll* _tmp50_;
	GtkEventController* _tmp51_;
	GtkEventControllerFocus* _tmp52_;
	GtkEventControllerScroll* _tmp53_;
	GtkToggleButton* _tmp54_;
	GtkToggleButton* _tmp55_;
#line 79 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (he_time_picker_parent_class);
#line 79 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 79 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 80 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 80 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 81 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, _ ("%-l:%M %p"));
#line 2203 "TimePicker.c"
	}
#line 84 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_format_24;
#line 84 "../lib/Widgets/TimePicker.vala"
	if (_tmp1_ == NULL) {
#line 85 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, _ ("%H:%M"));
#line 2211 "TimePicker.c"
	}
#line 88 "../lib/Widgets/TimePicker.vala"
	gtk_entry_set_max_length ((GtkEntry*) self, 8);
#line 89 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("clock-symbolic");
#line 89 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 89 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-gicon", (GIcon*) _tmp3_, NULL);
#line 89 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp3_);
#line 90 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("pan-down-symbolic");
#line 90 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = _tmp4_;
#line 90 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp5_, NULL);
#line 90 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp5_);
#line 91 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) _he_time_picker_on_icon_press_gtk_entry_icon_release, self, 0);
#line 93 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("AM"));
#line 93 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp6_, TRUE);
#line 93 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp6_);
#line 93 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 93 "../lib/Widgets/TimePicker.vala"
	self->priv->am_togglebutton = _tmp6_;
#line 96 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = self->priv->am_togglebutton;
#line 96 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 96 "../lib/Widgets/TimePicker.vala"
	_tmp9_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("PM"));
#line 96 "../lib/Widgets/TimePicker.vala"
	gtk_toggle_button_set_group (_tmp9_, _tmp8_);
#line 96 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp8_);
#line 96 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp9_, TRUE);
#line 96 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp9_);
#line 96 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 96 "../lib/Widgets/TimePicker.vala"
	self->priv->pm_togglebutton = _tmp9_;
#line 101 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 101 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 101 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp10_, 16);
#line 101 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp10_);
#line 101 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 101 "../lib/Widgets/TimePicker.vala"
	self->priv->am_pm_box = _tmp10_;
#line 105 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = self->priv->am_pm_box;
#line 105 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp11_, "linked");
#line 106 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = self->priv->am_pm_box;
#line 106 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = self->priv->am_togglebutton;
#line 106 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp14_ = self->priv->am_pm_box;
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp15_ = self->priv->pm_togglebutton;
#line 107 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 109 "../lib/Widgets/TimePicker.vala"
	if (he_time_picker_is_clock_format_12h ()) {
#line 2291 "TimePicker.c"
		GtkSpinButton* _tmp16_;
#line 110 "../lib/Widgets/TimePicker.vala"
		_tmp16_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
#line 110 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp16_);
#line 110 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 110 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp16_;
#line 2301 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp17_;
#line 112 "../lib/Widgets/TimePicker.vala"
		_tmp17_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
#line 112 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp17_);
#line 112 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 112 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp17_;
#line 2312 "TimePicker.c"
	}
#line 115 "../lib/Widgets/TimePicker.vala"
	_tmp18_ = self->priv->hours_spinbutton;
#line 115 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
#line 116 "../lib/Widgets/TimePicker.vala"
	_tmp19_ = self->priv->hours_spinbutton;
#line 116 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp19_, TRUE);
#line 117 "../lib/Widgets/TimePicker.vala"
	_tmp20_ = self->priv->hours_spinbutton;
#line 117 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp20_, "display");
#line 118 "../lib/Widgets/TimePicker.vala"
	_tmp21_ = self->priv->hours_spinbutton;
#line 118 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp21_, "flat");
#line 119 "../lib/Widgets/TimePicker.vala"
	_tmp22_ = self->priv->hours_spinbutton;
#line 119 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp22_, "value-changed", (GCallback) __he_time_picker___lambda43__gtk_spin_button_value_changed, self, 0);
#line 121 "../lib/Widgets/TimePicker.vala"
	_tmp23_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 121 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp23_);
#line 121 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 121 "../lib/Widgets/TimePicker.vala"
	self->priv->minutes_spinbutton = _tmp23_;
#line 122 "../lib/Widgets/TimePicker.vala"
	_tmp24_ = self->priv->minutes_spinbutton;
#line 122 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp24_, GTK_ORIENTATION_VERTICAL);
#line 123 "../lib/Widgets/TimePicker.vala"
	_tmp25_ = self->priv->minutes_spinbutton;
#line 123 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp25_, TRUE);
#line 124 "../lib/Widgets/TimePicker.vala"
	_tmp26_ = self->priv->minutes_spinbutton;
#line 124 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, "display");
#line 125 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 125 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp27_, "flat");
#line 126 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = self->priv->minutes_spinbutton;
#line 126 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp28_, "value-changed", (GCallback) __he_time_picker___lambda44__gtk_spin_button_value_changed, self, 0);
#line 128 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 128 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp29_, "output", (GCallback) __he_time_picker___lambda45__gtk_spin_button_output, self, 0);
#line 138 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = (GtkLabel*) gtk_label_new (":");
#line 138 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp30_);
#line 138 "../lib/Widgets/TimePicker.vala"
	separation_label = _tmp30_;
#line 139 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = separation_label;
#line 139 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp31_, "display");
#line 141 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 141 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp32_, 12);
#line 141 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp32_, 12);
#line 141 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 12);
#line 141 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 12);
#line 141 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp32_);
#line 141 "../lib/Widgets/TimePicker.vala"
	pop_grid = _tmp32_;
#line 147 "../lib/Widgets/TimePicker.vala"
	_tmp33_ = pop_grid;
#line 147 "../lib/Widgets/TimePicker.vala"
	_tmp34_ = self->priv->hours_spinbutton;
#line 147 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 148 "../lib/Widgets/TimePicker.vala"
	_tmp35_ = pop_grid;
#line 148 "../lib/Widgets/TimePicker.vala"
	_tmp36_ = separation_label;
#line 148 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
#line 149 "../lib/Widgets/TimePicker.vala"
	_tmp37_ = pop_grid;
#line 149 "../lib/Widgets/TimePicker.vala"
	_tmp38_ = self->priv->minutes_spinbutton;
#line 149 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 150 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = pop_grid;
#line 150 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = self->priv->am_pm_box;
#line 150 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp39_, (GtkWidget*) _tmp40_);
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = pop_grid;
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = _g_object_ref0 ((GtkWidget*) _tmp41_);
#line 152 "../lib/Widgets/TimePicker.vala"
	_tmp43_ = (GtkPopover*) gtk_popover_new ();
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_autohide (_tmp43_, TRUE);
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_child (_tmp43_, _tmp42_);
#line 152 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp42_);
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp43_, FALSE);
#line 152 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_position (_tmp43_, GTK_POS_BOTTOM);
#line 152 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp43_);
#line 152 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 152 "../lib/Widgets/TimePicker.vala"
	self->priv->popover = _tmp43_;
#line 158 "../lib/Widgets/TimePicker.vala"
	_tmp44_ = self->priv->popover;
#line 158 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp44_, (GtkWidget*) self);
#line 159 "../lib/Widgets/TimePicker.vala"
	_tmp45_ = self->priv->popover;
#line 159 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp45_, FALSE);
#line 161 "../lib/Widgets/TimePicker.vala"
	_tmp46_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 161 "../lib/Widgets/TimePicker.vala"
	focus_controller = _tmp46_;
#line 162 "../lib/Widgets/TimePicker.vala"
	_tmp47_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 162 "../lib/Widgets/TimePicker.vala"
	scroll_controller = _tmp47_;
#line 167 "../lib/Widgets/TimePicker.vala"
	_tmp48_ = focus_controller;
#line 167 "../lib/Widgets/TimePicker.vala"
	_tmp49_ = _g_object_ref0 ((GtkEventController*) _tmp48_);
#line 167 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp49_);
#line 168 "../lib/Widgets/TimePicker.vala"
	_tmp50_ = scroll_controller;
#line 168 "../lib/Widgets/TimePicker.vala"
	_tmp51_ = _g_object_ref0 ((GtkEventController*) _tmp50_);
#line 168 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp51_);
#line 170 "../lib/Widgets/TimePicker.vala"
	_tmp52_ = focus_controller;
#line 170 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp52_, "leave", (GCallback) __he_time_picker___lambda46__gtk_event_controller_focus_leave, self, 0);
#line 174 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = scroll_controller;
#line 174 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp53_, "scroll", (GCallback) __he_time_picker___lambda47__gtk_event_controller_scroll_scroll, self, 0);
#line 186 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) _he_time_picker_is_unfocused_gtk_entry_activate, self, 0);
#line 188 "../lib/Widgets/TimePicker.vala"
	_tmp54_ = self->priv->am_togglebutton;
#line 188 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp54_, "clicked", (GCallback) __he_time_picker___lambda48__gtk_button_clicked, self, 0);
#line 192 "../lib/Widgets/TimePicker.vala"
	_tmp55_ = self->priv->pm_togglebutton;
#line 192 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp55_, "clicked", (GCallback) __he_time_picker___lambda49__gtk_button_clicked, self, 0);
#line 196 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "text-field");
#line 198 "../lib/Widgets/TimePicker.vala"
	he_time_picker_update_text (self, FALSE);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (scroll_controller);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (focus_controller);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (separation_label);
#line 79 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 2496 "TimePicker.c"
}

static void
he_time_picker_class_init (HeTimePickerClass * klass,
                           gpointer klass_data)
{
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_parent_class = g_type_class_peek_parent (klass);
#line 19 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &HeTimePicker_private_offset);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_time_picker_get_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_time_picker_set_property;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = he_time_picker_constructor;
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = he_time_picker_finalize;
#line 2515 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 12h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_12_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_12_PROPERTY] = g_param_spec_string ("format-12", "format-12", "format-12", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2521 "TimePicker.c"
	/**
	     *  The string format of how to display the time when in 24h mode.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_FORMAT_24_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_FORMAT_24_PROPERTY] = g_param_spec_string ("format-24", "format-24", "format-24", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 19 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TIME_PICKER_TIME_PROPERTY, he_time_picker_properties[HE_TIME_PICKER_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2529 "TimePicker.c"
	/**
	     *  The signal when time is changed with this widget.
	     */
#line 19 "../lib/Widgets/TimePicker.vala"
	he_time_picker_signals[HE_TIME_PICKER_TIME_CHANGED_SIGNAL] = g_signal_new ("time-changed", HE_TYPE_TIME_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2535 "TimePicker.c"
}

static void
he_time_picker_instance_init (HeTimePicker * self,
                              gpointer klass)
{
	gchar* _tmp0_;
#line 19 "../lib/Widgets/TimePicker.vala"
	self->priv = he_time_picker_get_instance_private (self);
#line 35 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = NULL;
#line 60 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 61 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 61 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp0_;
#line 2553 "TimePicker.c"
}

static void
he_time_picker_finalize (GObject * obj)
{
	HeTimePicker * self;
#line 19 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 28 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_12);
#line 33 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_24);
#line 35 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 61 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 62 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 63 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 64 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->hours_spinbutton);
#line 65 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 66 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 67 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 19 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (he_time_picker_parent_class)->finalize (obj);
#line 2584 "TimePicker.c"
}

static GType
he_time_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTimePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_time_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTimePicker), 0, (GInstanceInitFunc) he_time_picker_instance_init, NULL };
	GType he_time_picker_type_id;
	he_time_picker_type_id = g_type_register_static (gtk_entry_get_type (), "HeTimePicker", &g_define_type_info, 0);
	HeTimePicker_private_offset = g_type_add_instance_private (he_time_picker_type_id, sizeof (HeTimePickerPrivate));
	return he_time_picker_type_id;
}

GType
he_time_picker_get_type (void)
{
	static volatile gsize he_time_picker_type_id__once = 0;
	if (g_once_init_enter (&he_time_picker_type_id__once)) {
		GType he_time_picker_type_id;
		he_time_picker_type_id = he_time_picker_get_type_once ();
		g_once_init_leave (&he_time_picker_type_id__once, he_time_picker_type_id);
	}
	return he_time_picker_type_id__once;
}

static void
_vala_he_time_picker_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_12 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, he_time_picker_get_format_24 (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		g_value_set_boxed (value, he_time_picker_get_time (self));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 2637 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 2643 "TimePicker.c"
	}
}

static void
_vala_he_time_picker_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TIME_PICKER, HeTimePicker);
#line 19 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_12 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_format_24 (self, g_value_get_string (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 19 "../lib/Widgets/TimePicker.vala"
		case HE_TIME_PICKER_TIME_PROPERTY:
#line 19 "../lib/Widgets/TimePicker.vala"
		he_time_picker_set_time (self, g_value_get_boxed (value));
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 2675 "TimePicker.c"
		default:
#line 19 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../lib/Widgets/TimePicker.vala"
		break;
#line 2681 "TimePicker.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

