/* ViewDual.c generated by valac 0.56.14, the Vala compiler
 * generated from ViewDual.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

enum  {
	HE_VIEW_DUAL_0_PROPERTY,
	HE_VIEW_DUAL_NUM_PROPERTIES
};
static GParamSpec* he_view_dual_properties[HE_VIEW_DUAL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeViewDualPrivate {
	GtkBox* box;
	GtkBox* left_box;
	GtkBox* right_box;
};

static gint HeViewDual_private_offset;
static gpointer he_view_dual_parent_class = NULL;

static void he_view_dual_real_add_child (HeView* base,
                                  GtkBuilder* builder,
                                  GObject* child,
                                  const gchar* type);
static GObject * he_view_dual_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void he_view_dual_finalize (GObject * obj);
static GType he_view_dual_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_view_dual_get_instance_private (HeViewDual* self)
{
	return G_STRUCT_MEMBER_P (self, HeViewDual_private_offset);
}

/**
     * Adds children to either the left or right side of the view, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
     *
     * @since 1.0
     */
static void
he_view_dual_real_add_child (HeView* base,
                             GtkBuilder* builder,
                             GObject* child,
                             const gchar* type)
{
	HeViewDual * self;
#line 36 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) base;
#line 36 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (builder != NULL);
#line 36 "../lib/Widgets/ViewDual.vala"
	g_return_if_fail (child != NULL);
#line 37 "../lib/Widgets/ViewDual.vala"
	if (g_strcmp0 (type, "left") == 0) {
#line 85 "ViewDual.c"
		GtkBox* _tmp0_;
#line 38 "../lib/Widgets/ViewDual.vala"
		_tmp0_ = self->priv->left_box;
#line 38 "../lib/Widgets/ViewDual.vala"
		gtk_box_append (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 91 "ViewDual.c"
	} else {
#line 39 "../lib/Widgets/ViewDual.vala"
		if (g_strcmp0 (type, "right") == 0) {
#line 95 "ViewDual.c"
			GtkBox* _tmp1_;
#line 40 "../lib/Widgets/ViewDual.vala"
			_tmp1_ = self->priv->right_box;
#line 40 "../lib/Widgets/ViewDual.vala"
			gtk_box_append (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
#line 101 "ViewDual.c"
		} else {
#line 42 "../lib/Widgets/ViewDual.vala"
			he_view_add_child (G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_VIEW, HeView), builder, child, type);
#line 105 "ViewDual.c"
		}
	}
}

HeViewDual*
he_view_dual_construct (GType object_type)
{
	HeViewDual * self = NULL;
#line 23 "../lib/Widgets/ViewDual.vala"
	self = (HeViewDual*) he_view_construct (object_type);
#line 23 "../lib/Widgets/ViewDual.vala"
	return self;
#line 118 "ViewDual.c"
}

HeViewDual*
he_view_dual_new (void)
{
#line 23 "../lib/Widgets/ViewDual.vala"
	return he_view_dual_construct (HE_TYPE_VIEW_DUAL);
#line 126 "ViewDual.c"
}

static GObject *
he_view_dual_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeViewDual * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
#line 46 "../lib/Widgets/ViewDual.vala"
	parent_class = G_OBJECT_CLASS (he_view_dual_parent_class);
#line 46 "../lib/Widgets/ViewDual.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 46 "../lib/Widgets/ViewDual.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 47 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = self->priv->box;
#line 47 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = self->priv->left_box;
#line 47 "../lib/Widgets/ViewDual.vala"
	gtk_box_append (_tmp0_, (GtkWidget*) _tmp1_);
#line 48 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = self->priv->box;
#line 48 "../lib/Widgets/ViewDual.vala"
	_tmp3_ = self->priv->right_box;
#line 48 "../lib/Widgets/ViewDual.vala"
	gtk_box_append (_tmp2_, (GtkWidget*) _tmp3_);
#line 50 "../lib/Widgets/ViewDual.vala"
	_tmp4_ = self->priv->box;
#line 50 "../lib/Widgets/ViewDual.vala"
	he_view_add ((HeView*) self, (GtkWidget*) _tmp4_);
#line 46 "../lib/Widgets/ViewDual.vala"
	return obj;
#line 166 "ViewDual.c"
}

static void
he_view_dual_class_init (HeViewDualClass * klass,
                         gpointer klass_data)
{
#line 23 "../lib/Widgets/ViewDual.vala"
	he_view_dual_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/ViewDual.vala"
	g_type_class_adjust_private_offset (klass, &HeViewDual_private_offset);
#line 23 "../lib/Widgets/ViewDual.vala"
	((HeViewClass *) klass)->add_child = (void (*) (HeView*, GtkBuilder*, GObject*, const gchar*)) he_view_dual_real_add_child;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->constructor = he_view_dual_constructor;
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (klass)->finalize = he_view_dual_finalize;
#line 183 "ViewDual.c"
}

static void
he_view_dual_instance_init (HeViewDual * self,
                            gpointer klass)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
#line 23 "../lib/Widgets/ViewDual.vala"
	self->priv = he_view_dual_get_instance_private (self);
#line 24 "../lib/Widgets/ViewDual.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 24 "../lib/Widgets/ViewDual.vala"
	gtk_box_set_homogeneous (_tmp0_, TRUE);
#line 24 "../lib/Widgets/ViewDual.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 24 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../lib/Widgets/ViewDual.vala"
	self->priv->box = _tmp0_;
#line 28 "../lib/Widgets/ViewDual.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 28 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp1_);
#line 28 "../lib/Widgets/ViewDual.vala"
	self->priv->left_box = _tmp1_;
#line 29 "../lib/Widgets/ViewDual.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 29 "../lib/Widgets/ViewDual.vala"
	g_object_ref_sink (_tmp2_);
#line 29 "../lib/Widgets/ViewDual.vala"
	self->priv->right_box = _tmp2_;
#line 217 "ViewDual.c"
}

static void
he_view_dual_finalize (GObject * obj)
{
	HeViewDual * self;
#line 23 "../lib/Widgets/ViewDual.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_VIEW_DUAL, HeViewDual);
#line 24 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->box);
#line 28 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->left_box);
#line 29 "../lib/Widgets/ViewDual.vala"
	_g_object_unref0 (self->priv->right_box);
#line 23 "../lib/Widgets/ViewDual.vala"
	G_OBJECT_CLASS (he_view_dual_parent_class)->finalize (obj);
#line 234 "ViewDual.c"
}

/**
 * A ViewDual is a view that displays two views side by side.
 */
static GType
he_view_dual_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeViewDualClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_view_dual_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeViewDual), 0, (GInstanceInitFunc) he_view_dual_instance_init, NULL };
	GType he_view_dual_type_id;
	he_view_dual_type_id = g_type_register_static (HE_TYPE_VIEW, "HeViewDual", &g_define_type_info, 0);
	HeViewDual_private_offset = g_type_add_instance_private (he_view_dual_type_id, sizeof (HeViewDualPrivate));
	return he_view_dual_type_id;
}

GType
he_view_dual_get_type (void)
{
	static volatile gsize he_view_dual_type_id__once = 0;
	if (g_once_init_enter (&he_view_dual_type_id__once)) {
		GType he_view_dual_type_id;
		he_view_dual_type_id = he_view_dual_get_type_once ();
		g_once_init_leave (&he_view_dual_type_id__once, he_view_dual_type_id);
	}
	return he_view_dual_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

